
extends Node

var parse=null
var apptentive=null
var fuseboxx=null
var flurry=null
var p_info=null
var billing=null
var InAppStore=null
var heyzap=null
var ratings_prompt=null
var firebase=null

## LEADERBOARD CACHE
var cached_friends_ranking = {}
var cached_friends_leaderboard = {}
var cached_global_ranking = {}
var cached_global_leaderboard = {}
var isGlobalLeaderboard = false
var current_country = null

## HEYZAP ADS CACHE
var ads_cache = []

var all_ok=false
var parse_class_name
var should_start_update = false

var login_preload = preload("res://screens/main_menu/login/login_popup.scn")
var store_loading = preload("res://screens/main_menu/shop/store_loading.scn")
var retry_policy = preload("res://screens/HUD/retry_policy.scn")
var beans_reward_popup = preload("res://screens/HUD/bean_reward_popup.scn")
var current_brp_parent = null
var shop_store_loading = null
var timer = null
var products_timer = null
var iap_info = {}

var gift_preload = preload("res://screens/main_menu/gift_notification/gift_popup.scn")
var endless_levels = ["res://endless/endlessUK.gd","res://endless/endlessIN.gd","res://endless/endlessJP.gd","res://endless/endlessAUS.gd","res://endless/endlessMX.gd","res://endless/endlessUS.gd"]
var login_popup

var current_scene
var pc_store

var Config = preload("res://global/config.gd")

var country = preload("res://global/http_request.gd")

var isLoggedin = false

var app_parameters = {}

var notification_manager


var tags = {}

func merge_save(default,loaded):
	for k in default:
		if (not k in loaded):
			loaded[k]=default[k]
	
	for hat in default["hats"]:
		if not hat in loaded["hats"]:
			loaded["hats"][hat] = default["hats"][hat]
		
	return loaded

func create_pc_local():
	var file = File.new()
	if(file.file_exists("user://localstorepc.bin")):
		var err = file.open_encrypted_with_pass("user://localstorepc.bin",File.READ,"pcstore")
		if(err == 0 and p_info != null and file.is_open()):
			p_info.data = merge_save(p_info.data,file.get_var())
			update_hats()
			print("get from file",p_info.data.to_json())
		file.close()
	else:
		save_pc()
	
func save_pc():
	var file = File.new()
	var err = file.open_encrypted_with_pass("user://localstorepc.bin",File.WRITE,"pcstore")
	if(err == 0 and p_info != null):
		print("saving data in file")
		file.store_var(p_info.data)
	file.close()
			
class UIdentifier:
	var ID
	
	func _init():
		var file = File.new()
		if(file.file_exists("user://identifier.bin")):
			var err = file.open_encrypted_with_pass("user://identifier.bin",File.READ,OS.get_unique_ID())
			if(file.get_len() > 0):
				ID = file.get_as_text()
				print("getting id from file",ID)
			else:
				print("file is empty")
			file.close()
		else:
			var err = file.open_encrypted_with_pass("user://identifier.bin",File.WRITE,OS.get_unique_ID())
			var date = OS.get_date()
			var c_time = OS.get_time()
			ID = set_UID(date["year"],date["month"],date["day"],c_time["hour"],c_time["minute"],c_time["second"])
			file.store_string(ID)
			print("setting id for the first time",ID)
			file.close()
			
	func set_UID(year,month,day,hour,minute,second):
		var time = "-"+str(year)+"/"+str(month)+"/"+str(year)+"-"+str(hour)+":"+str(minute)+":"+str(second)
		return (OS.get_unique_ID() + time)
		
	func update_UID(UID):
		var file = File.new()
		var err = file.open_encrypted_with_pass("user://identifier.bin",File.WRITE,OS.get_unique_ID())
		file.store_string(UID)
		print("Updating id : ",UID)
		file.close()

class PlayerInfo:
	var Config = preload("res://global/config.gd")
	var locations = ["uk","india","japan","australia","mexico","usa"]
	var location_levels = [preload("res://locations/uk.gd"),preload("res://locations/india.gd"),preload("res://locations/japan.gd"),preload("res://locations/australia.gd"),preload("res://locations/mexico.gd"),preload("res://locations/usa.gd")]
	var data = {}
	var leaderboard = {}
	var uid = UIdentifier.new()
	var login_data = {}
	
	func _init():
		data["unique_ID"] = uid.ID
		for i in range(locations.size()):
			data[locations[i]] = {
				unlocked=false,
				level_unlocked={},
				level_completed=0,
				level_scores={}
			}
			
			leaderboard[locations[i] + "_highscore"] = 0
		
		data["uk"].unlocked=true
		data["india"].unlocked=false
		data["japan"].unlocked=false
		data["australia"].unlocked=false
		data["mexico"].unlocked=false
		data["usa"].unlocked=false
		data["game_complete"]=false
		data["what_next"]=true
		data["dead_days"]=(OS.get_date()["year"] * 365) + (OS.get_date()["month"] * 30) + OS.get_date()["day"]
		data["dead_seconds"]=(OS.get_time()["hour"] * 3600) + (OS.get_time()["minute"] * 60) + OS.get_time()["second"]
		data["red_gift"]=false
		data["plane_in_world"]=-1
		data["beans"]=0
		data["completed_game"]=0
		data["bean_rush"]=0
		data["yellow_gift"]=0
		data["yellow_gift_taken"]=0
		data["total_meters_run"]=0
		data["total_mishaps"]=0
		data["total_jump_time"]=0
		data["total_wicket_close"]=0
		data["total_rushes"]=0
		data["total_balloons"]=0
		data["total_pogos"]=0
		data["total_umbrellas"]=0
		data["sfx_enabled"]=true
		data["music_enabled"]=true
		data["push_enabled"]=true
		data["premium"]=false
	
		data["hats"]={"bowler":"price_"+str(Config.get_hat_pc("bowler")), #STATUS --> price_x,equip,equiped
				  	  "construction":"price_"+str(Config.get_hat_pc("construction")),
					  "golden":"price_"+str(Config.get_hat_pc("golden")),
					  "mexican":"price_"+str(Config.get_hat_pc("mexican")),
					  "top":"price_"+str(Config.get_hat_pc("top")),
					  "trucker":"price_"+str(Config.get_hat_pc("trucker")),
					  "sports":"price_"+str(Config.get_hat_pc("sports")),
					  "admiral":"price_"+str(Config.get_hat_pc("admiral")),
					  "beret":"price_"+str(Config.get_hat_pc("beret")),
					  "beanie":"price_"+str(Config.get_hat_pc("beanie")),
					  "boater":"price_"+str(Config.get_hat_pc("boater")),
					  "conical":"price_"+str(Config.get_hat_pc("conical")),
					  "chef":"price_"+str(Config.get_hat_pc("chef")),
					  "cowboy":"price_"+str(Config.get_hat_pc("cowboy")),
					  "crown":"price_"+str(Config.get_hat_pc("crown")),
					  "explorer":"price_"+str(Config.get_hat_pc("explorer")),
					  "fedora":"price_"+str(Config.get_hat_pc("fedora")),
					  "flat":"price_"+str(Config.get_hat_pc("flat")),
					  "fruit":"price_"+str(Config.get_hat_pc("fruit")),
					  "police":"price_"+str(Config.get_hat_pc("police")),
					  "mortar":"price_"+str(Config.get_hat_pc("mortar")),
					  "paper":"price_"+str(Config.get_hat_pc("paper")),
					  "party":"price_"+str(Config.get_hat_pc("party")),
					  "pilgrim":"price_"+str(Config.get_hat_pc("pilgrim")),
					  "propeller":"price_"+str(Config.get_hat_pc("propeller")),
					  "racoon":"price_"+str(Config.get_hat_pc("racoon")),
					  "umbrella":"price_"+str(Config.get_hat_pc("umbrella")),
					  "bucket":"price_"+str(Config.get_hat_pc("bucket")),}
	
		data["achievements"]={"golden_bean_bags":false,
							  "stars_england":false,
							  "stars_mexico":false,
							  "stars_japan":false,
							  "stars_usa":false,
							  "stars_india":false,
							  "stars_australia":false,
							  "wickett_close_shave":false,
							  "time_hot_persuit":false,
							  "time_jumping":false,
							  "mishap_madness":false,
							  "fashion":false,
							  "bean_marathon":false,
							  "social_share":false,
							  "teddy_england":false,
							  "teddy_mexico":false,
							  "teddy_japan":false,
							  "teddy_usa":false,
							  "teddy_india":false,
							  "teddy_australia":false,
							  "teddy_travelling":false,
							  "random_travel":false,
							  "random_bean_rush":false,
							  "random_angry_mobs":false,
							  "random_hot_air":false,
							  "random_umbrella":false,
							  "random_bouncing_bean":false,
							  "random_completionist":false}
		
	func save_local(parse, class_name):
		if(parse):
			parse.sync_with_localdatastore(class_name,data,true)

######### TEST !!!!


#func test_unlock_uk():
#	p_info.data["uk"]["level_completed"]=10
#	p_info.data["uk"]["level_unlocked"]={"level_01":true,"level_10":true}
#	
#func test_unlock_all():
#	for i in range(p_info.locations.size()):
#		p_info.data[p_info.locations[i]].unlocked=true
#		p_info.data[p_info.locations[i]]["level_completed"]=10
#		p_info.data[p_info.locations[i]]["level_unlocked"]={"level_01":true,"level_10":true}
#
#func test_free_beans():
#	set_beans(get_beans() + 4200)
#	pass

#########

func _ready():
	var scripID_File = File.new()
	scripID_File.open("user://scriptid.bin",File.WRITE)
	scripID_File.store_string(str(get_instance_ID()))
	scripID_File.close()
	
	add_user_signal("sync_ok")
	add_user_signal("leaderboard_ok")
	add_user_signal("ranking_ok")
	add_user_signal("watched_videoAd")
	add_user_signal("receivedGift")
	add_user_signal("user_logged_out")
	add_user_signal("user_logged_in")
	add_user_signal("purchase_successfull")
	add_user_signal("consume_successfull")
	add_user_signal("achievement_unlocked")
	add_user_signal("use_hat")
	add_user_signal("daily_cap_reached")
	add_user_signal("received_product_info")
	add_user_signal("no_connection")
	add_user_signal("leaderboard_offline")
	add_user_signal("unlocked_all")
	add_user_signal("adIsAvailable")
	add_user_signal("adIsNotAvailable")
	add_user_signal("finished_rewardedad")
	add_user_signal("rewardedad_failed")
	add_user_signal("ad_rewardWithCurrencyReceived")
	add_user_signal("hat_consumed")
	add_user_signal("buyed_megasale")
	add_user_signal("purchase_owned")

	fuseboxx = Globals.get_singleton("Fuseboxx")
	if(fuseboxx):
		fuseboxx.start_session(get_instance_ID())
		#fuseboxx.preload_adzone("d67603b")
	
	p_info = PlayerInfo.new()
	
	parse = Globals.get_singleton("Parse")
	apptentive = Globals.get_singleton("Apptentive")
	flurry = Globals.get_singleton("Flurry")
	billing = Globals.get_singleton("GodotPayments")
	InAppStore = Globals.get_singleton("InAppStore")
	ratings_prompt = Globals.get_singleton("RatingsPrompt")
	firebase = Globals.get_singleton("firebase")
	
	track_user_engagement()
	
	if(InAppStore):
		InAppStore.set_auto_finish_transaction(true)
		var _prefs = InAppStore.getNonConsumablePref()
		if(typeof(_prefs) == TYPE_DICTIONARY && _prefs.has("unlock_all")):
			if(_prefs["unlock_all"]):
				get_node("/root/globals").is_premium = true
		
		if(typeof(_prefs) == TYPE_DICTIONARY && _prefs.has("megasale")):
			if(_prefs["megasale"]):
				get_node("/root/globals").megasale_ok = true
		
	#notification_manager = Globals.get_singleton("LocalNotification")
	
	var httpThread = Thread.new()
	httpThread.start(country,'get_country',self)
	
	
	if(billing):
		billing.setPurchaseCallbackId(get_instance_ID())
		billing.setAutoConsume(false)
		billing.get_premium()
		billing.get_megasale()
	
	request_products()
	
	if (parse):
		parse.set_instance_id(get_instance_ID())
		if(OS.get_name().to_lower() == "ios"):
			parse.get_game_configuration(get_node("/root/default_params").params)
		elif(OS.get_name().to_lower() == "android"):
			parse.get_game_configuration()
		login_popup = login_preload.instance()
	else:
		create_pc_local()
		update_settings()
		
	heyzap=Globals.get_singleton("Heyzap")
	tags = {"interstitialAds":str(get_app_parameter("interstitialAd","empty")),
			"rewardedAds":str(get_app_parameter("rewardedAd","empty")),
			"videoAds":str(get_app_parameter("videoAds","empty"))}
	
	var rewarded_ads = ["endless_boost_rewarded","endless_continue_rewarded","checkpoint_beans_rewarded","story_continue_rewarded","flight_beans_rewarded","levelselect_beans_rewarded"]
	var interstitial_ads = ["app_start","endless_gameover","story_giveup","checkpoint_complete"]
	
	if(heyzap):
		heyzap.setCallbackId(get_instance_ID())
		
		for i in range(rewarded_ads.size()):
			heyzap.fetch_rewardedad(rewarded_ads[i])
		
		for i in range(interstitial_ads.size()):
			heyzap.fetch_interstitial(interstitial_ads[i])
		
		#heyzap.fetch_videoad()

############# HEYZAP AD SUPPORT

func add_to_ads_cache(tag):
	if(ads_cache.find(tag) == -1):
		ads_cache.append(tag)
	print("ADS CACHE : ", ads_cache)
	
func ad_is_in_cache(tag):
	var idx = ads_cache.find(tag)
	
	if(idx == -1):
		if(heyzap):
			heyzap.fetch_rewardedad(tag)
		return false
	else:
		return true

func show_retry(node, adFailed = false):
	var retry_instance = retry_policy.instance()
	
	if(adFailed):
		retry_instance.add_retry(node,true)
		return
	
	retry_instance.add_retry(node)

func show_heyzapad(tag):
	if(get_node("/root/globals").is_premium):
		return

	if(heyzap):
		heyzap.show_videoad(tag)
	else:
		print("heyzap not init or could not fetch video ad")
	
func show_heyzapinterstitial(tag):
	if(get_node("/root/globals").is_premium):
		return

	if(heyzap):
		heyzap.show_intestitialad(tag)

func show_rewarded_ad(tag):
	if(get_node("/root/globals").is_premium):
		return
	
	log_event("rewarded_ad_tapped",{"tag":tag})
	
	if(heyzap):
			heyzap.show_rewardedad(tag)
	else:
		print("heyzap not init or could not fetch rewarded ad")
		if(get_tree().is_paused()):
			get_tree().set_pause(false)

func isAdAvailable(ad,cap):
	if(get_node("/root/globals").is_premium):
		adIsNotAvailable(ad)
		return
	
	if(heyzap):
		heyzap.isAdAvailable(ad,cap)

func on_AdStart():
	print("CALLED ON AD START (IOS)")
	
	if(!get_tree().is_paused()):
		get_tree().set_pause(true)
	
func on_AdFinish():
	if(get_tree().is_paused()):
		get_tree().set_pause(false)
		
func on_AdAudioStarted():
	#MUTE 
	
	AudioServer.set_fx_global_volume_scale(0)
	AudioServer.set_stream_global_volume_scale(0)

func on_AdAudioFinished():
	#UNMUTE
	
	AudioServer.set_fx_global_volume_scale(1)
	AudioServer.set_stream_global_volume_scale(1)
	
func refreshAds():
	print("*************************** REFRESHING ADS ******************************")
	
	var ads =  {"endless_continue_rewarded":int(get_app_parameter("endless_continue_rewarded_cap",1)),
				"story_continue_rewarded":int(get_app_parameter("story_continue_rewarded_cap",3))}
				
	for i in range(ads.keys().size()):
		isAdAvailable(ads.keys()[i],ads[ads.keys()[i]])
		
func on_AdRewardReceived(tag):
	emit_signal("finished_rewardedad",tag)
	var idx = ads_cache.find(tag)
	
	log_event("rewarded_ad_completed",{"tag":tag})
	
	if(idx != -1):
		ads_cache.remove(idx)
		if(heyzap):
			heyzap.fetch_rewardedad(tag)
	
	refreshAds()
	
func on_AdRewardWithCurrencyReceived(tag,currency,amount):
	if(str(currency) == "beans" && int(amount)!=0):
		set_beans(get_beans() + int(amount))
		var beans_reward_popup_instance = beans_reward_popup.instance()
		beans_reward_popup_instance.add_popup(current_brp_parent)
		emit_signal("ad_rewardWithCurrencyReceived",int(amount))
		save_cloud()
		log_event("earn_virtual_currency",{"virtual_currency":"beans",
				   						   "item":tag,
				   						   "value":str(int(amount))})
	var idx = ads_cache.find(tag)
	
	log_event("rewarded_ad_completed",{"tag":tag})
	
	if(idx != -1):
		ads_cache.remove(idx)
		if(heyzap):
			heyzap.fetch_rewardedad(tag)
	
	#refreshAds()

func on_adFailed(tag):
	emit_signal("rewardedad_failed",tag)

func adIsAvailable(ad):
	print("****** ad is available : ", ad)

	emit_signal("adIsAvailable",ad)

func adIsNotAvailable(ad):
	print("****** ad is not available : ", ad)
	
	emit_signal("adIsNotAvailable",ad)

#############

##### IAPPBILLING API

#var SKU_MOCKUP = {Config.HUGE_BEAN_PACK_SKU:false,
#				  Config.BIG_BEAN_PACK_SKU:false,
#				  Config.MEDIUM_BEAN_PACK_SKU:false,
#				  Config.SMALL_BEAN_PACK_SKU:false,
#				  Config.TINY_BEAN_PACK_SKU:false,
#				  Config.BOWLER_HAT_SKU:false,
#				  Config.GOLDEN_HAT_SKU:false,
#				  Config.MEXICAN_HAT_SKU:false,
#				  Config.TOP_HAT_SKU:false,
#				  Config.TRUCKER_HAT_SKU:false,
#				  Config.SPORTS_HAT_SKU:false,
#				  Config.CONSTRUCTION_HAT_SKU:false}

func no_connection_iap():
	get_node("/root/iap_no_connection").play()

func set_premium(premium):
	if(str(premium) != "False"):
		get_node("/root/globals").is_premium = true

func set_megasale(megasale):
	if(str(megasale) != "False"):
		get_node("/root/globals").megasale_ok = true

func has_purchased(receipt, signature, sku):
	purchase_success(receipt, signature, sku)

func restore_purchase():
	if(OS.get_name().to_lower() == "android"):
		billing.requestPurchased()

	if(OS.get_name().to_lower() == "ios"):
		var result = InAppStore.restore_purchase()
		if result == OK:
			iosIAP_status_ok()
		elif result == ERR_UNAUTHORIZED:
			get_node("/root/iap_no_connection").play()

var SKU_MOCKUP = {Config.UNLOCK_ALL_SKU:false,
				  Config.MEGASALE_SKU:false,
				  Config.UNLOCK_INDIA_SKU:false,
				  Config.UNLOCK_JAPAN_SKU:false,
				  Config.UNLOCK_AUSTRALIA_SKU:false,
				  Config.UNLOCK_MEXICO_SKU:false,
				  Config.UNLOCK_US_SKU:false,
				  Config.TOP_HAT_SKU:false,
				  Config.BOWLER_HAT_SKU:false,
				  Config.GOLDEN_HAT_SKU:false,
				  Config.MEXICAN_HAT_SKU:false,
				  Config.TRUCKER_HAT_SKU:false,
				  Config.SPORTS_HAT_SKU:false,
				  Config.CONSTRUCTION_HAT_SKU:false,
				  Config.ADMIRAL_HAT_SKU:false,
				  Config.BERET_HAT_SKU:false,
				  Config.TINY_BEAN_PACK_SKU:false,
				  Config.SMALL_BEAN_PACK_SKU:false,
				  Config.MEDIUM_BEAN_PACK_SKU:false,
				  Config.BIG_BEAN_PACK_SKU:false,
				  Config.HUGE_BEAN_PACK_SKU:false,
				  Config.BEANNIE_HAT_SKU:false,
				  Config.BOATER_HAT_SKU:false,
				  Config.CONICAL_HAT_SKU:false,
				  Config.COOK_HAT_SKU:false,
				  Config.COWBOY_HAT_SKU:false,
				  Config.CROWN_HAT_SKU:false,
				  Config.EXPLORER_HAT_SKU:false,
				  Config.FEDORA_HAT_SKU:false,
				  Config.FLAT_HAT_SKU:false,
				  Config.FRUITS_HAT_SKU:false,
				  Config.LONDON_POLICE_HAT_SKU:false,
				  Config.MORTER_HAT_SKU:false,
				  Config.PAPER_HAT_SKU:false,
				  Config.PARTY_HAT_SKU:false,
				  Config.PROPELLER_HAT_SKU:false,
				  Config.RACOON_HAT_SKU:false,
				  Config.UMBRELLA_HAT_SKU:false}

func set_mockup(sku):
	if(!SKU_MOCKUP.has(sku)):
		return
		
	var keys = SKU_MOCKUP.keys()
	for i in range(keys.size()):
		if(keys[i]!=sku):
			SKU_MOCKUP[keys[i]]=false

	SKU_MOCKUP[sku]=true
	
	
func get_sku():
	var sku = null
	var keys = SKU_MOCKUP.keys()
	for i in range(keys.size()):
		if(SKU_MOCKUP[keys[i]]==true):
			sku=keys[i]
	
	if(sku == Config.UNLOCK_ALL_SKU):
		get_node("/root/globals").is_premium = true
	
	return sku
	
func gen_payload():
	var src = "abcdefghijklmnopqrstuvwxyz123456789"
	var payload = ""
	
	for i in range(37):
		if(i == 4):
			payload += "+"
		elif(i == 7):
			payload += "/"
		elif(i == 16):
			payload += "+"
		
		var idx = randi() % 6
		if(idx == 3):
			payload += src[randi() % src.length()].to_upper()
		else:
			payload += src[randi() % src.length()]
			
	return payload

func purchase(sku,transactionId):
	set_mockup(sku)
	
	if(OS.get_name().to_lower() == "android"):
		#billing.purchase("android.test.purchased",transactionId)
		print("Starting purchase for ", sku)
		billing.purchase(sku,gen_payload())
		return
	elif(OS.get_name().to_lower() == "ios"):
		if sku.find("unlock") != -1:
			sku+="_non"
			
		var result = InAppStore.purchase({"product_id":sku})
		if result == OK:
			iosIAP_status_ok()
		elif result == ERR_UNAUTHORIZED:
			get_node("/root/iap_no_connection").play()
		else:
        	print("An error ocurred with the request :", str(result))
		return
	
	if(!billing):
		emit_signal("consume_successfull",get_sku())

func iosIAP_status_ok():
	shop_store_loading = store_loading.instance()
	var root = get_tree().get_root()
	var shop_scene = root.get_child( root.get_child_count() -1 )
	if(!shop_store_loading.is_inside_tree()):
		shop_scene.add_child(shop_store_loading)
			
	timer = Timer.new()
	timer.set_wait_time(2.5)
	timer.set_one_shot(false)
	timer.connect("timeout",self,"ios_consume")
			
	if(!timer.is_inside_tree()):
		shop_scene.add_child(timer)
				
	timer.start()

func ios_consume():
	if(InAppStore.get_pending_event_count() == 0):
		return
	
	while InAppStore.get_pending_event_count() > 0:
		var event = InAppStore.pop_pending_event()
		if event.type == "purchase" || event.type == "restore":
			if event.result == "ok":
				print("Finished buying a product : ",event.product_id)
				var product_id = event.product_id
				if(product_id.find("_non",0) != -1):
					emit_signal("consume_successfull",product_id.substr(0,product_id.find("_non",0)))
					if(event.type == "restore"):
						var locations_skus = ["uk","unlock_india",
										"unlock_japan","unlock_australia",
										"unlock_mexico","unlock_us"]
						for i in range(locations_skus.size()):
							if(product_id.find(locations_skus[i],0) != -1):
								set_world_unlocked(i,true)
				elif(product_id.find("_hat") != -1):
					consume_hat(product_id)
				elif(product_id.find("megasale") != -1):
					megasale_ok()
				else:
					emit_signal("consume_successfull",product_id)
			else:
				print("An error ocurred with the request :", str(event.result))
				
	shop_store_loading.queue_free()
	timer.stop()
	timer.queue_free()

func request_products():
	if(InAppStore):
		var result = InAppStore.request_product_info(Config.IPHONE_PRODUCTS_IDS)
		if result == OK:
			var root = get_tree().get_root()
			var scene = root.get_child( root.get_child_count() -1 )
			products_timer = Timer.new()
			products_timer.set_wait_time(get_node("/root/globals").iap_localized_request_timeout)
			get_node("/root/globals").iap_localized_request_timeout += 10
			products_timer.set_one_shot(false)
			products_timer.connect("timeout",self,"products_info")
			
			if(!products_timer.is_inside_tree()):
				scene.add_child(products_timer)
				
			products_timer.start()
			
	if(billing):
		for p in Config.ANDROID_PRODUCT_IDS:
			billing.request_products(p)

func products_details(details):
	for iap in details:
		if not iap in iap_info:
			iap_info[iap] = details[iap]
			
	print("In app purchases info : ", iap_info)
	emit_signal("received_product_info")

func products_details_failed():
	if(get_node("/root/globals").iap_localized_request_timeout > 600):
		return
	
	var root = get_tree().get_root()
	var scene = root.get_child( root.get_child_count() -1 )
	products_timer = Timer.new()
	products_timer.set_wait_time(get_node("/root/globals").iap_localized_request_timeout)
	get_node("/root/globals").iap_localized_request_timeout *= 2
	products_timer.set_one_shot(true)
	products_timer.connect("timeout",self,"request_products")
	
	if(!products_timer.is_inside_tree()):
		scene.add_child(products_timer)

func products_info():
	if(InAppStore.get_pending_event_count() == 0):
		print("No event captured Retrying...")
		request_products()
		return
	
	while InAppStore.get_pending_event_count() > 0:
		var event = InAppStore.pop_pending_event()
		if event.type == "product_info":
			if event.result == "ok":
				print("IAP prices -----------> ", event.localized_prices)
				print("IAP prices size -----------> ", event.localized_prices.size())
				for i in range(event.localized_prices.size()):
					var idx = event.ids[i].find("_non")
					if(idx != -1):
						var iap_id = event.ids[i].substr(0,idx)
						iap_info[iap_id] = event.localized_prices[i]
					else:
						iap_info[event.ids[i]] = event.localized_prices[i]
					
				print("prices dictionary : ", iap_info)
					
				emit_signal("received_product_info")
				print("received products")
			else:
				print("An error ocurred with the request :", str(event.result))
				
	products_timer.stop()
	products_timer.queue_free()

func get_iap_info(iap):
	if(iap_info.has(iap)):
		return iap_info[iap]
	else:
		return null

func consume_all():
	billing.consumeUnconsumedPurchases()

func purchase_success(ticket,signature,sku):
	print("purchase was successful. Ticket : " , ticket + " - Signature : " + signature + " sku : " + sku)
	emit_signal("purchase_successfull")
	
	if(sku == Config.UNLOCK_ALL_SKU):
		print("Succesfully purchased Unlock ALL. Unlocking ...")
		unlock_all()
	elif(sku.find("hat",0) != -1):
		set_achievement_unlocked("fashion")
		consume_hat(sku)
	elif(sku == Config.MEGASALE_SKU):
		print("Succesfully purchased Megasale. Unlocking ...")
		megasale_ok()
	else:
		billing.consume(sku)
		
	if parse:
		parse.log_event(sku,ticket)

func purchase_owned(sku):
	emit_signal("purchase_owned")

func consume_success(ticket,signature,sku):
	print("consume was successful. Ticket : " , ticket + " - Signature : " + signature + " - SKU : " + 	sku)
	#if(fuseboxx):
	#	fuseboxx.register_iappPurchase(ticket,sku)
	emit_signal("consume_successfull",sku)

func no_validation_required():
	print("no validation required")
	
func purchase_fail():
	print("purchase fail")

func purchase_cancel():
	print("purchase cancel")

##### FIRBASE API
func log_event(type,params):
	if (firebase):
		firebase.log_event(type,params)
	else:
		print("Firebase not here, trying to log event : ", type)
	
func fill_login_data(params):
	for key in params.keys():
		p_info.login_data[key] = params[key]
		
	if p_info.login_data.size() == 6:
		log_event("login", p_info.login_data)
	
func set_property(property, value):
	if firebase:
		firebase.set_property(property,value)
	
func track_times_played(stage):
	var g = get_node("/root/globals")
	var mode
	var times_played  
	var world = p_info.locations[g.world_index]
	
	if g.endless_mode:
		mode = "endless"
		if !g.times_played_endless.has(world):
			g.times_played_endless[world] = 0
			
		g.times_played_endless[world] += 1
		times_played = g.times_played_endless[world]
	else:
		mode = "story"
		if !g.times_played.has(world+"_"+stage):
			var array = []
			for i in range(10):
				array.push_back(0)
			
			g.times_played[world+"_"+stage] = array
			
		g.times_played[world+"_"+stage][g.level_index] += 1
		times_played = g.times_played[world+"_"+stage][g.level_index]
	
	log_event(stage,{"country_name":p_info.locations[g.world_index],
				     "mode":mode,
				 	 "checkpoint":str(g.level_index+1),
					 "times_played":str(times_played)})

func track_user_engagement():
	var file = File.new()
	
	if !file.file_exists("user://user_engagement.bin"):
		var err = file.open_encrypted_with_pass("user://user_engagement.bin",file.WRITE, OS.get_unique_ID())
		if err != -1:
			var engagement = {"sessions":1,
							  "last_session":OS.get_date()}
			set_property("lifycyle_stage", "new_user")
			file.store_var(engagement)
			file.close()
	else:
		var err = file.open_encrypted_with_pass("user://user_engagement.bin",file.READ_WRITE, OS.get_unique_ID())
		
		if err != -1:
			var engagement = file.get_var()
			var last_session = engagement["last_session"]
			
			var last_day = (last_session["year"] * 365) + (last_session["month"] * 30) + last_session["day"]
			var curr_day = (OS.get_date()["year"] * 365) + (OS.get_date()["month"] * 30) + OS.get_date()["day"]
			
			var dif = curr_day - last_day
			
			var sessions = engagement["sessions"] + 1
			if dif <= 7:
				if sessions < 3:
					set_property("lifycyle_stage", "evaluating_user")
				else:
					set_property("lifycyle_stage", "engaged_user")
			elif dif >= 8 && dif < 30:
				set_property("lifycyle_stage", "lapsing_user")
			elif dif >= 30 && dif <= 60:
				set_property("lifycyle_stage", "disappearing_user")
				
			engagement["last_session"] = OS.get_date()
			engagement["sessions"] = sessions
			
			file.store_var(engagement)
			file.close()
			
			
##### FIRBASE API
func set_game_configuration(config):
	if(OS.get_name().to_lower() == "android"):
		var regex = RegEx.new()
		regex.compile("{.*}")
		var idx = config.length() / 4
	
		print("configuration p1 : ", config.substr(0, idx))
		print("configuration p2 : ", config.substr(idx, idx))
		print("configuration p3 : ", config.substr((idx*2), idx))
		print("configuration p4 : ", config.substr((idx*3), idx + (config.length() % 4)))		
		
		if(regex.is_valid()):
			var err = regex.find(config)
			if err == -1:
				print("Regex failed !!!")
				return
		else:
			print("invalid REGEX !!")
			return
		
		var final_string = regex.get_capture(0)
		
		final_string = final_string.replace("=","\":\"")
		final_string = final_string.replace("{","{\"")
		final_string = final_string.replace(",","\",\"")
		final_string = final_string.replace("}","\"}")
		final_string = final_string.replace(" ","")
		
		print("CONFIG : ", final_string)
		
		var d = {}
		var err = d.parse_json(final_string)
		if (err!=OK):
			print("error parsing json")
		else:
			print("success!", d)
			app_parameters = d
	elif(OS.get_name().to_lower() == "ios"):
		print("app parameters : ", config)
		app_parameters = config
	
func register_event(name,param,param_val,data):
	if(fuseboxx):
		fuseboxx.register_event(name,param,param_val,data)
		
func get_app_parameter(parameter,default = null):
	if(parameter in app_parameters && app_parameters[parameter]):
		return app_parameters[parameter]
	elif(parameter in get_node("/root/default_params").params && get_node("/root/default_params").params[parameter]):
		return get_node("/root/default_params").params[parameter]
	else:
		return default

func show_ad(id,options):
	if(fuseboxx):
		print("Current Ad zone : ", id)
		fuseboxx.show_adzone(id,options)

func get_reward(reward,value):
	emit_signal("watched_videoAd")
	
	if(reward == "beans"):
		if(OS.get_name().to_lower() == "ios"):
			self.set_beans(self.get_beans() + int(value))
		else:
			self.set_beans(self.get_beans() + value)
	elif(reward == "gift"):
		if(OS.get_name().to_lower() == "ios"):
			self.set_yellow_gift(get_yellow_gift() + int(value))
		else:
			self.set_yellow_gift(get_yellow_gift() + value)

func daily_cap_reached():
	emit_signal("daily_cap_reached")

##### APPTENTIVE API

func start_message_center():
	if(apptentive):
		apptentive.start_message_center()

func engage(event):
	if(apptentive):
		apptentive.event_engage(event)

##### PARSE API

func set_installetion_country(country):
	var _country = ""
	for i in range(country.length()):
		if(country[i] != ' '):
			_country+=country[i]
	
	if(_country == ""):
		_country = country
	
	if(parse):
		parse.channel_subscribe(_country)

func user_logged_out():
	p_info = PlayerInfo.new()
	login_popup.reset()
	isLoggedin = false
	emit_signal("user_logged_out")

func user_logged_in():
	var file = File.new()
	if(file.file_exists("user://leaderboard.bin")):
		var err = file.open_encrypted_with_pass("user://leaderboard.bin",File.READ,OS.get_unique_ID())
		
		if(err==-1):
			return
		
		parse.save_highscore("Leaderboard",file.get_var())
		file.close()
		
		var dir = Directory.new()
		dir.open("user://")
		if(dir.file_exists("user://leaderboard.bin")):
			dir.remove("user://leaderboard.bin")
			print("removed leaderboard save ...")
		
	login_popup.reset()
	isLoggedin = true
	emit_signal("user_logged_in")

func check_notification():
	if(parse):
		parse.get_notification()

func is_gift_taken(idx):
	return p_info.data["yellow_gift_taken"]&(1<<idx)
	
func set_gift_taken(idx):
	p_info.data["yellow_gift_taken"]|=(1<<idx)
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()
	

func add_gift(gift):
	if(!gift.has("type") && !gift.has("amount")):
		return
		
	print("adding gift for : ", gift["type"])
	if(gift["type"] == "beans"):
		p_info.data["beans"] += gift["amount"]
	elif(gift["type"] == "yellow_gift"):
		p_info.data["yellow_gift"] += gift["amount"]
		
	save_cloud()
	
	if(OS.get_name().to_lower() == "ios"):
		return
	
	var gift_popup = gift_preload.instance()
	gift_popup.set_pause_mode(PAUSE_MODE_PROCESS)
	var root = get_tree().get_root()
	var gift_scene = root.get_child( root.get_child_count() -1 )
	if(!gift_popup.is_inside_tree()):
		gift_popup.set_gift_text(gift["alert"])
		gift_scene.add_child(gift_popup)
		
func update_ID(new_ID):
	p_info.uid.update_UID(new_ID)
	p_info.data["unique_ID"] = new_ID

func retrieve_data():
	should_start_update = false
	initialize_sync("character_info",false)
	
func save_cloud():
	should_start_update = true
	initialize_sync("character_info",true)

func finish_sync():
	### UPDATE HATS PRICES
	update_hats()

	emit_signal("sync_ok")
	get_node("/root/globals").synced = true
	update_settings()
	login_popup.stop_loading()
	
	if(parse and isLoggedin):
		for i in range(p_info.locations.size()):
			parse.get_user_highscore(p_info.locations[i])
	else:
		var file = File.new()
		if(file.file_exists("user://leaderboard.bin")):
			var err = file.open_encrypted_with_pass("user://leaderboard.bin",File.READ,OS.get_unique_ID())
			
			if(err==-1):
				return
			
			p_info.leaderboard = file.get_var()
			file.close()

	if(login_popup.is_inside_tree()):
		current_scene.remove_child(login_popup)
	
	if((p_info.data["dead_days"] == 0 || p_info.data["dead_seconds"] == 0) && 
		!get_node("/root/globals").megasale_ok):
		p_info.data["dead_days"]=(OS.get_date()["year"] * 365) + (OS.get_date()["month"] * 30) + OS.get_date()["day"]
		p_info.data["dead_seconds"]=(OS.get_time()["hour"] * 3600) + (OS.get_time()["minute"] * 60) + OS.get_time()["second"]
		p_info.save_local(parse,"character_info")

func update_hats():
	var hats_keys = p_info.data["hats"].keys()
	for i in range(hats_keys.size()):
		var hat = hats_keys[i]
		if(p_info.data["hats"][hat].find("price") == -1):
			if(get_node("/root/globals").global_powerups.has(hat)):
				get_node("/root/globals").global_powerups[hat] = true
			#DEPRECATED
			#var updated_param = get_app_parameter(hats_keys[i]+"_hat")
			#if(updated_param!=null):
			#	p_info.data["hats"][hats_keys[i]]="price_"+str(updated_param)

func set_player_data(p_info,clearCache):
	self.p_info.data = merge_save(self.p_info.data,p_info)
	if(clearCache):
		manage_login_popup()
		login_popup.show_local_warning()
		return

	finish_sync()

func initialize_sync(class_name,isUpdate):
	parse_class_name = class_name
	if (not parse):
		print("Parse was not found")
		emit_signal("sync_ok")
		update_hats()
		get_node("/root/globals").synced = true
		return
		
	parse.begin_sync(class_name,p_info.data,isUpdate)

func subscribe(channel):
	if(parse):
		parse.channel_subscribe(channel)

func unsubscribe(channel):
	if(parse):
		parse.channel_unsubscribe(channel)

### LEADERBOARD
func set_leaderboard_score(country,score):
	p_info.leaderboard[country + "_highscore"] = score

func set_leaderboard_list(p_leaderboard):
	emit_signal("leaderboard_ok",[p_leaderboard])
	if(isGlobalLeaderboard):
		cached_global_leaderboard[current_country]=p_leaderboard
	else:
		cached_friends_leaderboard[current_country]=p_leaderboard

func leaderboard_offline():
	emit_signal("leaderboard_offline")

func set_player_ranking(ranking):
	emit_signal("ranking_ok",[ranking])
	if(isGlobalLeaderboard):
		cached_global_ranking[current_country]=ranking
	else:
		cached_friends_ranking[current_country]=ranking

func get_global_leaderboard(country):
	current_country=country
	isGlobalLeaderboard = true
	if(cached_global_leaderboard.has(country)):
		emit_signal("leaderboard_ok",[cached_global_leaderboard[country]])
	else:
		if(parse):
			parse.get_global_leaderboard(country)
	
	if(cached_global_ranking.has(country)):
		emit_signal("ranking_ok",[cached_global_ranking[country]])
	else:
		if(parse):
			parse.get_global_ranking(country)

func get_friends_leaderboard(country):
	current_country=country
	isGlobalLeaderboard = false
	if(cached_friends_leaderboard.has(country)):
		emit_signal("leaderboard_ok",[cached_friends_leaderboard[country]])
	else:
		parse.get_friends_leaderboard(country)
	
	if(cached_friends_ranking.has(country)):
		emit_signal("ranking_ok",[cached_friends_ranking[country]])
	else:
		parse.get_friends_ranking(country)

### LOGIN HELPERS
func login_dialog(alreadyConnected):
	manage_login_popup()
	if(alreadyConnected):
		login_popup.play_loading_anim()

func user_canceled_login():
	login_popup.stop_loading()

func no_connection():
	login_popup.stop_loading()
	self.emit_signal("no_connection")

func manage_login_popup():
	var root = get_tree().get_root()
	current_scene = root.get_child( root.get_child_count() -1 )
	if(!login_popup.is_inside_tree()):
		current_scene.add_child(login_popup)
	else:
		login_popup.stop_loading()
			
###### API ########

func get_max_worlds():
	return p_info.locations.size()

func set_endless_highscore(idx,score):
	p_info.leaderboard[ p_info.locations[idx] + "_highscore"]=score
	if(parse and isLoggedin):
		parse.save_highscore("Leaderboard",p_info.leaderboard)
	else:
		var file = File.new()
		if(file.file_exists("user://leaderboard.bin")):
			var err = file.open_encrypted_with_pass("user://leaderboard.bin",File.WRITE,OS.get_unique_ID())
			
			if(err==-1):
				return
			
			file.store_var(p_info.leaderboard)
			file.close()
		else:
			var err = file.open_encrypted_with_pass("user://leaderboard.bin",File.WRITE,OS.get_unique_ID())
			
			if(err==-1):
				return
			
			file.store_var(p_info.leaderboard)
			file.close()

func get_endless_highscore(idx):
	return p_info.leaderboard[ p_info.locations[idx] + "_highscore"]

func unlock_all():
	if(is_in_plane()):
		p_info.data["plane_in_world"] = -1
		p_info.data["dead_days"] = 0
		p_info.data["dead_seconds"] = 0
		plane_reset=false
	
	for idx in range(p_info.locations.size()):
			set_world_unlocked(idx,true)
	emit_signal("unlocked_all")
	get_node("/root/globals").is_premium = true
	if(billing):
		billing.save_premium()
	
	if(parse):
		save_cloud()
	else:
		save_pc()

func megasale_ok():
	set_beans(get_beans() + 10000)
	p_info.data["hats"]["golden"] = "equip"
	unlock_all()
	if(billing):
		billing.save_megasale()
	get_node("/root/globals").megasale_ok = true
	emit_signal("buyed_megasale")
	
func worlds_unlocked():
	var worlds_unlocked = 0
	
	for idx in range(p_info.locations.size()):
		if(is_world_unlocked(idx)):
			worlds_unlocked += 1
	
	if(worlds_unlocked == p_info.locations.size()):
		return true
	else:
		return false

func set_world_unlocked(idx,unlock):
	p_info.data[ p_info.locations[idx] ].unlocked=unlock
	p_info.save_local(parse,"character_info")
	
func is_world_unlocked(idx):
	return p_info.data[ p_info.locations[idx] ].unlocked

func is_world_completed(idx):
	return get_level_completed(idx)>=get_max_level(idx)

func set_world_score(idx,score):
	p_info.data[ p_info.locations[idx] ].endless_hiscore=score
	p_info.save_local(parse,"character_info")

func get_world_score(idx):
	return p_info.data[ p_info.locations[idx] ].endless_hiscore
			
func set_level_completed(world_idx,level_idx):
	p_info.data[ p_info.locations[world_idx] ].level_completed=max(level_idx,p_info.data[ p_info.locations[world_idx] ].level_completed)
	p_info.save_local(parse,"character_info")

func get_level_completed(world_idx):
	return p_info.data[ p_info.locations[world_idx] ].level_completed

func set_achievement_unlocked(achievement):
	if (p_info.data[ "achievements" ][achievement]):
		return	
	p_info.data[ "achievements" ][achievement]=true
	p_info.save_local(parse,"character_info")
	emit_signal("achievement_unlocked")
	get_node("/root/achievement").show_achievement(achievement)
	log_event("unlock_achievement",{"achievement":achievement})

func get_achievement(achievement):
	return (achievement in p_info.data[ "achievements" ]) and p_info.data[ "achievements" ][achievement]

func get_achievements():
	return p_info.data["achievements"]

func get_max_level(world_idx):
	return p_info.location_levels[ world_idx - 1 ].levels.size()
	
func get_level_path(world_idx,level_idx):
	if(level_idx >= p_info.location_levels[ world_idx ].levels.size()):
		level_idx -= 1
	
	return p_info.location_levels[ world_idx ].levels[level_idx]

func set_level_score(world_idx,level_idx,score):
	#always store if greater
	var level_str = str("level_",level_idx)
	if (level_str in p_info.data[ p_info.locations[world_idx] ].level_scores):
		score|=int(p_info.data[ p_info.locations[world_idx] ].level_scores[level_str])
		print("LEVEL SCORE : ", score)
	p_info.data[ p_info.locations[world_idx] ].level_scores[level_str]=score
	p_info.save_local(parse,"character_info")

func get_level_score(world_idx,level_idx):
	var level_str = str("level_",level_idx)
	if (level_str in p_info.data[ p_info.locations[world_idx] ].level_scores):
		return int(p_info.data[ p_info.locations[world_idx] ].level_scores[str("level_",level_idx)])
	else:
		return 0

func get_world_passing_stars(world_idx):
	return int(get_app_parameter("world_"+str(world_idx+1)+"_passing_stars",25))


func get_world_stars(world_idx):

	var levelcount=get_max_level(world_idx)
	var star_count=0

	for i in range(levelcount):
		var score = int(get_level_score(world_idx,i))
		if (score&1):
			star_count+=1
		if (score&2):
			star_count+=1
		if (score&4):
			star_count+=1

	return star_count

func set_level_unlocked(world_idx,level_idx,score):
	#always store if greater
	var level_str = str("level_",level_idx)
	p_info.data[ p_info.locations[world_idx] ].level_unlocked[level_str]=true
	p_info.save_local(parse,"character_info")

func get_level_unlocked(world_idx,level_idx):
	var level_str = str("level_",level_idx)
	if (level_str in p_info.data[ p_info.locations[world_idx] ].level_unlocked):
		return p_info.data[ p_info.locations[world_idx] ].level_unlocked[level_str]
	else:
		return false
	
func set_beans(beans):
	p_info.data["beans"]=beans
	p_info.save_local(parse,"character_info")
	
func get_beans():
	return p_info.data["beans"]
	
func set_bean_rush(bean_rush):
	p_info.data["bean_rush"]=bean_rush
	p_info.save_local(parse,"character_info")
	
func get_bean_rush():
	return p_info.data["bean_rush"]
	
func set_yellow_gift(yellow_gift):
	p_info.data["yellow_gift"]=yellow_gift
	p_info.save_local(parse,"character_info")
	
func get_yellow_gift():
	return p_info.data["yellow_gift"]

func received_gift():
	emit_signal("receivedGift")

func consume_hat(sku):
	var hat = sku.substr(0,sku.find("_hat",0))
	if(hat == "mariachi"):
		hat = "mexican"
	elif(hat == "headband"):
		hat = "sports"
	elif(hat == "gold"):
		hat = "golden"
			
	p_info.data["hats"][hat]="equip"
	if(get_node("/root/globals").global_powerups.has(hat)):
		get_node("/root/globals").global_powerups[hat] = true
	emit_signal("hat_consumed")
	p_info.save_local(parse,"character_info")
	log_event("earn_virtual_currency",{"virtual_currency":"hat",
			  						   "item":"in_app_purchase",
			  						   "value":hat})
	
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()

func set_hat(hat,val):
	if(val == "equip"):
		var keys = p_info.data["hats"].keys()
		for i in range(keys.size()):
			if(p_info.data["hats"][keys[i]] == "unequip"):
				p_info.data["hats"][keys[i]]="equip"
		p_info.data["hats"][hat] = "unequip"
	elif(val == "unequip"):
		p_info.data["hats"][hat] = "equip"
		
##### DEPRECATED
#func set_hat(hat,sku,use_iap):
#	var keys = p_info.data["hats"].keys()
#	
#	if(hat==null):
#		return null
#		
#	if(p_info.data["hats"][hat] == "equip"):
#		for i in range(keys.size()):
#			if(p_info.data["hats"][keys[i]] == "unequip"):
#				p_info.data["hats"][keys[i]]="equip"
#		p_info.data["hats"][hat]="unequip"
#		emit_signal("use_hat")
#	elif(p_info.data["hats"][hat].find("price",0) != -1):
#		var price = p_info.data["hats"][hat].substr(6,p_info.data["hats"][hat].length())
#		if(use_iap):
#			purchase(sku,"")
#		else:
#			if(int(price) <= self.get_beans()):
#				self.set_beans(self.get_beans() - int(price))
#				emit_signal("consume_successfull",sku)
#	elif(p_info.data["hats"][hat] == "unequip"):
#		p_info.data["hats"][hat]="equip"
#		emit_signal("use_hat")

#	p_info.save_local(parse,"character_info")
	
func set_gift_hat(hat):
	p_info.data["hats"][hat]="equip"
	p_info.save_local(parse,"character_info")

func get_hats():
	return p_info.data["hats"]
	
func get_current_hat():
	var keys = p_info.data["hats"].keys()
	var current_hat="no_hat"
	
	for i in range(keys.size()):
		if(p_info.data["hats"][keys[i]] == "unequip"):
			current_hat=keys[i]
	
	return current_hat

func get_hat_price(hat, sku):
	if(p_info.data["hats"][hat].find("price",0) != -1):
		if get_iap_info(sku):
			return get_iap_info(sku)
		else:
			return p_info.data["hats"][hat].substr(6,p_info.data["hats"][hat].length())
	else:
		return null

func get_hat_val(hat):
	return p_info.data["hats"][hat]

func get_continue_cost():
	return int(get_app_parameter("continue_cost",Config.LEVEL_CONTINUE_COST))	

func get_unlock_cost(world,level):
	var default_cost=Config.LEVEL_COST
	if (world<Config.CHECKPOINT_COST.size()):
		if level in Config.CHECKPOINT_COST[world]:
			default_cost=Config.CHECKPOINT_COST[world][level]
			
	var apidx=str(level)
	if (apidx.length()==1):
		apidx="0"+apidx
	var ap = "cp_"+["uk","india","japan","australia","mexico","usa"][world]+apidx
	var final_cost = int(get_app_parameter(ap,default_cost))
	
	if get_node("/root/globals").global_powerups["mexican"]:
			final_cost -= (final_cost * 
						  (int(get_app_parameter("powerup_mariachi",Config.POWERUP_MARIACHI)))
						  / 100)
			if typeof(final_cost) == TYPE_REAL:
				final_cost = int(final_cost)
	
	return final_cost
	
func get_flight_timer_cost(world):
	var ap = "timer_"+["uk","india","japan","australia","mexico","usa"][world]+"_cost"
	return int(get_app_parameter(ap,Config.AIRPLANE_COST))

func get_travel_unlock_cost():
	return 1000	

func get_endless_path(world):
	return endless_levels[world]

func set_time_megasale(year,month,day,hours,minutes,seconds):
	p_info.data["dead_days"] = (year*365) + (month*30) + day
	p_info.data["dead_seconds"] = (hours*3600) + (minutes*60) + seconds
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()

func get_plane():
	return p_info.data["plane_in_world"]

var plane_reset=false

func reset_plane():
	plane_reset=true

func has_red_gift():
	return p_info.data["red_gift"]
	
func claim_red_gift():
	p_info.data["red_gift"] = false
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()
	
func update_settings():

	if (p_info.data["music_enabled"]):
		AudioServer.set_stream_global_volume_scale(1)
	else:
		AudioServer.set_stream_global_volume_scale(0)
		
	if (p_info.data["sfx_enabled"]):
		AudioServer.set_fx_global_volume_scale(1)
	else:
		AudioServer.set_fx_global_volume_scale(0)
	
func save_settings():
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()
	
func is_in_plane():
	return p_info.data["plane_in_world"]!=-1
	
func set_plane(world):
	if (p_info.data["plane_in_world"]==world):
		return
	p_info.data["plane_in_world"] = world
	if (world==1):
		p_info.data["red_gift"] = true
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()
	#agregar save
	
func clear_plane():
	var plane = p_info.data["plane_in_world"]
	if (plane!=-1):
		if (plane<get_max_worlds()):
			set_world_unlocked(plane,true)
			subscribe("Level("+["UK","INDIA","JAPAN","AUSTRALIA","MEXICO","USA"][plane]+")")
		else:
			p_info.data["game_complete"]=true
	p_info.data["plane_in_world"] = -1
	#p_info.data["dead_days"] = 0
	#p_info.data["dead_seconds"] = 0
	plane_reset=false
	engage("world_complete")
	
	if (parse):
		p_info.save_local(parse,"character_info")	
	else:
		save_pc()
	
var DIED_SECONDS = 3600.0

var configured_DIED_SECOND=false

func get_seconds_left():
	if (not configured_DIED_SECOND):
		configured_DIED_SECOND=true
		DIED_SECONDS=int(get_app_parameter("megasale_time",Config.MEGASALE_TIME_SECS))
		
	var card_days = p_info.data["dead_days"]
	var card_secs = p_info.data["dead_seconds"]
	
	var days = (OS.get_date()["year"] * 365) + (OS.get_date()["month"] * 30) + OS.get_date()["day"]
	var secs = (OS.get_time()["hour"] * 3600) + (OS.get_time()["minute"] * 60) + OS.get_time()["second"]
	
	var daysleft = days - card_days
	var secondleft = secs - card_secs
	
	var ret = DIED_SECONDS - (secondleft + (daysleft * 86400))
	
	if (ret <= 0):
		var delay = ( 3600 * int(get_app_parameter("megasale_delay",Config.MEGASALE_DELAY))) - abs(ret)
		if(delay <= 0):
			p_info.data["dead_days"] = days
			p_info.data["dead_seconds"] = secs
			p_info.save_local(parse,"character_info")
		return -1
		
	return ret
	
func is_premiumVersion1():
	if(!p_info.data.has("premium")):
		return false
	
	return p_info.data["premium"]