extends Node

static func get_country(gstate):
	var err=0
	var http = HTTPClient.new() # Create the Client
	
	var err = http.connect("www.telize.com",80) # Connect to host/port
	assert(err==OK) # Make sure connection was OK
	
	
	while( http.get_status()==HTTPClient.STATUS_CONNECTING or http.get_status()==HTTPClient.STATUS_RESOLVING):
	    #Wait until resolved and connected
		http.poll()
		print("Connecting..")
		OS.delay_msec(500)
	
	assert( http.get_status() == HTTPClient.STATUS_CONNECTED ) # Could not connect
	
	# Some headers
	
	var headers=[
		"User-Agent: Mr Bean /1.0 (ATW)",
		"Accept: */*"
		]
	
	err = http.request(HTTPClient.METHOD_GET,"/geoip",headers) # Request a page from the site (this one was chunked..)
	
	assert( err == OK ) # Make sure all is OK
	
	while (http.get_status() == HTTPClient.STATUS_REQUESTING):
		# Keep polling until the request is going on
		http.poll()
		print("Requesting..")
		OS.delay_msec(500)
	
	assert( http.get_status() == HTTPClient.STATUS_BODY or http.get_status() == HTTPClient.STATUS_CONNECTED ) # Make sure request finished well.
	
	print("response? ",http.has_response()) # Site might not have a response.
	
	if (http.has_response()):
		var rb = RawArray() #array that will hold the data
	
		while(http.get_status()==HTTPClient.STATUS_BODY):
		    #While there is body left to be read
			http.poll()
			var chunk = http.read_response_body_chunk() # Get a chunk
			if (chunk.size()==0):
				#got nothing, wait for buffers to fill a bit
				OS.delay_usec(1000)
			else:
				rb = rb + chunk # append to read bufer
	
		print("bytes got: ",rb.size())
		var text = rb.get_string_from_ascii()
		var dic = {}
		dic.parse_json(text)
		
		if(!dic.has("country")):
			return
			
		print("response : ", dic["country"])
		
		if(gstate):
			gstate.call_deferred("set_installetion_country",dic["country"])
			
			