
extends Control

# member variables here, example:
# var a=2
# var b="textvar"
var gstate = null
var world = 0
var unlock_bean_cost=2000

var levels = ["uk","india","japan","australia","mexico","usa"]

var Config = preload("res://global/config.gd")	

var atendgame=false

var current_sku=""

var countries = ["UNITED KINGDOM","INDIA","JAPAN","AUSTRALIA","MEXICO","UNITED STATES"]

var skus = ["empty",Config.UNLOCK_INDIA_SKU,Config.UNLOCK_JAPAN_SKU,Config.UNLOCK_AUSTRALIA_SKU,Config.UNLOCK_MEXICO_SKU,Config.UNLOCK_US_SKU]

func _ready():
	# Initalization here
	#set_process(true)	
	
	gstate = get_node("/root/gamestate")
	world = gstate.get_plane()
	
	gstate.connect("consume_successfull",self,"consume_purchase")
	
	gstate.connect("adIsAvailable",self,"show_ad_btn")
	gstate.connect("adIsNotAvailable",self,"hide_ad_btn")
	gstate.connect("rewardedad_failed",self,"show_failed_popup")
	
	
	if(world < gstate.get_max_worlds()):
		get_node("PAYWALL/pines").set_frame(world)
		get_node("PAYWALL/countries").set_frame(world)
		get_node("PAYWALL/title/Label").set_text(tr("PLANE_TITLE_UU").replace("[XX]",countries[world]))
		var beans_cost = int(gstate.get_app_parameter("bean_unlock" + levels[world],3000))
		get_node("PAYWALL/buy_beans/Label").set_text(str(beans_cost))
		
		var not_enough_desc = ""
		if(world - 1 >= 0):
			not_enough_desc = tr("PLANE_NOT_ENOUGH_DESC").replace("[XX-PREV]",countries[world-1])
		else:
			not_enough_desc = tr("PLANE_NOT_ENOUGH_DESC").replace("[XX-PREV]",countries[0])
			
		not_enough_desc = not_enough_desc.replace("[XX]",countries[world])
		get_node("PAYWALL/not_enough/container/Label").set_text(not_enough_desc)
	
	var unlocked=false
	
	if (world<gstate.get_max_worlds()):
		unlocked=gstate.is_world_unlocked( world )
	else:
		unlocked=gstate.p_info.data["game_complete"]
		get_node("planeup").clear_queue()
		get_node("planeup").remove_animation("planeup")
		get_node("planeup").queue("planeup_unlocked")
		atendgame=true
		
		## FIXED ENDGAME !!
		gstate.clear_plane()
		get_node("/root/globals").change_scene("res://screens/endgame/endgame.scn")
		
		get_node("continue/Label").set_text("AP_GO_HOME")
		get_node("purchase/Label").set_text("AP_GO_HOME")
		
	if (not unlocked and gstate.get_world_stars(world) >= gstate.get_world_passing_stars(world)):
		unlocked=true
	
	update_iap_price()
		
	#if ( unlocked ):
	#	get_node("purchase").hide()
	#	get_node("continue").show()
	#else:
	#	unlock_bean_cost = gstate.get_flight_timer_cost(world)
	#	get_node ("purchase/value").set_text(str(unlock_bean_cost))
		#txt = txt.replace("XXXX",str(unlock_bean_cost))
	#	get_node ("timer/stars").set_text(str(gstate.get_world_passing_stars(world)))
		
	#get_node("sound").play("glide_loop")
	
	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		get_node("PAYWALL/title/Label").set_scale(Vector2(0.5,0.5))
		get_node("PAYWALL/title/Label").set_size(Vector2(583,218))
		#get_node("PAYWALL/unlock_all/scale/Label").set_scale(Vector2(0.7,0.7))
		#get_node("PAYWALL/unlock_all/scale/Label").set_size(Vector2(602,188))
	pass

func show_failed_popup(tag):
	if(tag=="flight_beans_rewarded"):
		gstate.show_retry(self,true)

func update_iap_price():
	if(gstate.get_plane() < skus.size()):
		var world_sku = skus[gstate.get_plane()]
		if(gstate.get_iap_info(world_sku)):
			get_node("PAYWALL/purchase_world/Label").set_text(str(gstate.get_iap_info(world_sku)))
		else:
			get_node("PAYWALL/purchase_world/Label").set_text("0.79")

func update_not_enough_dialog(btn,btn_rep,btn_out,btn_out_rep):
	get_node("PAYWALL/not_enough/container/Label").set_text(tr("AD_FREE_DESC"))
	get_node("PAYWALL/purchase_world/Label").set_text(tr("AD_FREE_BTN"))
	
	var path = get_node("PAYWALL/purchase_world").get_normal_texture().get_path()
	
	if(path.find(btn) != -1 ):
		path = path.replace(btn,btn_rep)
		var texture = load(path)
		get_node("PAYWALL/purchase_world").set_normal_texture(texture)
	
		path = get_node("PAYWALL/purchase_world").get_pressed_texture().get_path().replace(btn_out,btn_out_rep)
		texture = load(path)
		get_node("PAYWALL/purchase_world").set_pressed_texture(texture)

func show_ad_btn(ad):
	if(ad != "flight_beans_rewarded"):
		return

	update_not_enough_dialog("plane_unlock_single.png","continue_video_ad_btn.png","plane_unlock_single_out.png","continue_video_ad_btn_out.png")

func hide_ad_btn(ad):
	if(ad != "flight_beans_rewarded"):
		return

	update_not_enough_dialog("continue_video_ad_btn.png","plane_unlock_single.png","continue_video_ad_btn_out.png","plane_unlock_single_out.png")
	update_iap_price()
	
	var not_enough_desc = ""
	
	if(world - 1 >= 0):
		not_enough_desc = tr("PLANE_NOT_ENOUGH_DESC").replace("[XX-PREV]",countries[world-1])
	else:
		not_enough_desc = tr("PLANE_NOT_ENOUGH_DESC").replace("[XX-PREV]",countries[0])
			
	not_enough_desc = not_enough_desc.replace("[XX]",countries[world])
	get_node("PAYWALL/not_enough/container/Label").set_text(not_enough_desc)
	
func _process(delta):
	get_node("world").set_pos(Vector2(OS.get_screen_size().x,OS.get_screen_size().y))
	
	var c = """
	var gs = gstate
	var world = gs.get_plane()
	#assert( world != -1)
	var secsleft = int(gs.get_seconds_left())
	var txt = str(secsleft/3600,":",(secsleft/60)%60,":",secsleft%60)
	get_node("timer/time").set_text(txt)
	if (secsleft<=0):
		#	gs.clear_plane()
			get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
			set_process(false)	
			return
	"""
	pass

func _on_Button_pressed():
	pass # replace with function body


func _on_back_pressed():
	gstate.show_ad(gstate.get_app_parameter("Leave_flight_ad" + "_" + OS.get_name(),Config.get_zone("Leave_flight_ad" + "_" + OS.get_name())),{})
#	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")	
	get_node("/root/globals").change_scene("res://screens/level_map/level_select.scn")	
	if(!get_node("PAYWALL/not_enough").is_hidden()):
		get_node("PAYWALL/not_enough").hide()
	pass # replace with function body


func _on_purchase_pressed():
	
	if (gstate.get_beans() < unlock_bean_cost):
		get_node("no_beans").show()
	else:
		gstate.set_beans( gstate.get_beans() - unlock_bean_cost )
		if (world+1<gstate.get_max_worlds()):
			gstate.set_world_unlocked(world+1,true)			
		else:
			gstate.p_info.data["game_complete"]=true
		get_node("purchase").hide()
		get_node("continue").show()
						


func _on_continue_pressed():
	if (atendgame):
		get_node("/root/globals").change_scene("res://screens/endgame/endgame.scn")
	else:
		get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
	set_process(false)
	gstate.clear_plane()	
	pass # replace with function body


func _on_buy_beans_pressed():
	var current_world = levels[get_node("PAYWALL/countries").get_frame()]
	var beans_cost = int(gstate.get_app_parameter("bean_unlock" + current_world,3000))
	
	if(gstate.get_beans() >= beans_cost):
		gstate.set_beans(gstate.get_beans() - beans_cost)
		_on_continue_pressed()
	else:
		if(get_node("PAYWALL/not_enough").is_hidden()):
			get_node("PAYWALL/not_enough").show()
			gstate.isAdAvailable("flight_beans_rewarded",int(gstate.get_app_parameter("flight_beans_rewarded_cap",1)))


func _on_purchase_world_pressed():
	if(get_node("PAYWALL/purchase_world/Label").get_text() == tr("AD_FREE_BTN")):
		if(!gstate.ad_is_in_cache("flight_beans_rewarded")):
			gstate.show_retry(self)
			return
		
		gstate.show_rewarded_ad("flight_beans_rewarded")
		gstate.current_brp_parent = self
		_on_close_pressed()
		return

	if(gstate.get_plane() < skus.size()):
		print("Current sku : ", skus[gstate.get_plane()])
		current_sku = skus[gstate.get_plane()]
		gstate.purchase(skus[gstate.get_plane()],"")

func consume_purchase(sku):
	if(sku==current_sku):
		_on_continue_pressed()

func _on_unlock_all_pressed():
	get_node("/root/unlock_popup").show_popup()


func _on_close_pressed():
	if(!get_node("PAYWALL/not_enough").is_hidden()):
		get_node("PAYWALL/not_enough").hide()
		hide_ad_btn("flight_beans_rewarded")