\
extends CanvasLayer

# member variables here, example:
# var a=2
# var b="textvar"

var gs
var hud_pause_btn = null

func _init():
	add_user_signal("endless_swap")

func game_over(distance):
	print("GAME OVER!")
	gs.isAdAvailable("endless_continue_rewarded",int(gs.get_app_parameter("endless_continue_rewarded_cap",1)))
	get_tree().set_pause(true)
	var world = get_node("/root/globals").world_index
	get_node("gameover/bg/distance_value").set_text(str(int(distance)))
	var hs = gs.get_endless_highscore(world)
	get_node("anim").play("appear")
	if (hs < distance):
		hs=distance
		gs.set_endless_highscore(world,int(distance))
		get_node("anim").queue("new_record")
	get_node("gameover/bg/record_value").set_text(str(int(hs)))
	
	gs.get_global_leaderboard( gs.p_info.locations[world] )
	

func _endless_change():
	emit_signal("endless_swap")
	
func do_swap():
	get_node("anim").play("fade")

func set_world_record(list):
	if(list.size() == 0):
		print("something went wrong")
		return
	elif(list[0].size()==0):
		print("No record found")
		return
	
	get_node("gameover/bg/world_value").set_text(str(list[0][0][1]))

func _ready():
	# Initialization here
	
	gs = get_node("/root/gamestate")
	
	add_user_signal("continue")
	add_user_signal("do_bean_rush")
	add_user_signal("update_bean_rush")
		
	gs.connect("adIsAvailable",self,"show_ad_btn")
	gs.connect("adIsNotAvailable",self,"hide_ad_btn")
	gs.connect("leaderboard_ok",self,"set_world_record")
	gs.connect("finished_rewardedad",self,"get_reward")
	gs.connect("rewardedad_failed",self,"show_failed_popup")
	
	show_ad_btn("endless_continue_rewarded")
	
	get_node("endless_boost/dialog_timer").connect("timeout",self,"show_car_boost")
	
	get_node("gameover").hide()
	get_node("black").hide()

	pass

func show_ad_btn(ad):
	if(ad == "endless_continue_rewarded"):
		if(get_node("gameover/bg/show_ad").is_hidden()):
			get_node("gameover/bg/show_ad").show()
			
	if(ad == "endless_boost_rewarded"):
		get_node("endless_boost/car_boost").play("show_popup")
		if(!get_tree().is_paused()):
			get_tree().set_pause(true)

func hide_ad_btn(ad):
	if(ad == "endless_continue_rewarded"):
		if(!get_node("gameover/bg/show_ad").is_hidden()):
			get_node("gameover/bg/show_ad").hide()
			
	if(ad == "endless_boost_rewarded"):
		get_node("endless_boost/car_boost").play("hide_popup")

func _on_world_map_pressed():
	saved_collected_beans()

	get_node("gameover").hide()
	get_node("black").hide()
	get_tree().set_pause(false)
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")	

	gs.show_heyzapinterstitial("endless_gameover")
	pass # replace with function body


func _on_try_again_pressed():
	saved_collected_beans()
	
	get_node("gameover").hide()
	get_node("black").hide()
	get_tree().set_pause(false)
	get_node("/root/globals").level_index=-1 # minus one is endless... yeah

	get_node("/root/globals").change_scene("res://locations/level.scn")
	get_node("/root/globals").distance_run=0.0
	
	gs.show_heyzapinterstitial("endless_gameover")
	
func saved_collected_beans():
	gs.set_beans(gs.get_beans() + get_node("/root/globals").collected_beans_endless)
	
	if(gs.parse):
		gs.save_cloud()
	else:
		gs.save_pc()

func _on_show_ad_pressed():
	if(!gs.ad_is_in_cache("endless_continue_rewarded")):
		gs.show_retry(self)
		return
		
	gs.show_rewarded_ad("endless_continue_rewarded")

func _on_watch_ad_pressed():
	if(!gs.ad_is_in_cache("endless_boost_rewarded")):
		gs.show_retry(self)
		return
	
	gs.show_rewarded_ad("endless_boost_rewarded")
	get_node("endless_boost/car_boost").play("hide_popup")

func get_reward(tag):
	if(tag=="endless_continue_rewarded"):
		emit_signal("continue")
		get_node("anim").play("disapear")
		get_node("/root/globals").continued = true
	if(tag=="endless_boost_rewarded"):
		gs.set_bean_rush(gs.get_bean_rush() + 1)
		get_node("/root/globals").longer_car_boost = true
		emit_signal("update_bean_rush")
		emit_signal("do_bean_rush")

func show_failed_popup(tag):
	if(tag=="endless_continue_rewarded" || tag=="endless_boost_rewarded"):
		gs.show_retry(self,true)

func check_car_boost(btn):
	get_node("endless_boost/dialog_timer").start()
	hud_pause_btn = btn
	hud_pause_btn.set_disabled(true)

func show_car_boost():
	if(hud_pause_btn):
		hud_pause_btn.set_disabled(false)
	
	print("Checking if car boost is available")
	gs.isAdAvailable("endless_boost_rewarded",int(gs.get_app_parameter("endless_boost_rewarded_cap",3)))

func _on_close_btn_pressed():
	get_node("endless_boost/car_boost").play("hide_popup")
	if(get_tree().is_paused()):
		get_tree().set_pause(false)
