
extends Node

# member variables here, example:
# var a=2
# var b="textvar"

var Config = preload("res://global/config.gd")

const MOB_DISTANCE=320
const WALKWAY_SIZE = 4350
const PHOTOBOOTH_SIZE = 1699

const MAX_ACTIVE_PIECES=3
const SHUFFLE_COUNT=20

const DIFFICULTY_EASY = 0
const DIFFICULTY_MEDIUM = 1
const DIFFICULTY_HARD = 2

var speed_mods=[-1,-1,-1]

var background=null
var progression=null
var stage_complete=false

var progression_section=-1
var progression_index=-1

var mob=null
var wicket=null
var beanpos=Vector2()

var total_beans=0

var endless=false

func get_total_beans():
	return total_beans
func get_collected_beans():
	return get_node("bean").bean_count
	
var endless_speed=1.0
var endless_accel=1.01

var begin_level=true


func game_over():
	if (not endless):
		get_node("bean").gameover()
	else:
		get_node("/root/endless").game_over( get_node("bean").get_distance_run() )

func _endless_swap():
	call_deferred("advance_level")
	get_node("/root/globals").distance_run = get_node("bean").get_distance_run()

func _bean_finished():
	if (endless):
		get_node("/root/endless").do_swap()
		
	pass

func advance_level():
	

		
	var path=""
	var world = get_node("/root/globals").world_index
	if (endless):
		path=get_node("/root/gamestate/").get_endless_path(world)	
	else:
		get_node("/root/globals").level_index+=1
		if (get_node("/root/globals/").custom_level!=""):
			path=get_node("/root/globals/").custom_level
		else:
			path=get_node("/root/gamestate").get_level_path(get_node("/root/globals/").world_index,get_node("/root/globals/").level_index)		
		print("next level is: "+path)
		
	for c in get_node("bg").get_children():
		c.free()
		
	
	var newwicket = load("res://wicket/wicket.scn").instance()
	var newmob = load("res://mishaps/angrymob.scn").instance()
	
	mob.free()
	wicket.free()
	mob=newmob
	wicket=newwicket
	begin_level=true
	
	var newbean = load("res://bean/bean.scn").instance()
	get_node("bean").free()
	newbean.set_name("bean")
	newbean.set_pos(beanpos)
	newbean.connect("finished",self,"_bean_finished")
	add_child(newbean)
	move_child(newbean,1)
	if (endless):
		var distance = 	get_node("/root/globals").distance_run
		newbean.set_enable_endless(distance)
	else:
		newbean.set_current_level( get_node("/root/globals/").level_index + 1 )
	
		
	mob.set_name("mob")
	mob.set_pos(get_node("mob_pos").get_pos())
	add_child(mob)

	wicket.set_name("wicket")
	wicket.set_pos(get_node("wicket_pos").get_pos())
	add_child(wicket)
	

	var ls = load(path)
	assert(ls!=null)

	active_pieces=[]
	offset=0
	
	stage_complete=false

	progression_section=-1
	progression_index=-1
	available_pieces=[]
	
	progression = ls.pieces
	total_beans=0
	
func _ready():

	var world = get_node("/root/globals").world_index

	var remap_target = "res://mishaps/"+["london","agra","japan","australia","mexico","newyork"][world]+"/frames.res";
	print("remap target ",remap_target)
	PathRemap.add_remap("res://mishaps/london/frames.res",remap_target)

	var path=""

	if ( get_node("/root/globals/").level_index==-1):
		#endless mode
		path=get_node("/root/gamestate/").get_endless_path(world)
		endless=true
		var distance = 	get_node("/root/globals").distance_run
		get_node("bean").set_enable_endless(distance)
		get_node("/root/endless").connect("endless_swap",self,"_endless_swap")
		
		##CHECK IF CAR BOOST AD IS AVAILABLE
		get_node("/root/endless").check_car_boost(get_node("bean/hudbase/hud/pause_button"))
	else:
		#regular mode
		if (get_node("/root/globals/").custom_level!=""):
			path=get_node("/root/globals/").custom_level
		else:
			path=get_node("/root/gamestate").get_level_path(get_node("/root/globals/").world_index,get_node("/root/globals/").level_index)
		endless=false
		print("current level is: "+path)
		get_node("bean").set_current_level( get_node("/root/globals/").level_index + 1 )
		
	var ls = load(path)
	assert(ls!=null)
	var name = ls.type
	
	var music = ["UK.ogg","India.ogg","Japan.ogg","Australia.ogg","Mexico.ogg","USA.ogg"]
	get_node("music").set_stream( load("res://sounds/music/"+music[world]) )
	get_node("music").play()
	
	mob = load("res://mishaps/angrymob.scn").instance()
	mob.set_name("mob")
	mob.set_pos(get_node("mob_pos").get_pos())
	add_child(mob)

	wicket = load("res://wicket/wicket.scn").instance()
	wicket.set_name("wicket")
	wicket.set_pos(get_node("wicket_pos").get_pos())
	add_child(wicket)
		
	var s = load("res://locations/"+name+"/stages.gd")
	background = s.background.instance()
	add_child(background)
	
	beanpos=get_node("bean").get_pos()
	get_node("bean").connect("finished",self,"_bean_finished")
	progression = ls.pieces
	
	for x in s.decorations:
		available_decos.append(x)
	set_process(true)
	
	get_node("/root/gamestate").track_times_played("level_start")
	
func _stage_completed():
	print("AIRPORT DONE 2")
	emit_signal("stage_completed")	
	
func _get_pieces():

	if (progression_section==-1):
		progression_section+=1
		progression_index=0
		
	if (progression_section==progression.size()):
		return false
		

		
	
	
var next_piece_speed_mult=0

var available_decos=[]
var available_pieces=[]
var shuffle_bag=[]

func _piece_out(piece):
	if (endless):
		endless_speed*=endless_accel
		get_node("bean").set_speed_mult(endless_speed)
	else:
		if (piece.has_meta("speed_mult")):
			print("CHANGING SPEED MULT TO: ",piece.get_meta("speed_mult"))
			get_node("bean").set_speed_mult(piece.get_meta("speed_mult"))
	active_pieces.erase(piece)
	piece.queue_free()

func _find_beans(node):
	if (node extends preload("res://locations/common/coin.gd")):
		if (node.big):
			total_beans+=10
		else:
		 	total_beans+=1
			
	for n in node.get_children():
		_find_beans(n)

func _ensure_stage_exists():

	while(active_pieces.size()<MAX_ACTIVE_PIECES):
	
		if (progression_section==-1):
			progression_section=0	
		if (progression_section==progression.size()):
		
			if (not stage_complete):

				if (endless):
					available_pieces=[preload("res://locations/common/checkpoint/endless.scn")]
					shuffle_bag=[]				
				elif (get_node("/root/globals").level_index+1 == get_node("/root/gamestate").get_max_level(get_node("/root/globals").world_index)): #last level
					available_pieces=[preload("res://locations/airport/airport.scn")]
					shuffle_bag=[]
				else:
					available_pieces=[preload("res://locations/common/checkpoint/photobooth.scn")]
					shuffle_bag=[]
					
				stage_complete=true
			else:
				return false
		else:
		
			if (progression_index==-1):
				available_pieces=[]
				
				for p in progression[progression_section].pieces:
					available_pieces.append(p)
				shuffle_bag=[]
			progression_index+=1
			if (progression_index==0 and "speed_mult" in progression[progression_section]):
				next_piece_speed_mult=progression[progression_section].speed_mult
				
			if (progression_index==progression[progression_section].len):
				progression_section+=1
				progression_index=-1
				continue
				
		#shuffle
		if (shuffle_bag.size()==0):
			for i in range(available_pieces.size()):
				shuffle_bag.append(available_pieces[i])
				
			for i in range(SHUFFLE_COUNT):
				var aidx = randi() % shuffle_bag.size()
				var bidx = randi() % shuffle_bag.size()
				var aux = shuffle_bag[aidx]
				shuffle_bag[aidx]=shuffle_bag[bidx]
				shuffle_bag[bidx]=aux
			
		#pick 
		

		if (begin_level and get_node("/root/globals/").level_index>0):
			begin_level=false
			var scene
			if (endless):
				scene=preload("res://locations/common/checkpoint/endless.scn").instance()
			else:
				scene=preload("res://locations/common/checkpoint/photoboothbeg.scn").instance()
				
			scene.get_node("scene").disabled=true
			scene.set_pos(Vector2(offset,0))
			offset+=PHOTOBOOTH_SIZE
			get_node("bg").add_child(scene)
			scene.get_node("floor/notifier").connect("exit_screen",self,"_piece_out",[scene])
			active_pieces.push_back(scene)
			
		var spos = randi() % shuffle_bag.size()
		var p = shuffle_bag[ spos ]
		shuffle_bag.remove(spos)
		var scene = p.instance()
			
		_find_beans(scene)
		
		if (Config.DEBUG_LEVEL_NAMES):
			var lvname = scene.get_filename().get_file().basename()
			var dbg = preload("res://locations/section_debug.scn").instance()
			for c in dbg.get_children():
				c.set_text(lvname)
			scene.add_child(dbg)
			
		if (not stage_complete):
			var deco = available_decos[ randi() % available_decos.size() ].instance()
			scene.add_child(deco)
			scene.move_child(deco,1)
		else:
			scene.connect("stage_complete",self,"_stage_completed")
			
		scene.set_pos(Vector2(offset,0))
		offset+=WALKWAY_SIZE
		get_node("bg").add_child(scene)
		var fn =scene.get_filename()
		print(fn)
		scene.get_node("floor/notifier").connect("exit_screen",self,"_piece_out",[scene])
		if (next_piece_speed_mult>0):
			scene.set_meta("speed_mult",next_piece_speed_mult)
			next_piece_speed_mult=0;
		active_pieces.push_back(scene)
		





var active_victims=[]
var visible_victims=[]

func remove_victim(type):
	active_victims.erase(type)

func add_victim(type):
	active_victims.append(type)
	get_node("mob").enable_victim(type)

var active_pieces=[]
var offset=0

func _process(delta):

#fill up pieces
	

	_ensure_stage_exists()
		

func _init():
	add_user_signal("stage_completed")
	randomize()



