
extends KinematicBody2D

# member variables here, example:
# var a=2
# var b="textvar"

var disabled=true

var entered=false

const FLOOR_ANGLE_TOLERANCE = 30
const GRAVITY = 1200

var vvelocity = 0.0

var speed = -200


func _fixed_process(delta):

	if (disabled):
		return
	vvelocity+=delta*GRAVITY
	
	var velocity = Vector2(speed,vvelocity)
	
	var motion = velocity * delta
	
	motion = move(motion)

	var on_floor = false
	get_node("sprite").set_rot(0)
	
	if (is_colliding()):
		#ran against something, is it the floor? get normal
		var n = get_collision_normal()
		var ang = rad2deg(acos(n.dot( Vector2(0,-1))))
		if ( ang < FLOOR_ANGLE_TOLERANCE ):
			if (n.x>0):
				ang=-ang
			
			get_node("sprite").set_rot(deg2rad(ang))
			on_floor=true
			#if angle to the "up" vectors is < angle tolerance
			#char is on floor
#			on_air_time=0
#			floor_velocity=get_collider_velocity()
			#velocity.y=0 
			
		# But we were moving and our motion was interrupted, 
		# so try to complete the motion by "sliding"
		# by the normal

		motion = n.slide(motion)
		velocity = n.slide(velocity)
		vvelocity=velocity.y
		
		#then move again
		move(motion)
		

func _ready():
	var bn = get_tree().get_nodes_in_group("bean")
	for n in bn:
		add_collision_exception_with(n)
	set_fixed_process(true)
	pass




func _on_vn_enter_screen():
	disabled=false
	pass # replace with function body


func _on_damage_body_enter( body ):
	if (not disabled and body extends preload("res://bean/bean.gd")):
		disabled=true
		get_node("anim").play("die")
		body.damage(true)
		
	pass # replace with function body


func _on_VisibilityNotifier2D_enter_screen():
	if (entered):
		return
	get_node("sfx").play("mouse_"+str(randi()%4+1))
	entered=true
	pass # replace with function body
