
extends Node2D

# member variables here, example:
# var a=2
# var b="textvar"

var Config  = preload("res://global/config.gd")

const BASE_DISTANCE=80
const START_DISTANCE=500
const SEPARATION=30

var victim_timeout_base = Config.VICTIM_RUN_TIMEOUT
const VICTIM_GOAWAY_SPEED = 120

var bean=null


var dist={}

var following=[]

func get_closest_victim():
	var which=null
	var dist=99999999.0
	print("following size: ",following.size())
	for n in following:
		if (n.get_global_pos().x < dist):
			dist=n.get_global_pos().x
			which=n
	return which

func _char_entered(which):	
	var node = get_node(which)
	if (not node in following):
		node.set_meta("timeout",victim_timeout_base)
		following.append(node)

func _char_smacked(which):	
	var node = get_node(which)
	var n = AnimatedSprite.new()
	n.set_sprite_frames( node.get_node("frames").get_sprite_frames() )
	n.set_pos( node.get_pos()+node.get_node("frames").get_pos() )
	n.set_offset( node.get_node("frames").get_offset() )
	n.set_frame( node.get_node("frames").get_frame() )
	var hit = preload("res://mishaps/hit.scn").instance()
	n.add_child(hit)
	hit.set_emitting(true)
	node.hide()
	add_child(n)
	get_parent().remove_victim(which)


func get_victim_to_smack(ofs,size):
	for n in following:
		var d = dist[n]
		if (ofs>d and ofs-size<=d):
			return n
	return null
	
		
	

func smack_victim(victim):
	var node = get_node(victim)
	node.get_node("run").stop()
	node.get_node("anim").play("hit")
	following.erase(node)

	
func enable_victim(victim):
	get_node(victim+"/run").play("run")
	var n = get_node(victim)
	dist[n]=START_DISTANCE
	n.show()
	if (not victim in following):
		n.set_meta("timeout",victim_timeout_base)	
		following.append(n)
		
	if (following.size()>2):
		get_node("smoke").set_emitting(true)

func disable_victims():	
	for i in range(following.size()):
		var n = following[i]	
		n.set_meta("timeout",-1)
		
func _process(delta):
	
	var to_erase=[]
	for i in range(following.size()):
		var target_dist = (BASE_DISTANCE+i*SEPARATION)
		var n = following[i]	
				
		var bpos = bean.get_global_pos().x
		var d = dist[n]		
		
		var to = n.get_meta("timeout")
		to-=delta
		n.set_meta("timeout",to)
		
		if (to>0):
			d-=(d-target_dist)*delta
			if (d<target_dist):
				d=target_dist
		else:
			d+=VICTIM_GOAWAY_SPEED*delta
			if (d>START_DISTANCE):
				to_erase.append(n)
				
				
			
		dist[n]=d
		var pos = n.get_pos()
		pos.x=bpos-d
		n.set_pos(pos)
		
	for e in to_erase:
		following.erase(e)
		
	
func _ready():

	set_process(true)
	bean=get_node("../bean")
	for x in get_children():
		if x.has_node("anim"):
			print("found: ",x.get_name())
#			x.get_node("notifier").connect("enter_screen",self,"_enter_screen",[x.get_name()])
			var an = x.get_node("anim").get_animation("activate")
			var tc = an.get_track_count()
			an.add_track(Animation.TYPE_METHOD)
			an.track_set_path(tc,"..")
			an.track_insert_key(tc,an.get_length(),{method="_char_entered",args=[x.get_name()]})
			an = x.get_node("anim").get_animation("hit")
			tc = an.get_track_count()
			an.add_track(Animation.TYPE_METHOD)
			an.track_set_path(tc,"..")
			an.track_insert_key(tc,an.get_length(),{method="_char_smacked",args=[x.get_name()]})
			dist[x]=0
		
		x.hide()
	get_node("smoke").show()
	get_node("smoke").set_emitting(false)
	
	var gstate = get_node("/root/gamestate")
	victim_timeout_base = int(gstate.get_app_parameter("misshap_timeout",victim_timeout_base))
	# Initalization here
	add_to_group("angrymob")
	pass


