
extends Node2D

# member variables here, example:
# var a=2
# var b="textvar"

export var mode=0

var types=["girl1","girl2","man1","man2"]
var floor_types=["man3","man4"]

var type=""
var level = null
var victimized=false

var timeout=0

func _ready():
#shuffle
	level = self
	while (level and not level extends preload("res://locations/level.gd")):
		level = level.get_parent()

	if (level==null):
		return
		
	assert (level!=null) 
	
	
	if (mode==0):
		#shuffle unused type
		var candidates = []
		for x in types:
			if (not x in level.active_victims and not x in level.visible_victims):
				candidates.append(x)
				
		if (get_global_pos().y>700):
			for x in floor_types:
				if (not x in level.active_victims and not x in level.visible_victims):
					candidates.append(x)
		
		if (candidates.size()==0):
			queue_free()
			return #all victims active!
		type = candidates[ randi() % candidates.size() ]
		
		
	get_node("anim").play(type+"_idle")
	level.visible_victims.append(type)
		
	# Initalization here
	pass



func _on_area_body_enter( body ):
	if (not victimized and body extends preload("res://bean/bean.gd")):
		victimized=true
		body.hit_victim()
		get_node("anim").play(type+"_mishap")	
		_begin_misshap()
		get_node("slowdown_timer").start()	
		get_node("arrow").hide()


func _on_notifier_exit_screen():
	level.visible_victims.erase(type)
	if (victimized):
		level.add_victim(type)



func _on_area_body_exit( body ):
	if (not victimized and body extends preload("res://bean/bean.gd")):
		_stop_arrow()


func _on_slowdown_timer_timeout():
	return
	var wfs = Globals.get("waitingforslide")
	wfs-=1
	Globals.set("waitingforslide",wfs)
	if (wfs==0):
		OS.set_time_scale(1.0)
		
func _begin_misshap():
	return
	var wfs=0
	if (not Globals.has("waitingforslide")):
		wfs=0		
	else:
		wfs = Globals.get("waitingforslide")

	if (wfs==0):
		OS.set_time_scale(0.5)
		
	Globals.set("waitingforslide",wfs+1)
