
extends Control

# member variables here, example:
# var a=2
# var b="textvar"

var Config = preload("res://global/config.gd")

var tutorial_active=false

var tuto_ticks=0
var base_beans=0
var continue_cost=1
var beans_collected=0

var server

func _on_tutorial_input_event(ev):
	if (tutorial_active and ev.type==InputEvent.MOUSE_BUTTON and ev.pressed and ev.button_index==1 and (OS.get_ticks_msec()-tuto_ticks)>700):
		get_tree().set_pause(false)
		get_node("tutorial/anim").stop()
		get_node("tutorial").hide()
		tutorial_active=false
		get_parent().get_parent()._input(ev)
	pass # replace with function body


func set_current_level(idx):
	#get_node("level/count").set_text(tr("CS_LEVEL")+" "+str(idx))
	get_node("level/count").set_text(str(idx)+" / "+str(get_node("/root/gamestate").get_max_level( get_node("/root/globals").world_index ) ) )
	if (not get_node("distance").is_visible()):
		get_node("level").show()

func set_enable_endless():
	get_node("distance").show()
	get_node("level").hide()

func set_distance(distance):
	get_node("distance/count").set_text(str(int(distance)))

func show_teddy():
	get_node("found_anim").play("teddy")
	
func show_yellow_gift():
	get_node("found_anim").play("gift")

func show_tutorial(idx):
	if (tutorial_active):
		return
	tutorial_active=true
	get_tree().set_pause(true)
	get_node("tutorial").show()
	if (idx==0 or idx==1):
		get_node("../..").set_disable_jump(false)
	get_node("tutorial/anim").play(["hand_tap","hand_hold","hand_glide","bean_collect","dash","mishap","evade_wicket1","evade_wicket2","teddy","escape","gift"][idx])
	tuto_ticks=OS.get_ticks_msec()
	

func set_beans(amount):
	beans_collected=amount
	get_node("beans/count").set_text(str(amount+base_beans))

func set_bean_rushes(amount):
	get_node("rush_bar/button/amount").set_text(str(amount))	
	get_node("rush_bar/button").set_disabled(amount==0)
	if (amount>0):
		get_node("rush_bar/anim").play("activated")
	else:
		get_node("rush_bar/anim").play("deactivated")
		
	if (amount>1):
		get_node("rush_bar/button/amount").show()
	else:
		get_node("rush_bar/button/amount").hide()


var wicket_distance=0
var wicket_visible_time=0
var wicket_floor_time=0
var wicket_scream_time=5
const WICKET_SCREAM_TIMEOUT=5
const WICKET_TIMEOUT=0.5
var DISTANCE_DIVIDER=Config.WICKET_DISTANCE_DIVIDER

var hud_active=true

func _process(delta):

	if (delta>0.5):
		delta=0.5

	if (not hud_active):
		return
		
	var distance_nice = abs(floor((wicket_distance/DISTANCE_DIVIDER)*10)/10.0)
	wicket_visible_time-=delta
	wicket_floor_time-=delta
	
	if (wicket_visible_time<0):
		get_node("wicket_arrow").set_margin(MARGIN_LEFT,64)
		get_node("wicket_arrow").show()
		get_node("wicket_arrow/arrow").set_frame(0)
		get_node("wicket_arrow/distance").set_text(str(int(distance_nice))+"m")
	elif (wicket_floor_time<0):
		get_node("wicket_arrow").show()
		get_node("wicket_arrow/arrow").set_frame(1)
		get_node("wicket_arrow/distance").set_text(str(int(distance_nice))+"m")
		var pos = get_viewport().get_canvas_transform().xform(get_node("../..").get_global_pos())
		get_node("wicket_arrow").set_margin(MARGIN_LEFT,max(64,pos.x+wicket_distance))
		
		
		
	else:
		get_node("wicket_arrow").hide()
		if (wicket_scream_time<=0):
			get_node("sound").set_default_pitch_scale(rand_range(0.9,1.1))
			get_node("sound").play("bean")
		wicket_scream_time=WICKET_SCREAM_TIMEOUT
		
	wicket_scream_time-=delta
	
		
	if (wicket_visible_time>0):

		var twc = get_node("/root/gamestate").p_info.data.total_wicket_close
		if (twc<Config.ACHIEVEMENT_CLOSE_WICKET_SEC and twc+delta>=Config.ACHIEVEMENT_CLOSE_WICKET_SEC):
			get_node("/root/gamestate").set_achievement_unlocked("time_hot_persuit")			
		get_node("/root/gamestate").p_info.data.total_wicket_close=twc+delta
		

func set_bean_rush_fill(amount):
	get_node("rush_bar").set_val(amount)

func set_wicket_distance(dist):
	wicket_distance=dist

func wicket_on_screen():
	wicket_visible_time=WICKET_TIMEOUT
	pass

func wicket_on_floor():
	wicket_floor_time=WICKET_TIMEOUT
	pass

func set_wicket_visible(visible):
	if (visible):
		get_node("wicket_arrow").hide()
	else:
		get_node("wicket_arrow").show()
		

func _init():
	add_user_signal("do_bean_rush")
	add_user_signal("continue")
	# Initalization here
	pass


func hide_hud():
	get_node("rush_bar").hide()
	get_node("pause_button").hide()
	get_node("beans").hide()
	get_node("beans").hide()
	get_node("wicket_arrow").hide()
	if (not get_node("distance").is_visible()):
		get_node("level").hide()
	hud_active=false


func show_gameover():
	
	get_node("gameover").show()
	get_tree().set_pause(true)
	get_node("/root/gamestate").set_beans(base_beans+beans_collected)
	
	var level_str=get_node("/root/globals").get_checkpoint_str()
	
	if (get_node("/root/globals").continued):
		_on_giveup_pressed()

	
func _on_pause_pressed():
	get_node("pause").show()
	get_tree().set_pause(true)
	pass # replace with function body


func _on_button_pressed():
	emit_signal("do_bean_rush")
	pass # replace with function body
	


func _on_restart_pressed():
	get_tree().set_pause(false)
	
	var idx = get_node("/root/globals").level_index
	var world = get_node("/root/globals").world_index
	while( idx > 0 ):
		if get_node("/root/gamestate").get_level_unlocked(world,idx):
			break
		idx-=1
		
	get_node("/root/globals").level_index=idx
	
	get_node("/root/globals").change_scene("res://locations/level.scn")
	
	var level_str=get_node("/root/globals").get_checkpoint_str()

	pass # replace with function body


func _on_main_menu_pressed():
	get_tree().set_pause(false)
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")

	var level_str=get_node("/root/globals").get_checkpoint_str()
	pass # replace with function body


func _restore_hud():
	get_node("rush_bar").show()
	get_node("pause_button").show()
	get_node("beans").show()
	get_node("beans").show()
	get_node("wicket_arrow").show()	
	if (not get_node("distance").is_visible()):	
		get_node("level").show()
	hud_active=true

func _on_cont_pay_pressed():
	var beans = get_node("/root/gamestate").get_beans()
	if (beans<continue_cost):
		get_node("no_beans").show_popup(true)
		return
	
	get_node("/root/gamestate").set_beans(beans-continue_cost)
	base_beans-=continue_cost
	get_node("beans/count").set_text(str(beans_collected+base_beans))
	get_tree().set_pause(false)
	emit_signal("continue")
	get_node("gameover").hide()
	get_node("pause").hide()
	_restore_hud()

	var level_str=get_node("/root/globals").get_checkpoint_str()
	get_node("/root/globals").continued=true
	
	get_node("/root/gamestate").log_event("spend_virtual_currency",{"virtual_currency":"beans",
										   						    "item":"gameover_continue_"+str(get_node("/root/globals").level_index),
										   							"value":str(continue_cost)})
	#server.show_rewarded_ad()
	
	pass # replace with function body


func _on_cont_video_pressed():
	if(!server.ad_is_in_cache("story_continue_rewarded")):
		server.show_retry(self)
		return
	
	server.show_rewarded_ad("story_continue_rewarded")

	#server.show_ad(server.get_app_parameter("Watch_a_video_rewarded_ad" + "_" + OS.get_name(),Config.get_zone("Watch_a_video_rewarded_ad" + "_" + OS.get_name())),{})
	pass # replace with function body

func get_reward(tag):
	if(tag=="story_continue_rewarded"):
		get_tree().set_pause(false)
		emit_signal("continue")
		get_node("gameover").hide()
		_restore_hud()
		
		var level_str=get_node("/root/globals").get_checkpoint_str()
		get_node("/root/globals").continued=true
		
func _on_resume_pressed():
	get_tree().set_pause(false)
	get_node("pause").hide()
	_restore_hud()

	pass # replace with function body


func _on_home_pressed():
	get_tree().set_pause(false)
	get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")
	pass # replace with function body

func _ready():
	server = get_node("/root/gamestate")
	
	server.isAdAvailable("story_continue_rewarded",int(server.get_app_parameter("story_continue_rewarded_cap",3)))
	server.connect("adIsAvailable",self,"show_ad_btn")
	server.connect("finished_rewardedad",self,"get_reward")
	server.connect("rewardedad_failed",self,"show_failed_popup")
	server.connect("ad_rewardWithCurrencyReceived",self,"update_base_beans")
	
	#server.connect("adIsNotAvailable",self,"hide_ad_btn")
	
	server.connect("daily_cap_reached",self,"daily_cap_reached")
	base_beans = get_node("/root/gamestate").get_beans()
	get_node("beans/count").set_text(str(base_beans))	
	continue_cost = get_node("/root/gamestate").get_continue_cost()
	var txt = get_node("gameover/container/cont_pay/txt").get_text().replace("XXXX",str(continue_cost))
	get_node("gameover/container/cont_pay/txt").set_text(txt)
	get_node("/root/globals").continued=false
	get_node("level/flags").get_child( get_node("/root/globals").world_index ).show() 
	set_process(true)
	
	get_node("pause/dialog/music_toggle").set_pressed(get_node("/root/gamestate").p_info.data["music_enabled"])
	get_node("pause/dialog/sfx_toggle").set_pressed(get_node("/root/gamestate").p_info.data["sfx_enabled"])
	
	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		get_node("tutorial/base/tuto8").set_scale(Vector2(0.8,0.8))
		get_node("tutorial/base/tuto8").set_size(Vector2(730,186))
		get_node("tutorial/base/tuto_teddy").set_scale(Vector2(0.8,0.8))
		get_node("tutorial/base/tuto_teddy").set_size(Vector2(543,164))

func update_base_beans(reward_amount):
	base_beans += reward_amount

func show_failed_popup(tag):
	if(tag=="story_continue_rewarded"):
		server.show_retry(self,true)

func show_ad_btn(ad):
	if(ad == "story_continue_rewarded"):
		get_node("gameover/container/cont_video/hide_ad_btn").play("unhide_btn")

func hide_ad_btn(ad):
	if(ad == "story_continue_rewarded"):
		get_node("gameover/container/cont_video/hide_ad_btn").play("hide_btn")


func daily_cap_reached():
	if(!get_node("gameover/container/cont_video").is_disabled()):
		get_node("gameover/container/cont_video").set_disabled(true)

func _on_nobeans_button_pressed():
	get_node("no_beans").hide()
	pass # replace with function body


func _on_giveup_pressed():
	if(!get_node("/root/globals").continued):
		#server.show_ad(server.get_app_parameter("Give_up_gg_ad" + "_" + OS.get_name(),Config.get_zone("Give_up_gg_ad" + "_" + OS.get_name())),{})
		server.show_heyzapinterstitial("story_giveup")
	
	get_node("gameover/container/cont_pay").hide()
	#get_node("gameover/container/cont_video").hide()
	get_node("gameover/container/cont_video/hide_ad_btn").play("hide_btn")
	get_node("gameover/container/continuelabel").hide()
	get_node("gameover/container/giveup").hide()
	get_node("gameover/container/main_menu").show()
	get_node("gameover/container/restart").show()
	get_node("gameover/container/giveuplabel").show()
	
	pass # replace with function body


func _on_retry_pressed():
	_on_restart_pressed()
	pass # replace with function body


func _on_sfx_toggle_pressed():

	var state = get_node("pause/dialog/sfx_toggle").is_pressed()
	#get_node("pause/dialog/sfx_toggle").set_pressed(state)
	
	get_node("/root/gamestate").p_info.data["sfx_enabled"]=state
	
	if (state):
		AudioServer.set_fx_global_volume_scale(1)
	else:
		AudioServer.set_fx_global_volume_scale(0)
	
	get_node("/root/gamestate").save_settings()
	
	

func _on_music_toggle_pressed():

	var state = get_node("pause/dialog/music_toggle").is_pressed()
	#get_node("pause/dialog/music_toggle").set_pressed(state)
	
	get_node("/root/gamestate").p_info.data["music_enabled"]=state
	
	if (state):
		AudioServer.set_stream_global_volume_scale(1)
	else:
		AudioServer.set_stream_global_volume_scale(0)

	get_node("/root/gamestate").save_settings()

	pass # replace with function body
