
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"
var gs
var Config = preload("res://global/config.gd")
var gift_preload = preload("res://screens/main_menu/yellow_red_gifts/gifts_popup.scn")
var isCheckpointReachedAd = false

func _ready():
	# Initialization here
	
	gs = get_node("/root/gamestate")
	
	gs.isAdAvailable("levelselect_beans_rewarded",int(gs.get_app_parameter("levelselect_beans_rewarded_cap",1)))
	
	gs.connect("adIsAvailable",self,"show_ad_btn")
	gs.connect("adIsNotAvailable",self,"hide_ad_btn")
	gs.connect("rewardedad_failed",self,"show_failed_popup")
	
	add_user_signal("_pressed_endless_btn")
	
	hide()
	pass

func show_failed_popup(tag):
	if(tag=="levelselect_beans_rewarded" || tag=="checkpoint_beans_rewarded"):
		gs.show_retry(self,true)

func show_popup(isCheckpointReachScreen = false):
	if(self.is_hidden()):
		self.show()
	
	if(isCheckpointReachScreen):
		gs.isAdAvailable("checkpoint_beans_rewarded",int(gs.get_app_parameter("checkpoint_beans_rewarded_cap",1)))
		isCheckpointReachedAd = true
		return
		
	gs.isAdAvailable("levelselect_beans_rewarded",int(gs.get_app_parameter("levelselect_beans_rewarded_cap",1)))
	isCheckpointReachedAd = false

func show_ad_btn(ad):
	if(ad == "levelselect_beans_rewarded" || 
	   ad == "checkpoint_beans_rewarded"):
		get_node("anim").play("show_ad_btn")
			
	get_node("Label").set_text(tr("AD_FREE_DESC"))

func hide_ad_btn(ad):
	var ygift_price = int(gs.get_app_parameter("yellow_gifts",Config.YELLOW_GIFTS))
	
	if(ad == "levelselect_beans_rewarded" || 
	   ad == "checkpoint_beans_rewarded"):
		if(gs.get_beans() >= ygift_price):
			get_node("anim").play("show_endless_yellow")
			get_node("Label").set_text(tr("NEED_BEANS_YDESC"))
		else:
			get_node("Label").set_text(tr("NEED_BEANS_DESC"))
			get_node("anim").play("show_endless_center")

func _on_buy_pressed():
	get_tree().call_group(0,"bean_counter","_on_purchase_pressed")
	hide()
	
	pass # replace with function body


func _on_close_pressed():
	hide()
	pass # replace with function body


func _on_ad_btn_pressed():
	if(!gs.ad_is_in_cache("levelselect_beans_rewarded") || 
	   !gs.ad_is_in_cache("checkpoint_beans_rewarded") ):
		gs.show_retry(self)
		return
		
	hide()
	if(isCheckpointReachedAd):
		gs.show_rewarded_ad("checkpoint_beans_rewarded")
		return
		
	gs.show_rewarded_ad("levelselect_beans_rewarded")

func _on_endless_btn_pressed():
	emit_signal("_pressed_endless_btn")
	get_node("/root/globals").level_index=-1
	get_node("/root/globals").change_scene("res://locations/level.scn")
	if(!self.is_hidden()):
		hide()

func _on_worldmap_btn_pressed():
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
	get_node("/root/globals").endless_mode = true

func go_to_world_map():
	get_node("endless_btn").connect("pressed",self,"_on_worldmap_btn_pressed")
	
func go_to_endless_mode():
	get_node("endless_btn").connect("pressed",self,"_on_endless_btn_pressed")

func _on_buy_ygift_btn_pressed():
	var price = int(gs.get_app_parameter("yellow_gifts",Config.YELLOW_GIFTS))
	
	if(gs.get_beans()>=price):
		emit_signal("buyed")
		gs.set_yellow_gift(gs.get_yellow_gift() + 1)
		gs.set_beans(gs.get_beans() - price)
		
		gs.log_event("spend_virtual_currency",{"virtual_currency":"beans",
					  						   "item":"virtual_box",
					  						   "value":str(price)})
					
	if(gs.get_beans() < price):
		get_node("Label").set_text(tr("NEED_BEANS_DESC"))
		get_node("anim").play("show_endless_center")
		
	if(gs.get_yellow_gift() >= 1):
		gs.set_yellow_gift( gs.get_yellow_gift() - 1)
		var ygift_node = gift_preload.instance()
		if(!ygift_node.is_inside_tree()):
			self.add_child(ygift_node)
			ygift_node.set_pos(Vector2(0,-5))
			get_node("anim").play("hide_popup")
			ygift_node.connect("gift_popup_closed",self,"show_popup_noad")
			
	if(gs.parse):
		gs.save_cloud()
	else:
		gs.save_pc()
	
	pass # replace with function body

func show_popup_noad():
	get_node("anim").play("show_popup")
	pass