
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"

var config = preload("res://global/config.gd")
var server = null
var unlock_cost=1

var can_advance=false

var teddy_text = preload("res://screens/endlevel/teddy_found.png")
var ratings_prompt = preload("res://screens/main_menu/ratings_prompt.scn")
var teddy_ach = ["teddy_england",
				 "teddy_india",
				 "teddy_japan",
				 "teddy_australia",
				 "teddy_mexico",
				 "teddy_usa"]
				
func _ready():
	# Initalization here
	server = get_node("/root/gamestate")
	add_user_signal("done")
	get_node("anim").connect("finished",self,"show_buttons")
	get_node("anim").connect("finished",self,"show_ratings_prompt")
	get_node("no_beans").connect("_pressed_endless_btn",self,"_play_fade_out")
	hide()
	
	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		get_node("frame/title container/text").set_scale(Vector2(0.8,0.8))
		get_node("frame/title container/text").set_size(Vector2(660,193))
		get_node("frame/unlock4beans/hand_dialog/Label").set_scale(Vector2(0.8,0.8))
		get_node("frame/unlock4beans/hand_dialog/Label").set_size(Vector2(599,185))
	pass

func appear(p_can_advance=true):

	can_advance=p_can_advance
	
	var level_str=get_node("/root/globals").get_checkpoint_str()

	if (p_can_advance):
		get_node("frame/title container/text").set_text("CR_TITLE")
	else:
		get_node("frame/title container/text").set_text("CR_COUNTRY_TITLE")
	
	var world = get_node("/root/globals").world_index

	print("APPEARING!")
	call_deferred("raise")
	if (can_advance):
		get_node("anim").play("fadein")
		print("CURRENT SCENE ", get_node("/root/globals").current_scene)
	else:
		get_node("anim").play("fadein_nopic")
	get_node("frame/rating1").set_frame(0)
	get_node("frame/rating2").set_frame(0)
	get_node("frame/rating3").set_frame(0)
	var lvindex=(get_node("/root/globals").level_index%10)+1
	get_node("picture").set_texture( load("res://screens/endlevel/photobomb_"+str(lvindex)+".png") )
	
	var total_beans = get_node("/root/level").get_total_beans()
	var collected_beans = get_node("/root/level").get_collected_beans()
	
	if(server.get_current_hat()=="golden"):
		collected_beans /= 2
	
	get_node("frame/coincount").set_text(str("COINS: ",collected_beans,"/",total_beans))

	var g = get_node("/root/globals")
	var gstate = get_node("/root/gamestate")

	var percent = float(collected_beans)/total_beans*100
	
	var percent_required = int(gstate.get_app_parameter(str("bean_percent_",g.world_index+1,"_",get_node("/root/globals").level_index+1),50))
	#if collected_beans==0:
	#	percent=100
	get_node("frame/rating3/text2").set_text( tr("CR_BEANSP").replace("XX",str(percent_required)) )
		
	var prev_stars = gstate.get_world_stars(g.world_index)
	var stars=0
	var lv_stars = 0
	if (true):
		get_node("anim").queue("star1")
		stars|=1
		lv_stars = 1
	if (not get_node("/root/globals").continued):
		get_node("anim").queue("star2")
		stars|=2
		lv_stars = 2
	if (percent>percent_required):
		get_node("anim").queue("star3")
		stars|=4
		lv_stars = 3
		get_node("/root/globals").manage_ratings_prompt3stars()
	
		
	unlock_cost = gstate.get_unlock_cost(g.world_index,get_node("/root/globals").level_index+1)
	#var txt = tr("CR_UNLOCK").replace("XXXX",str(unlock_cost))
	get_node("frame/unlock4beans/beans").set_text(str(unlock_cost))
	
	if (world>0):
		get_node("picture/bg").set_texture(load("res://screens/endlevel/photobomb_bg_"+["england","india","japan","australia","mexico","usa"][world]+".png"))

	get_node("frame/bg").show()
	get_node("frame/rating1").show()
	get_node("frame/rating2").show()
	get_node("frame/rating3").show()
	get_node("frame/unlock4beans").show()
	get_node("frame/continue").show()
	get_node("frame/unlocked").hide()
	get_node("frame/level").hide()
	get_node("frame/level_pre").hide()
	get_node("frame/level_post").hide()
	get_node("frame/continue").set_disabled(false)
	
	
	var lv = get_node("/root/globals").level_index
	
	gstate.log_event("post_score",{"beans":str(collected_beans),
					 			   "beans_percentage":str(percent),
					 			   "stars_received":str(lv_stars),
					 			   "checkpoint":str(lv+1)})
	
	gstate.track_times_played("level_complete")
	
	gstate.set_level_score(g.world_index,lv,stars)
	gstate.set_level_completed(g.world_index,lv+2)
	
	##Show ad at the end of each level 10
	##server.show_ad(server.get_app_parameter("non_rewarded_ad" + "_" + OS.get_name(),config.get_zone("non_rewarded_ad" + "_" + OS.get_name())),{})	
	get_node("frame/levelname/text").set_text(tr("CS_LEVEL")+" "+str(lv+1))	
		

	var is_unlocked = gstate.get_level_unlocked(g.world_index,lv+1)
	print("IS UNLOCKED? ",lv+1,is_unlocked)
	if (is_unlocked):
		get_node("frame/unlock4beans").set_disabled(true)
		get_node("frame/continue/skip").hide()
		get_node("frame/continue/next").show()
		get_node("frame/unlock4beans/text").hide()
		get_node("frame/unlock4beans/beans").hide()
		get_node("frame/unlock4beans/bean").hide()
		get_node("frame/unlock4beans/bg").hide()
	else:
		get_node("frame/unlock4beans").set_disabled(false)
		get_node("frame/continue/skip").show()
		get_node("frame/continue/next").hide()
		get_node("frame/unlock4beans/text").show()
		get_node("frame/unlock4beans/beans").show()
		get_node("frame/unlock4beans/bean").show()
		get_node("frame/unlock4beans/bg").show()
	
	var teddy_starts = [10,6,3,10,4,7]
	
	if g.level_index + 1 != teddy_starts[g.world_index]:
		get_node("teddy").hide()
	
	if (g.world_index==0 and lv==0):
		if(!get_node("frame/restart_btn").is_hidden()):
			get_node("frame/restart_btn").hide()
		if(!get_node("frame/main_menu_btn").is_hidden()):
			get_node("frame/main_menu_btn").hide()
			
		get_node("frame/dark").show()
		get_node("frame/dark").set_opacity(0)
		get_node("frame/dark/frame1").set_opacity(0)
		get_node("anim").queue("showtuto")
		gstate.set_level_unlocked(g.world_index,lv+1,true)
		get_node("frame/unlock4beans").set_disabled(false)
		get_node("frame/unlock4beans/bg").hide()
		gstate.set_beans(get_node("/root/gamestate").get_beans() + unlock_cost)
		get_node("/root/gamestate").log_event("tutorial_complete",{})

	var need_stars = gstate.get_world_passing_stars(g.world_index)
	if (p_can_advance and gstate.is_in_plane() and prev_stars<need_stars and gstate.get_world_stars(g.world_index) >= need_stars):
		#gstate.clear_plane()
		get_node("anim").queue("unlocked")
		


	if(gstate.parse):
		gstate.save_cloud()
	else:
		gstate.save_pc()	

	gstate.engage("three_stars")		
	gstate.engage("checkpoint_reached")
	
	get_node("frame/level").hide()
	get_node("frame/level_pre").hide()
	get_node("frame/level_post").hide()
	
	if (not can_advance):
		get_node("frame/unlock4beans").hide()
		get_node("frame/continue").hide()
		get_node("frame/unlocked").show()
		
	_check_achievements()
	
func show_ratings_prompt():
	if(get_node("anim").get_current_animation() == "star3"):
		if(get_node("/root/globals").rating_prompt_3stars == int(server.get_app_parameter("rating_prompt_3stars",3))):
			var rating_prompt_instance = ratings_prompt.instance()
			self.add_child(rating_prompt_instance)

func _play_fade_out():
	get_node("anim").play("fadeout")

func advance_level():
	get_node("/root/level").advance_level()
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()

func _check_achievements():
	var world = get_node("/root/globals").world_index
	var ach=[
	  "stars_england",
	  "stars_india",
	  "stars_japan",
	  "stars_australia",
	  "stars_mexico",
	  "stars_usa"]
	
	var maxl = server.get_max_level(world)
	var all_3 = true
	for i in range(maxl):
		if (!(server.get_level_score(world,i)&0x7==0x7)):
			all_3=false
	if (all_3):
		server.set_achievement_unlocked(ach[world])
		
	var all_worlds_3=true
	for a in ach:
		if (not server.get_achievement(a)):
			all_worlds_3=false
			
	if (all_worlds_3):
		server.set_achievement_unlocked("random_completionist")
	
	if (get_node("/root/gamestate").get_achievement(teddy_ach[world])):
		get_node("teddy").set_texture(teddy_text)
	
func _on_unlock4beans_pressed():

	var beans = get_node("/root/gamestate").get_beans()
	if (unlock_cost>beans):
		get_node("no_beans").show_popup(true)
		server.current_brp_parent = self
		get_node("no_beans").go_to_world_map()
		return
	beans-=unlock_cost
	get_node("/root/gamestate").set_beans(beans)
	#get_node("anim").play("fadeout")
	var gstate = get_node("/root/gamestate")
	var g = get_node("/root/globals")
	
	var lvindex = get_node("/root/globals").level_index + 1
	#gstate.set_level_completed(g.world_index,l+1)
	gstate.set_level_unlocked(g.world_index,lvindex,true)
	
	
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()	

			
	"""
	if (can_advance):
		get_node("anim").play("fadeout")
	else:
		get_tree().set_pause(false)
		emit_signal("done")
		hide()
	"""
				
	get_node("frame/unlock4beans/anim").stop()
	get_node("frame/unlock4beans/hand_dialog").hide()
	get_node("frame/level").show()
	get_node("frame/level/buy").hide()
	var lvnum = str(lvindex+1)
	if (lvnum.length()==1):
		lvnum="0"+lvnum
	
	get_node("frame/level/number").set_text(lvnum)	
	get_node("frame/level/anim").play("unlocked")
	get_node("frame/level").show()

	var lvnum_pre = str(lvindex)
	if (lvnum_pre.length()==1):
		lvnum_pre="0"+lvnum_pre
		
	get_node("frame/level_pre/number").set_text(lvnum_pre)	
	get_node("frame/level_pre").show()
	if (lvindex==1 or gstate.get_level_unlocked(g.world_index,lvindex-1)):
		get_node("frame/level_pre/selector").set_frame(0)
	else:
		get_node("frame/level_pre/selector").set_frame(1)
	
	if (lvindex<gstate.get_max_level(g.world_index)-1):
		var lvnum_post = str(lvindex+2)
		if (lvnum_post.length()==1):
			lvnum_post="0"+lvnum_post
		get_node("frame/level_post/number").set_text(lvnum_post)	
		get_node("frame/level_post").show()
		
		if (lvindex<gstate.get_level_completed(g.world_index)):
			get_node("frame/level_post/selector").set_frame(2)		
		elif (gstate.get_level_unlocked(g.world_index,lvindex+1)):
			get_node("frame/level_post/selector").set_frame(0)
		else:
			get_node("frame/level_post/selector").set_frame(1)
		
	else:	
		get_node("frame/level_post").hide()
		
	
	
	get_node("frame/bg").hide()
	get_node("frame/rating1").hide()
	get_node("frame/rating2").hide()
	get_node("frame/rating3").hide()
	get_node("frame/unlock4beans").hide()
	get_node("frame/continue").hide()
	get_node("frame/unlocked").show()
	#get_node("frame/level/anim").queue("tada")
	pass # replace with function body


func _on_continue_pressed(): 
	server.show_ad(server.get_app_parameter("Skip_checkpoint_ad" + "_" + OS.get_name(),config.get_zone("Skip_checkpoint_ad" + "_" + OS.get_name())),{})
	var gstate = get_node("/root/gamestate")
	var g = get_node("/root/globals")

	server.show_heyzapinterstitial("checkpoint_complete")

	if (can_advance):
		get_node("anim").play("fadeout")
	else:
		get_tree().set_pause(false)
		emit_signal("done")
		hide()
	
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()
	
	pass # replace with function body

func show_buttons():
	if(get_node("anim").get_current_animation() != "fadeout"):
		return
	
	if(get_node("frame/restart_btn").is_hidden()):
		get_node("frame/restart_btn").show()
	if(get_node("frame/main_menu_btn").is_hidden()):
		get_node("frame/main_menu_btn").show()

func _on_nobeans_button_pressed():
	get_node("no_beans").hide()
	pass # replace with function body

var tuto_steps=0

func _on_dark_input_event( ev ):
	if (ev.type==InputEvent.MOUSE_BUTTON and ev.pressed):
		if (tuto_steps==0):
			get_node("frame/dark/frame1").hide()
			get_node("frame/dark/frame2").show()
			tuto_steps+=1
		elif (tuto_steps==1):
			get_node("frame/dark").hide()
			get_node("frame/unlock4beans/anim").play("handmove")
			get_node("frame/continue").set_disabled(true)	
			
		
		
	pass # replace with function body


func _on_unlocked_pressed():
	server.show_heyzapinterstitial("checkpoint_complete")
	
	if (can_advance):
		get_node("anim").play("fadeout")
	else:
		hide()
		get_tree().set_pause(false)
		emit_signal("done")
		
	pass # replace with function body


func _on_restart_btn_pressed():
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()
	
	get_tree().set_pause(false)
	
	get_node("anim").play("fadeout")
	
	var idx = get_node("/root/globals").level_index - 1
	var world = get_node("/root/globals").world_index 
	#while( idx > 0 ):
	#	if get_node("/root/gamestate").get_level_unlocked(world,idx):
	#		break
	#	idx-=1
		
	get_node("/root/globals").level_index=idx
	
	get_node("/root/globals").change_scene("res://locations/level.scn")

	pass # replace with function body


func _on_main_menu_btn_pressed():
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()
		
	get_node("anim").play("fadeout")
	
	get_tree().set_pause(false)
	get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")	
	pass # replace with function body
