
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"
var left_pad = 50
var right_pad = 50
var top_ofs = 400
var scroll_rate=1.0
var mult = 1.5

var locked={}
var base_price={}

var locked_button={}

var world=0
var country_names=[tr("CS_TITLE_UK"),tr("CS_TITLE_INDIA"),tr("CS_TITLE_JAPAN"),tr("CS_TITLE_AUS"),tr("CS_TITLE_MEX"),tr("CS_TITLE_US")]

func _process(delta):
	get_node("hbc").set_margin(MARGIN_LEFT,get_node("scroll/frame").get_margin(MARGIN_LEFT)/scroll_rate)

func _start_level(idx):
	
	if idx in locked:
		return
	var gstate = get_node("/root/gamestate")
	var maxlevel = gstate.get_max_level(world)
	get_node("/root/globals").level_index=idx
	get_node("/root/globals").change_scene("res://locations/level.scn")
	get_node("/root/globals").bean_rush_fill=0
		
	var level_str=get_node("/root/globals").get_checkpoint_str()
	
func get_level_str(chkp):
	var levels = ["uk","india","japan","australia","mexico","usa"]
	var w_idx = get_node("/root/globals").world_index
	if(w_idx <= levels.size()):
		return levels[w_idx]+".L"+str(chkp)
	else:
		return null

func _buy_level(idx):
	var gstate = get_node("/root/gamestate")
	
	var cost = locked[idx]
	
	if (cost>gstate.get_beans()):
		get_node("no_beans").show_popup()
		gstate.current_brp_parent = self
		get_node("no_beans").go_to_endless_mode()
		return
		
	gstate.set_beans(gstate.get_beans() - cost )
	gstate.log_event("spend_virtual_currency",{"virtual_currency":"beans",
					  						  "item":"checkpoint_"+str(idx),
					  						  "value":str(cost)})
	var level_str=get_node("/root/globals").get_checkpoint_str()

	var idxn = idx+1
	while (idx in locked):
		
		locked_button[idx].get_node("particles").set_emitting(true)
		locked_button[idx].get_node("anim").play("tada")
		locked_button[idx].get_node("buy").hide()
		locked_button[idx].get_node("play").show()
		locked_button[idx].get_node("selector").set_frame(0)
		gstate.set_level_unlocked(world,idx,true)
		locked.erase(idx)
		locked_button.erase(idx)
		base_price.erase(idx)
		
		idx-=1
	#update forward prices
	var accum=0	
	while(idxn in locked):
		accum+=base_price[idxn]
		locked_button[idxn].get_node("buy/price").set_text(str(accum))
		locked[idxn]=accum
		idxn+=1
		
	if(gstate.parse):
		gstate.save_cloud()
	else:
		gstate.save_pc()

	"""
	for i in range(idx+1):
		if (i in locked):
			locked_button[i].get_node("particles").set_emitting(true)
			locked_button[i].get_node("buy").hide()
			locked_button[i].get_node("play").show()
			locked_button[i].get_node("selector").set_frame(0)
			gstate.set_level_unlocked(world,i+1)
			locked.erase(i)
			locked_button.erase(i)
	"""


	pass





func _ready():

	world = get_node("/root/globals").world_index
	get_node("/root/globals").bean_rush_stored=false	

	if (world>0):
		for i in range(3):
			var n = get_node("hbc/map"+str(i+1))
			n.set_texture(load("res://screens/level_map/"+["uk","india","japan","aus","mexico","usa"][world]+str(i+1)+".png"))
		get_node("base/flag").set_texture(load("res://screens/level_map/flag_"+["UK","india","japan","australia","mexico","USA"][world]+".png"))
		get_node("base/font/label").set_text(country_names[world])
		
	var frame = get_node("scroll/frame")
	var ms = get_node("hbc").get_minimum_size()
		
	scroll_rate=(ms.x*mult-get_viewport_rect().size.x) / (ms.x-get_viewport_rect().size.x)
	ms.x*=mult
	frame.set_custom_minimum_size( ms )
	var gstate = get_node("/root/gamestate")
	
	var levelcount=gstate.get_max_level(world)
	
	var levelcompleted=gstate.get_level_completed(world)
#	var level_cost = gstate.get_unlock_cost(world)
	
	print(levelcompleted)
	
	var enabled=5
	var price_accum=0
	
	for i in range(levelcount):
		
		var ofs = left_pad + ((ms.x - left_pad - right_pad) / levelcount)*i
		var l = preload("res://screens/level_map/level.scn").instance()		
		
		if i>=levelcompleted:
		
			if (i>0):
				l.set_disabled(true) 
				l.get_node("selector").set_frame(2)
				#l.get_node("selector").
				l.get_node("play").hide()
				
			l.get_node("star1").hide()
			l.get_node("star2").hide()
			l.get_node("star3").hide()
		else:
			l.get_node("star1").show()
			l.get_node("star2").show()
			l.get_node("star3").show()
			
			if i>0 and not gstate.get_level_unlocked(world,i):
			
				var cost = int(gstate.get_unlock_cost(world,i))
				price_accum+= cost
				#var local_price = price + price_accum
				l.get_node("selector").set_frame(1)				
				l.get_node("buy").show()
				l.get_node("play").hide()
				l.get_node("buy/price").set_text(str(price_accum))
				locked[i]=price_accum
				base_price[i]=cost
				l.get_node("buy").connect("pressed",self,"_buy_level",[i])
				l.connect("pressed",self,"_buy_level",[i])
				locked_button[i]=l
			else:
				price_accum=0
				
			var score = int(gstate.get_level_score(world,i))
			if (score&1):
				l.get_node("star1").set_frame(1)
			if (score&2):
				l.get_node("star2").set_frame(1)
			if (score&4):
				l.get_node("star3").set_frame(1)
			
			
		if (i<levelcompleted):
			l.get_node("anim").play("active")

			
		l.connect("pressed",self,"_start_level",[i])
		l.get_node("play").connect("pressed",self,"_start_level",[i])
		var ltxt=str(i+1)
		if (ltxt.length()==1):
			ltxt="0"+ltxt
		if (world==0 and i==0):
			ltxt="01 "+tr("CS_TUTORIAL")
		l.get_node("number").set_text(ltxt)
		l.set_pos( Vector2( ofs, top_ofs) )
		frame.add_child(l)
		
	set_process(true)
	get_node("sound").play(["uk","india","japan","australia","mexico","usa"][world])
	

	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		get_node("base/font/label").set_scale(Vector2(0.8,0.8))
		get_node("base/font/label").set_size(Vector2(513,132))
	# Initalization here
	pass




func _on_backbase_pressed():
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
	pass # replace with function body


func _on_nobeans_button_pressed():
	get_node("no_beans").hide()
	pass # replace with function body


func _on_Button34_pressed():
	var gstate = get_node("/root/gamestate")
	
	var levelcount=gstate.get_max_level(world)+1
	for i in range(levelcount):
		
		gstate.set_level_unlocked(world,i,true)
		gstate.set_level_completed(world,i)

	get_node("/root/globals").change_scene("res://screens/level_map/level_select.scn")


func _on_shop_btn_pressed():
	if (get_node("shop").is_hidden()):
		get_node("shop").show()
		
	pass # replace with function body