
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"

var clicks = 1

var server
var mapped_nodes = {}
var achievements_keys = []

func _ready():
	self.add_user_signal("backed")
	server = get_node("/root/gamestate")
	server.connect("achievement_unlocked",self,"update_achievements")
	var achievements = server.get_achievements()
	achievements_keys = achievements.keys()
	map_nodes()
	update_achievements()
	fit_de("1")

func update_achievements():
	var achievements = server.get_achievements()
	for key in achievements_keys:
		if(achievements[key]):
			print("true achieve : ", key)
			get_node("book_container/"+mapped_nodes[key]+"/"+key+"/title").set_opacity(1.0)
			get_node("book_container/"+mapped_nodes[key]+"/"+key+"/description").set_opacity(1.0)
			get_node("book_container/"+mapped_nodes[key]+"/"+key).set_self_opacity(1.0)
		else:
			get_node("book_container/"+mapped_nodes[key]+"/"+key+"/title").set_opacity(0.5)
			get_node("book_container/"+mapped_nodes[key]+"/"+key+"/description").set_opacity(0.8)
			get_node("book_container/"+mapped_nodes[key]+"/"+key).set_self_opacity(0.2)

func map_nodes():
	for i in range(get_node("book_container").get_child_count()):
		for j in range(get_node("book_container").get_child(i).get_child_count()):
			var child = get_node("book_container").get_child(i)
			for k in range(achievements_keys.size()):
				if(child.get_child(j).get_name().find(achievements_keys[k]) != -1):
					mapped_nodes[achievements_keys[k]]=child.get_name()
					k=achievements_keys.size()
	
	#print("map: ", mapped_nodes.to_json())

func _on_back_btn_pressed():
	if(self.is_visible()):
		self.hide()
		self.emit_signal("backed")

func _on_main_menu_btn_pressed():
	if(self.is_visible()):
		self.hide()
		self.emit_signal("backed")
		if(self.get_parent().get_node("bottom/menu_ok").is_visible()):
			self.get_parent().get_node("bottom/menu_ok").hide()
			self.get_parent().get_node("bottom/play_btn").show()
			self.get_parent().get_node("bottom/menu_btn").show()
			if(self.get_parent().get_node("bottom/back_btn").is_visible()):
				self.get_parent().get_node("bottom/back_btn").hide()


func _on_right_arrow_btn_pressed():
	if(clicks<=6):
		clicks += 1
	else:
		clicks = 1
	
	show_page(str(clicks))

func _on_left_arrow_btn_pressed():
	if(clicks >= 2):
		clicks -= 1
	else:
		clicks = 7
		
	show_page(str(clicks))	
		
func fit_de(page):
	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		var c = get_node("book_container/page" + page).get_child_count()
		
		for i in range(c):
			var n = get_node("book_container/page" + page).get_child(i)
			if i < 2:
				var p = n.get_node("title").get_pos()
				n.get_node("title").set_pos(Vector2(p.x - 8, p.y))
				
			n.get_node("title").set_size(Vector2(190,120))
			n.get_node("title").set_scale(Vector2(0.75,0.75))
		
func show_page(current):
	var previous = ["1","2","3","4","5","6","7"]
	fit_de(current)
	
	if(get_node("book_container/page" + current).is_hidden()):
		get_node("book_container/page" + current).show()

	for i in range(previous.size()):
		if(previous[i] != current && !get_node("book_container/page" + previous[i]).is_hidden()):
			get_node("book_container/page" + previous[i]).hide()