
extends Control

var server
var timer

func _ready():
	server = get_node("/root/gamestate")
	timer = Timer.new()
	timer.set_wait_time(30)
	timer.set_one_shot(true)
	timer.connect("timeout",self,"timedout")

func reset():
	if(get_node("background/container/login").is_hidden()):
		get_node("background/container/login").show()
		
	if(!get_node("background/container/local_warning").is_hidden()):
		get_node("background/container/local_warning").hide()
		
	if(!get_node("background/container/warning").is_hidden()):
		get_node("background/container/warning").hide()	

func play_loading_anim():
	ui_helper("loading","background")
	var root = get_tree().get_root()
	var scene = root.get_child( root.get_child_count() -1 )
	if(!timer.is_inside_tree()):
		scene.add_child(timer)
	
	timer.start()

func timedout():
	if(server.isLoggedin && get_node("/root/globals").synced):
		timer.queue_free()
	else:
		if(get_node("login_timeout").is_hidden()):
			get_node("login_timeout").show()

func stop_loading():
	if(timer.get_time_left() > 0):
		timer.stop()
		
	ui_helper("background","loading")
	if(!get_node("login_timeout").is_hidden()):
			get_node("login_timeout").hide()

func show_local_warning():
	if(get_node("background/container/login").is_visible()):
		ui_helper("background/container/local_warning","background/container/login")
	else:
		ui_helper("background/container/local_warning","background/container/warning")

func _on_facebook_login_btn_pressed():
	if(server.parse && server.parse_class_name):
		server.parse.facebook_login(server.parse_class_name,server.p_info.data,server.should_start_update)
		play_loading_anim()

func _on_cancel_btn_pressed():
	ui_helper("background/container/login","background/container/warning")

func _on_continue_btn_pressed():
	if(server.parse && server.parse_class_name):
		server.parse.set_guest_user(true)
		server.parse.sync_with_localdatastore(server.parse_class_name,server.p_info.data,server.should_start_update)
		play_loading_anim()

func ui_helper(currentView, prevView):
	if(get_node(prevView).is_visible()):
		get_node(prevView).hide()
	if(get_node(currentView).is_hidden()):
		get_node(currentView).show()

func _on_wcontinue_btn_pressed():
	if(server.parse && server.parse_class_name):
		server.parse.clear_cache(server.parse_class_name)

func _on_wcancel_btn_pressed():
	if(server.parse):
		server.parse.log_out()
	if(get_node("background/container/local_warning").is_visible()):
		ui_helper("background/container/login","background/container/local_warning")

func _on_just_play_btn_pressed():
	ui_helper("background/container/warning","background/container/login")


func _on_stop_pressed():
	stop_loading()
	if(!get_node("login_timeout").is_hidden()):
			get_node("login_timeout").hide()
			
	if(server.isLoggedin):
		server.parse.log_out()

func _on_wait_pressed():
	timer.start()
	if(!get_node("login_timeout").is_hidden()):
			get_node("login_timeout").hide()
