
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"

var server
var Config = preload("res://global/config.gd")

func _ready():
	server = get_node("/root/gamestate")
	
	server.connect("user_logged_in",self,"show_yellow_gift")
	server.connect("user_logged_in",self,"reconnect")
	show_yellow_gift()
	update_ygifts_count()
	get_node("achievements").connect("backed",self,"show_yellow_gift")
	get_node("leaderboard").connect("backed",self,"show_yellow_gift")
	
	if(!get_node("/root/globals").megasale_ok):
		self.set_process(true)
	else:
		self.set_process(false)
		if(get_node("megasale").get_opacity() == 1):
			get_node("megasale/hide").play("hide")
	#DEPRECATED
	#if(get_node("/root/globals").is_premium or server.is_premiumVersion1() or server.worlds_unlocked()):
	#	get_node("unlock_all/hide").play("hide")
	#elif(get_node("/root/globals").menu_sessions >= 2):
	#	get_node("unlock_all/show").play("show")
	
	#if(get_node("unlock_all/hand").is_hidden() && 
	#get_node("unlock_all/container").is_hidden() &&
	#!get_node("/root/globals").unlock_active_session &&
	#get_node("/root/globals").menu_sessions >= int(server.get_app_parameter("menu_hand_freq",3)) &&
	#(int(get_node("/root/globals").menu_sessions)%int(server.get_app_parameter("menu_hand_freq",3))) == 0):
	#	get_node("unlock_all/hand").show()
	#	get_node("unlock_all/container").show()

func _process(delta):
	if(get_node("/root/globals").megasale_ok):
		if(get_node("megasale").get_opacity() == 1):
			get_node("megasale/hide").play("hide")
		self.set_process(false)
		return
	
	if(server.get_seconds_left() == -1):
		if(get_node("megasale").get_opacity() == 1):
			get_node("megasale/hide").play("hide")
	else:
		if(get_node("megasale").get_opacity() == 0):
			get_node("megasale/show").play("show")
		var secsleft = int(server.get_seconds_left())
		
		var hr 
		if((secsleft/3600) < 10):
			hr = "0" + str(secsleft/3600)
		else:
			hr = secsleft/3600
		
		var mins
		if((secsleft/60)%60 < 10):
			mins = "0" + str((secsleft/60)%60)
		else:
			mins = (secsleft/60)%60
			
		var secs
		if((secsleft%60) < 10):
			secs = "0" + str(secsleft%60)
		else:
			secs = secsleft%60
			
		var txt = str(hr,":",mins,":",secs)
		get_node("megasale/timer/time").set_text(txt)

func reconnect():
	get_node("achievements").connect("backed",self,"show_yellow_gift")
	get_node("leaderboard").connect("backed",self,"show_yellow_gift")

func show_yellow_gift():
	if get_node("/root/globals").get_m_yellow():
		return
	
	if (server.get_yellow_gift()>0):
		if(get_node("yellowgift").is_hidden()):
			get_node("yellowgift/anim").play("yellow")
			get_node("yellowgift").show()
			get_node("/root/globals").set_m_yellow(true)
	
func hide_yellow_gift():
	get_node("yellowgift").hide()
	pass

func update_ygifts_count():
	var gifts = server.get_yellow_gift()
	if(gifts > 0):
		get_node("shop_btn/hats_counter").show()
		get_node("shop_btn/hats_counter/nmb").set_text(str(gifts))
	else:
		get_node("shop_btn/hats_counter").hide()

func _on_play_btn_pressed():
	_stage_select("world_map")
	if(get_node("settings").is_visible()):
		get_node("settings").hide()

func _on_shop_btn_pressed():
	hide_yellow_gift()
	get_node("shop").show()
	if(get_node("settings").is_visible()):
		get_node("settings").hide()
		
	if(!get_node("yellowgift").is_hidden()):
		get_node("achievements").disconnect("backed",self,"show_yellow_gift")
		get_node("leaderboard").disconnect("backed",self,"show_yellow_gift")
		get_node("yellowgift").hide()
		get_node("shop")._on_yellow_gift_btn_pressed()

func _on_settings_btn_pressed():
	hide_yellow_gift()
	if(get_node("settings").is_hidden()):
		get_node("settings").show()

func _on_achievements_btn_pressed():
	get_node("achievements").show()
	if(get_node("settings").is_visible()):
		get_node("settings").hide()

	if(!get_node("yellowgift").is_hidden()):
		get_node("yellowgift").hide()

func _on_leaderboard_pressed():
	hide_yellow_gift()
	get_node("leaderboard").show()
	if(get_node("settings").is_visible()):
		get_node("settings").hide()
	get_node("leaderboard").set_frame_and_get_leaderboard(get_node("leaderboard/countries").get_frame())
	
	if(!get_node("yellowgift").is_hidden()):
		get_node("yellowgift").hide()
	
func _stage_select(what):
	#get_node("/root/globals").change_scene("res://worldmap/"+what+".scn")
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")


func _on_more_games_btn_pressed():
	#get_node("/root/gamestate").show_ad(get_node("/root/gamestate").get_app_parameter("More_games_ad" + "_" + OS.get_name(),Config.get_zone("More_games_ad" + "_" + OS.get_name())),{})
	OS.shell_open("http://moreapps.endemolgames.com")
	pass # replace with function body


#func _on_unlock_all_pressed(): DEPRECATED
#	get_node("/root/unlock_popup").show_popup()
#	get_node("/root/globals").unlock_active_session = true
#	if(!get_node("unlock_all/container").is_hidden()):
#		get_node("unlock_all/container").hide()
#		
#	if(!get_node("unlock_all/hand").is_hidden()):
#		get_node("unlock_all/hand").hide()


func _on_megasale_pressed():
	_on_shop_btn_pressed()
	get_node("shop")._on_megasale_page_btn_pressed()
	get_node("shop/megasale").came_from_menu = true
	get_node("shop/megasale").update_pc()
	pass # replace with function body
