
extends TextureFrame

var gstate = null
var Config = preload("res://global/config.gd")

func _ready():
	gstate = get_node("/root/gamestate")
	gstate.connect("unlocked_all",self,"go_to_world")
	gstate.connect("consume_successfull",self,"consume_purchase")
	gstate.connect("received_product_info",self,"update_uall_price")
	update_uall_price()
	add_user_signal("closed_popup")
	
	if(OS.get_locale() == "es_ES" || OS.get_locale().find("es") != -1):
		get_node("title/title").set_scale(Vector2(0.6,0.6))
		get_node("title/title").set_size(Vector2(1198,161))
		get_node("container/desc").set_scale(Vector2(0.7,0.7))
		get_node("container/desc").set_size(Vector2(257,109))


func update_uall_price():
	if(gstate.get_iap_info("unlock_all")):
		get_node("unlock_all1/label").set_text(str(gstate.get_iap_info("unlock_all")))
		
func show_popup():
	if(self.is_hidden()):
		self.show()

func go_to_world():
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
	
func _on_close_pressed():
	if(!self.is_hidden()):
		self.hide()
		emit_signal("closed_popup")
	
	get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")

func consume_purchase(sku):
	if(sku == Config.UNLOCK_ALL_SKU):
		gstate.unlock_all()
	
func _on_unlock_all1_pressed():
	gstate.purchase(Config.UNLOCK_ALL_SKU,"")
	if(!self.is_hidden()):
		self.hide()
		emit_signal("closed_popup")


func _on_back_pressed():
	if(!self.is_hidden()):
		self.hide()
		emit_signal("closed_popup")
