extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"
var server
var settings_timer

func _ready():
	server = get_node("/root/gamestate")
	#get_node("settings_ok/grid/column2/volume_slider").connect("value_changed",self,"set_volume")
	server.connect("user_logged_out",self,"log_out")
	server.connect("user_logged_in",self,"log_in")
	#AudioServer.set_fx_global_volume_scale(0.5)
	#get_node("settings_ok/grid/column2/volume_slider").set_value(AudioServer.get_fx_global_volume_scale())
	get_node("about_ok/container/terms_desc").get_node("_v_scroll").set_opacity(0)
	
	get_node("settings_ok/grid/column2/volume_slider").set_pressed(get_node("/root/gamestate").p_info.data["music_enabled"])
	get_node("settings_ok/grid/column2/sound_btn").set_pressed(get_node("/root/gamestate").p_info.data["sfx_enabled"])
	get_node("settings_ok/grid/column2/push_btn").set_pressed(get_node("/root/gamestate").p_info.data["push_enabled"])
	set_process(true)
	get_node("about_ok/container/credits").get_v_scroll().set_opacity(0)
	
	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		get_node("tittle/text").set_scale(Verctor2(0.66,0.66))
		get_node("tittle/text").set_pos(Vector2(get_node("tittle/text").get_pos().x + 5, get_node("tittle/text").get_pos().y))
	
	if(server.isLoggedin):
		get_node("settings_ok/log_out_btn/text").set_text(tr("ST_LOG_OUT"))
	
const SCROLL_SPEED=27
var offset=0
	
func _process(delta):
	offset+=delta*SCROLL_SPEED
	var vs = get_node("about_ok/container/credits").get_v_scroll()
	vs.set_value(offset)
	if (offset + 5 > vs.get_max() - vs.get_page()):
		offset=0

func log_out():
	get_node("settings_ok/log_out_btn/text").set_text(tr("ST_LOG_IN"))
	get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")

func log_in():
	get_node("settings_ok/log_out_btn/text").set_text(tr("ST_LOG_OUT"))

func set_volume(value):
	pass

func _on_log_out_btn_pressed():
	if(server.parse):
		server.parse.set_guest_user(false)
		if(get_node("settings_ok/log_out_btn/text").get_text() == tr("ST_LOG_OUT")):
			server.parse.log_out()
			get_node("/root/globals").synced = false
		elif(get_node("settings_ok/log_out_btn/text").get_text() == tr("ST_LOG_IN")):
			get_node("/root/globals").synced = false
			get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")

func _on_contact_us_btn_pressed():
	if(server.parse):
		server.start_message_center()


func _on_about_btn_pressed():
	ui_helper("about_ok","settings_ok","ABOUT",Vector2(-130,-37))


func _on_more_games_btn_pressed():
	OS.shell_open("https://www.goodcatchgames.com/games/")


func _on_tutorials_btn_pressed():
	get_node("/root/globals").world_index=0
	get_node("/root/globals").level_index=0	
	get_node("/root/globals").change_scene("res://locations/level.scn")

	pass # replace with function body

func finished_timer():
	print("finished waiting")
	if(get_node("settings_ok/grid/column2/push_btn").is_disabled()):
		get_node("settings_ok/grid/column2/push_btn").set_disabled(false)

func _on_push_btn_pressed():
	settings_timer = Timer.new()
	settings_timer.set_wait_time(5.0)
	settings_timer.set_one_shot(true)
	settings_timer.set_autostart(false)

	settings_timer.connect("timeout",self,"finished_timer")
	
	if(!settings_timer.is_inside_tree()):
		var root = get_tree().get_root()
		var scene = root.get_child( root.get_child_count() -1 )
		scene.add_child(settings_timer)

	settings_timer.start()
	
	var state = get_node("settings_ok/grid/column2/push_btn").is_pressed()
	
	get_node("/root/gamestate").p_info.data["push_enabled"]=state
	
	if(state):
		get_node("/root/gamestate").unsubscribe("PushNOff")
		get_node("settings_ok/grid/column2/push_btn").set_disabled_texture(get_node("settings_ok/grid/column2/push_btn").get_pressed_texture())
	else:
		get_node("/root/gamestate").subscribe("PushNOff")
		
		get_node("settings_ok/grid/column2/push_btn").set_disabled_texture(get_node("settings_ok/grid/column2/push_btn").get_normal_texture())
	
	get_node("/root/gamestate").save_settings()
	
	get_node("settings_ok/grid/column2/push_btn").set_disabled(true)
	

func _on_volume_slider_pressed():

	var state = get_node("settings_ok/grid/column2/volume_slider").is_pressed()
	#get_node("pause/dialog/music_toggle").set_pressed(state)
	
	get_node("/root/gamestate").p_info.data["music_enabled"]=state
	
	if (state):
		AudioServer.set_stream_global_volume_scale(1)
	else:
		AudioServer.set_stream_global_volume_scale(0)

	get_node("/root/gamestate").save_settings()

func _on_sound_btn_pressed():

	var state = get_node("settings_ok/grid/column2/sound_btn").is_pressed()
	#get_node("pause/dialog/sfx_toggle").set_pressed(state)
	
	get_node("/root/gamestate").p_info.data["sfx_enabled"]=state
	
	if (state):
		AudioServer.set_fx_global_volume_scale(1)
	else:
		AudioServer.set_fx_global_volume_scale(0)
	
	get_node("/root/gamestate").save_settings()

func _on_close_btn_pressed():
	if(self.is_visible()):
		self.hide()
	ui_helper("settings_ok","about_ok","SETTINGS",Vector2(-160,-37))

func _on_back_btn_pressed():
	ui_helper("settings_ok","about_ok","SETTINGS",Vector2(-160,-37))
	
func ui_helper(curr_node,prev_node,text,pos):
	if(get_node(curr_node).is_hidden()):
		get_node(curr_node).show()
		
	if(!get_node(prev_node).is_hidden()):
		get_node(prev_node).hide()
	#get_node("tittle/text").set_text(text)
	#get_node("tittle/text").set_pos(pos)




func _on_terms_pressed():
	OS.shell_open("http://www.mrbeanaroundtheworld.com/terms-of-use")
	


func _on_restore_purchase_pressed():
	server.restore_purchase()
