
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"

var server
var gift_preload = preload("res://screens/main_menu/yellow_red_gifts/gifts_popup.scn")

var current_h_scroll = 0 
var hat_btn_buy_normal_texture = preload("res://screens/main_menu/shop/sprites/hat_btn_buy.png")
var hat_btn_equip_normal_texture = preload("res://screens/main_menu/shop/sprites/hat_btn.png")
var hat_btn_equiped_pressed_texture = preload("res://screens/main_menu/shop/sprites/hat_btn_buy_out.png")
var yellow_gift_popup_first_time = false
var Config = preload("res://global/config.gd")
var is_notmainmenu = false

var didBuyed = false

func _ready():
	add_user_signal("buyed")
	self.connect("buyed",self,"buyed")
	server = get_node("/root/gamestate")
	server.connect("sync_ok",self,"update_UI")
	server.connect("watched_videoAd",self,"update_UI")
	server.connect("receivedGift",self,"update_UI")
	server.connect("consume_successfull",self,"consume_purchase")
	server.connect("use_hat",self,"manage_hats")
	server.connect("daily_cap_reached",self,"daily_cap_reached")
	server.connect("received_product_info",self,"update_hat_prices")
	add_user_signal("not_enough_money")
	self.connect("not_enough_money",self,"show_not_enough_popup")
	get_node("items_tabs_ok/hats_ok/hats_scroll_controller").get_node("_h_scroll").set_opacity(0)
	update_UI()
	get_node("items_tabs_ok/hats_ok/hats_scroll_controller").set_h_scroll(0)
	
	if(OS.get_locale() == "de_DE" || OS.get_locale().find("de") != -1):
		get_node("items_tabs_ok/yellow_gift_tab/title").set_scale(Vector2(0.9,0.9))

func daily_cap_reached():
	if(!get_node("not_enough_container/watch_ad").is_disabled()):
		get_node("not_enough_container/watch_ad").set_disabled(true)

func buyed():
	didBuyed = true
	update_UI()

func show_not_enough_popup():
	if(get_node("not_enough_container").is_hidden()):
			get_node("not_enough_container").show()

func update_UI():
	get_node("bean_counter/counter").set_text(str(server.get_beans()))
	get_node("bean_rush_counter/counter").set_text(str(server.get_bean_rush()))
	get_node("yellow_gift_counter/counter").set_text(str(server.get_yellow_gift()))
	get_node("items_tabs_ok/bean_rush_ok/beanrush_1/1pack_btn/price").set_text(str(server.get_app_parameter("bean.rush_x1",Config.BEAN_RUSH_X1)))
	get_node("items_tabs_ok/bean_rush_ok/beanrush_2/2pack_btn/price").set_text(str(server.get_app_parameter("bean.rush_x5",Config.BEAN_RUSH_X5)))
	get_node("items_tabs_ok/bean_rush_ok/beanrush_3/3pack_btn/price").set_text(str(server.get_app_parameter("bean.rush_x10",Config.BEAN_RUSH_X10)))
	get_node("items_tabs_ok/yellow_gift_ok/buy_yellow_gift_btn/price").set_text(str(server.get_app_parameter("yellow_gifts",Config.YELLOW_GIFTS)))
	
	get_node("items_tabs_ok/golden_beans_ok/goldebean_1/counter").set_text(str(server.get_app_parameter("tiny.bean_pack",Config.TINY_BEAN_PACK)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_2/counter").set_text(str(server.get_app_parameter("small.bean_pack",Config.SMALL_BEAN_PACK)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_3/counter").set_text(str(server.get_app_parameter("medium.bean_pack",Config.MEDIUM_BEAN_PACK)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_4/counter").set_text(str(server.get_app_parameter("big.bean_pack",Config.BIG_BEAN_PACK)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_5/counter").set_text(str(server.get_app_parameter("huge.bean_pack",Config.HUGE_BEAN_PACK)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_1/price").set_text(str(server.get_app_parameter("tiny.bean_pack.price",Config.TINY_BEAN_PACK_PRICE)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_2/price").set_text(str(server.get_app_parameter("small.bean_pack.price",Config.SMALL_BEAN_PACK_PRICE)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_3/price").set_text(str(server.get_app_parameter("medium.bean_pack.price",Config.MEDIUM_BEAN_PACK_PRICE)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_4/price").set_text(str(server.get_app_parameter("big.bean_pack.price",Config.BIG_BEAN_PACK_PRICE)))
	get_node("items_tabs_ok/golden_beans_ok/goldebean_5/price").set_text(str(server.get_app_parameter("huge.bean_pack.price",Config.HUGE_BEAN_PACK_PRICE)))
	manage_yellow_gifts()
	manage_hats()
	
	if(current_h_scroll == 0):
		if(!get_node("items_tabs_ok/hats_ok/left_arrow_container/left_arrow_btn").is_hidden()):
			get_node("items_tabs_ok/hats_ok/left_arrow_container/left_arrow_btn").hide()


func manage_hats():
	var keys = server.get_hats().keys()
	
	for i in range(keys.size()):
		var hatname = keys[i]
		var hat = get_node("items_tabs_ok/hats_ok/hats_scroll_controller/hats/" + hatname + "_hat_container/" + hatname + "_hat/hat")
		var status = get_node("items_tabs_ok/hats_ok/hats_scroll_controller/hats/" + hatname + "_hat_container/" + hatname + "_hat/status")
		var hat_button = get_node("items_tabs_ok/hats_ok/hats_scroll_controller/hats/" + hatname + "_hat_container/" + hatname + "_hat")
		
		if(server.get_hats()[hatname].find("price",0) != -1):
			hat.set_frame(0)
			status.set_text(server.get_hats()[hatname].substr(6,server.get_hats()[hatname].length()))
			print("price : ", server.get_hats()[hatname].substr(6,server.get_hats()[hatname].length()))
			hat_button.set_normal_texture(hat_btn_buy_normal_texture)
		elif(server.get_hats()[hatname] == "equip"):
			hat.set_frame(0)
			status.set_text("WEAR")
			status.set_pos(Vector2(101, status.get_pos().y))
			hat_button.set_normal_texture(hat_btn_equip_normal_texture)
			hat_button.set_pressed_texture(hat_btn_equiped_pressed_texture)
		elif(server.get_hats()[hatname] == "equiped"):
				hat.set_frame(1)
				status.set_text("REMOVE")
				status.set_pos(Vector2(81, status.get_pos().y))

func update_hat_prices(hats_info):
	if(hats_info[0]==null):
		print("null dictionary")
		return

	var keys = server.get_hats().keys()
	var hat_map = {"bowler":"bowler_hat",
				   "construction":"construction_hat",
				   "golden":"golden_hat",
				   "mexican":"mariachi_hat",
				   "top":"top_hat",
				   "trucker":"trucker_hat",
				   "sports":"headband_hat"}
					
	for i in range(keys.size()):
		var hatname = keys[i]
		var status = get_node("items_tabs_ok/hats_ok/hats_scroll_controller/hats/" + hatname + "_hat_container/" + hatname + "_hat/status")
		print("Product : ", hatname," price : ", str(hats_info[0][hat_map[hatname]]))
		status.set_text(str(hats_info[0][hat_map[hatname]]))
	
func manage_yellow_gifts():
	if(server.get_yellow_gift()>0):
		get_node("items_tabs_ok/yellow_gift_ok/container/desc").set_text("YG_CAN_OPEN")
		get_node("items_tabs_ok/yellow_gift_ok/counter_container/counter").set_text(str(server.get_yellow_gift()))
		get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn/yellow_gift").set_frame(0)
		if(get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn").is_disabled()):
			get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn").set_disabled(false)
		get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn/open").show()
	else:
		get_node("items_tabs_ok/yellow_gift_ok/container/desc").set_text("YG_NO_MORE")
		get_node("items_tabs_ok/yellow_gift_ok/counter_container/counter").set_text(str(server.get_yellow_gift()))
		get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn/yellow_gift").set_frame(1)
		get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn/open").hide()
		if(!get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn").is_disabled()):
			get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn").set_disabled(true)
			
#Reset instance to default state
func reset_instance():
	print("RESET")
	if(get_node("items_ok").is_hidden()):
		get_node("items_ok").show()
	
	if(!get_node("items_tabs_ok/bean_rush_ok").is_hidden()):
		get_node("items_tabs_ok/bean_rush_ok").hide()
		get_node("items_tabs_ok/bean_rush_tab").set_disabled(false)
		
	if(!get_node("items_tabs_ok/hats_ok").is_hidden()):
		get_node("items_tabs_ok/hats_ok").hide()
		get_node("items_tabs_ok/hats_tab").set_disabled(false)
		
	if(!get_node("items_tabs_ok/yellow_gift_ok").is_hidden()):
		get_node("items_tabs_ok/yellow_gift_ok").hide()
		get_node("items_tabs_ok/yellow_gift_tab").set_disabled(false)
		
	if(!get_node("items_tabs_ok/golden_beans_ok").is_hidden()):
		get_node("items_tabs_ok/golden_beans_ok").hide()
		get_node("items_tabs_ok/golden_beans_tab").set_disabled(false)
		
	if(!get_node("items_tabs_ok").is_hidden()):
		get_node("items_tabs_ok").hide()
	
func _on_back_btn_pressed():
	if(!get_node("items_tabs_ok").is_hidden()):
		get_node("items_tabs_ok").hide()
		if(get_node("items_ok").is_hidden()):
			get_node("items_ok").show()
	elif(!self.is_hidden()):
		self.hide()
		if(didBuyed):
			didBuyed = false
		else:
			server.show_ad(server.get_app_parameter("No_purchase_inshop_ad" + "_" + OS.get_name(),Config.get_zone("No_purchase_inshop_ad" + "_" + OS.get_name())),{})
		
	reset_instance()

func _on_main_menu_btn_pressed():
	if(is_notmainmenu):
		get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")
		return
		
	if(!self.is_hidden()):
		self.hide()
		if(didBuyed):
			didBuyed = false
		else:
			server.show_ad(server.get_app_parameter("No_purchase_inshop_ad" + "_" + OS.get_name(),Config.get_zone("No_purchase_inshop_ad" + "_" + OS.get_name())),{})

func show_item_tabs(tab_name):
	if(get_node("items_ok").is_visible()):
		get_node("items_ok").hide()
		
	get_node("items_tabs_ok").show()
	if(get_node("items_tabs_ok/" + tab_name + "_ok").is_hidden()):
		get_node("items_tabs_ok/" + tab_name + "_ok").show()
		if(!get_node("items_tabs_ok/" + tab_name + "_tab").is_disabled()):
			get_node("items_tabs_ok/" + tab_name + "_tab").set_disabled(true)

func _on_bean_rush_btn_pressed():
	server.register_event("Shop Bean Boosts","shop_beanboosts_button","1",{"bean_boosts":server.get_bean_rush()})
	show_item_tabs("bean_rush")

func _on_hats_btn_pressed():
	var owned_hats = 0
	var hats = server.get_hats()
	var keys = hats.keys()
	for key in keys:
		if(hats[key] == "equip" || hats[key] == "equiped"):
			owned_hats += 1
		
	server.register_event("Shop Hats","shop_hats_button","1",{"owned_hats":owned_hats})
	show_item_tabs("hats")

func _on_yellow_gift_btn_pressed():
	show_item_tabs("yellow_gift")
	if(!yellow_gift_popup_first_time):
		if(get_node("items_tabs_ok/yellow_gift_ok/yellow_gift_popup").is_hidden()):
			get_node("items_tabs_ok/yellow_gift_ok/yellow_gift_popup").show()
			yellow_gift_popup_first_time = true

func _on_golden_beans_btn_pressed():
	server.register_event("Shop Golden Beans","shop_goldenbeans_button","1",{"beans":server.get_beans()})
	show_item_tabs("golden_beans")
	
func _on_left_arrow_btn_pressed():
	manage_arrow_btn("left")

func _on_right_arrow_btn_pressed():
	manage_arrow_btn("right")

func manage_arrow_btn(direction):	
	var scroll_size = get_node("items_tabs_ok/hats_ok/hats_scroll_controller").get_size().x + 10
	var last_scroll = get_node("items_tabs_ok/hats_ok/hats_scroll_controller/hats/bowler_hat_container").get_size().x + 10

	var MAX_SCROLL_SIZE = scroll_size * ((get_node("items_tabs_ok/hats_ok/hats_scroll_controller/hats").get_child_count() / 2) - 1)
	if(direction == "right"):
		if(get_node("items_tabs_ok/hats_ok/left_arrow_container/left_arrow_btn").is_hidden()):
			get_node("items_tabs_ok/hats_ok/left_arrow_container/left_arrow_btn").show()
	
		if(current_h_scroll < MAX_SCROLL_SIZE):
			current_h_scroll += scroll_size
		elif(current_h_scroll < (MAX_SCROLL_SIZE + last_scroll)):
			current_h_scroll += last_scroll
			if(!get_node("items_tabs_ok/hats_ok/right_arrow_container/right_arrow_btn").is_hidden()):
				get_node("items_tabs_ok/hats_ok/right_arrow_container/right_arrow_btn").hide()


	elif(direction == "left"):
		if(get_node("items_tabs_ok/hats_ok/right_arrow_container/right_arrow_btn").is_hidden()):
			get_node("items_tabs_ok/hats_ok/right_arrow_container/right_arrow_btn").show()
	
		var node_scroll = get_node("items_tabs_ok/hats_ok/hats_scroll_controller").get_h_scroll() 
		if(node_scroll > MAX_SCROLL_SIZE):
			current_h_scroll -= last_scroll
		elif(node_scroll > 0):
			if((current_h_scroll - scroll_size) >= 0):
				current_h_scroll -= scroll_size
			else:
				current_h_scroll = 0
				
		if(current_h_scroll == 0):
			if(!get_node("items_tabs_ok/hats_ok/left_arrow_container/left_arrow_btn").is_hidden()):
				get_node("items_tabs_ok/hats_ok/left_arrow_container/left_arrow_btn").hide()
				
	get_node("items_tabs_ok/hats_ok/hats_scroll_controller").set_h_scroll(current_h_scroll)
		
func control_tabs(selected_tab, next_tabs):
	if(!get_node("items_tabs_ok/" + selected_tab).is_disabled()):
		get_node("items_tabs_ok/" + selected_tab).set_disabled(true)
	
	get_node("items_tabs_ok/" + selected_tab.replace("_tab","_ok")).show()
	
	for tab in next_tabs:
		get_node("items_tabs_ok/" + tab).set_disabled(false)
		if(get_node("items_tabs_ok/" + tab.replace("_tab","_ok")).is_visible()):
			get_node("items_tabs_ok/" + tab.replace("_tab","_ok")).hide()

func _on_rush_tab_pressed():
	control_tabs("bean_rush_tab", ["hats_tab", "yellow_gift_tab", "golden_beans_tab"])

func _on_hats_tab_pressed():
	control_tabs("hats_tab", ["bean_rush_tab", "yellow_gift_tab", "golden_beans_tab"])

func _on_yellow_gift_tab_pressed():
	control_tabs("yellow_gift_tab", ["bean_rush_tab", "hats_tab", "golden_beans_tab"])
	if(!yellow_gift_popup_first_time):
		if(get_node("items_tabs_ok/yellow_gift_ok/yellow_gift_popup").is_hidden()):
			get_node("items_tabs_ok/yellow_gift_ok/yellow_gift_popup").show()
			yellow_gift_popup_first_time = true
	
func _on_golden_bean_tab_pressed():
	control_tabs("golden_beans_tab", ["bean_rush_tab", "hats_tab", "yellow_gift_tab"])

func _on_1pack_btn_pressed():
	buy_bean_rush(1,int(server.get_app_parameter("bean.rush_x1",Config.BEAN_RUSH_X1)))

func _on_2pack_btn_pressed():
	buy_bean_rush(5,int(server.get_app_parameter("bean.rush_x5",Config.BEAN_RUSH_X5)))

func _on_3pack_btn_pressed():
	buy_bean_rush(10,int(server.get_app_parameter("bean.rush_x10",Config.BEAN_RUSH_X10)))

func _on_1bean_btn_pressed():
	buy_beans(server.get_app_parameter("tiny.bean_pack_sku",Config.TINY_BEAN_PACK_SKU))
	#buy_beans(Config.TINY_BEAN_PACK_SKU)
	server.register_event("Shop Beans Pack","beans_pack","5000",{"beans":server.get_beans()})

func _on_2bean_btn_pressed():
	buy_beans(server.get_app_parameter("small.bean_pack_sku",Config.SMALL_BEAN_PACK_SKU))
	#buy_beans(Config.SMALL_BEAN_PACK_SKU)
	server.register_event("Shop Beans Pack","beans_pack","6500",{"beans":server.get_beans()})

func _on_3bean_btn_pressed():
	buy_beans(server.get_app_parameter("medium.bean_pack_sku",Config.MEDIUM_BEAN_PACK_SKU))
	#buy_beans(Config.MEDIUM_BEAN_PACK_SKU)
	server.register_event("Shop Beans Pack","beans_pack","8000",{"beans":server.get_beans()})

func _on_4bean_btn_pressed():
	buy_beans(server.get_app_parameter("big.bean_pack_sku",Config.BIG_BEAN_PACK_SKU))
	#buy_beans(Config.BIG_BEAN_PACK_SKU)
	server.register_event("Shop Beans Pack","beans_pack","9500",{"beans":server.get_beans()})
	
func _on_5bean_btn_pressed():
	buy_beans(server.get_app_parameter("huge.bean_pack_sku",Config.HUGE_BEAN_PACK_SKU))
	#buy_beans(Config.HUGE_BEAN_PACK_SKU)
	server.register_event("Shop Beans Pack","beans_pack","9500",{"beans":server.get_beans()})

func buy_beans(sku):
	server.purchase(sku,"bGoa+V7g/yqDXvKRqq+JTFn4uQZbPiQJo4pf9RzJ")
	
func consume_purchase(sku):
	emit_signal("buyed")
	if(!Config.SKU_FILTER.has(sku)):
		print("Invalid sku")
		return

	var consumable = str(Config.SKU_FILTER[sku])
	
	if(consumable.find("hat",0) != -1):
		server.set_achievement_unlocked("fashion")
		server.consume_hat(consumable.substr(4,consumable.length()))
		manage_hats()
	else:
		server.set_beans(server.get_beans() + consumable.to_int())
		get_node("bean_counter/counter").set_text(str(server.get_beans()))
		
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()
		
func buy_bean_rush(bean_rush,price):
	if(server.get_beans()>=price):
		emit_signal("buyed")
		server.set_bean_rush(server.get_bean_rush()+bean_rush)
		server.set_beans(server.get_beans() - price)
		get_node("bean_rush_counter/counter").set_text(str(server.get_bean_rush()))
		get_node("bean_counter/counter").set_text(str(server.get_beans()))
		
		if(bean_rush == 3):
			print("buyed 3 bean rushes")
			server.register_event("Shop Bean Boost x3","beanboostx3","3",{"bean_rush":server.get_bean_rush()})
		elif(bean_rush == 5):
			print("buyed 5 bean rushes")
		elif(bean_rush == 10):
			print("buyed 10 bean rushes")
				
		if(server.parse):
			server.save_cloud()
		else:
			server.save_pc()
	else:
		emit_signal("not_enough_money")

func _on_buy_yellow_gift_btn_pressed():
	buy_yellow_gift(int(server.get_app_parameter("yellow_gifts",Config.YELLOW_GIFTS)))
	
func buy_yellow_gift(price):
	if(server.get_beans()>=price):
		emit_signal("buyed")
		server.set_yellow_gift(server.get_yellow_gift() + 1)
		server.set_beans(server.get_beans() - price)
		get_node("bean_counter/counter").set_text(str(server.get_beans()))
		manage_yellow_gifts()
		server.register_event("Shop Gift","yellow_gift","1",{"yellow_gift_buy":server.get_yellow_gift()})
		
		if(server.parse):
			server.save_cloud()
		else:
			server.save_pc()
	else:
		emit_signal("not_enough_money")

func _on_bowler_hat_pressed():
	buy_hat("bowler",server.get_app_parameter("bowler.hat_sku",Config.BOWLER_HAT_SKU))

func _on_construction_hat_pressed():
	buy_hat("construction",server.get_app_parameter("construction.hat_sku",Config.CONSTRUCTION_HAT_SKU))

#func _on_nun_hat_pressed():
#	buy_hat("flying_nun",Config.TRUCKER_HAT_SKU)

func _on_top_hat_pressed():
	buy_hat("top",server.get_app_parameter("top.hat_sku",Config.TOP_HAT_SKU))

func _on_trucker_hat_pressed():
	buy_hat("trucker",server.get_app_parameter("trucker.hat_sku",Config.TRUCKER_HAT_SKU))
	
func buy_hat(hat,sku):
	#server.set_hat(hat,sku,true) Use this line to disable IAP 
	server.set_hat(hat,sku,false) 

func _on_yellow_gift_popup_close_btn_pressed():
	if(!get_node("items_tabs_ok/yellow_gift_ok/yellow_gift_popup").is_hidden()):
		get_node("items_tabs_ok/yellow_gift_ok/yellow_gift_popup").hide()

func _on_not_enough_close_btn_pressed():
	if(!get_node("not_enough_container").is_hidden()):
		get_node("not_enough_container").hide()

func _on_buy_more_beans_btn_pressed():
	if(!get_node("not_enough_container").is_hidden()):
		get_node("not_enough_container").hide()
	control_tabs("golden_beans_tab", ["bean_rush_tab", "hats_tab", "yellow_gift_tab"])


func _on_big_gift_btn_pressed():
	if(server.get_yellow_gift() > 0):
		server.set_yellow_gift(server.get_yellow_gift() - 1)
		_claim_yellow_gift()
		manage_yellow_gifts()
		server.register_event("Shop Gift Open","yellow_gift","1",{"yellow_gift_buy":server.get_yellow_gift()})
		get_node("items_tabs_ok/yellow_gift_ok/big_gift_btn/yellow_gift/porots").set_emitting(true)

func _on_golden_hat_pressed():
	buy_hat("golden",server.get_app_parameter("golden.hat_sku",Config.GOLDEN_HAT_SKU))


func _on_mexican_hat_pressed():
	buy_hat("mexican",server.get_app_parameter("mariachi.hat_sku",Config.MEXICAN_HAT_SKU))


func _on_sports_hat_pressed():
	buy_hat("sports",server.get_app_parameter("headband.hat_sku",Config.SPORTS_HAT_SKU))

func _claim_yellow_gift():
	var gift_popup = gift_preload.instance()
	var root = get_tree().get_root()
	var current_scene = root.get_child( root.get_child_count() -1 )
	if(!gift_popup.is_inside_tree()):
		current_scene.add_child(gift_popup)
		if(server.parse):
			server.save_cloud()
		else:
			server.save_pc()

func _on_watch_ad_pressed():
	if(!get_node("not_enough_container").is_hidden()):
		get_node("not_enough_container").hide()
	
	server.show_ad(server.get_app_parameter("No_money_rewarded_ad" + "_" + OS.get_name(),Config.get_zone("No_money_rewarded_ad" + "_" + OS.get_name())),{})