
extends TextureFrame

# member variables here, example:
# var a=2
# var b="textvar"

var current_h_scroll = 0 
var server = null
var Config = preload("res://global/config.gd")
var initialized = false

func popup_shop():
	if(!initialized):
		initialized = true
		server = get_node("/root/gamestate")
		get_node("beans_scroll").get_node("_h_scroll").set_opacity(0)
		server.connect("consume_successfull",self,"consume_purchase")
		get_node("beans_scroll").set_h_scroll(0)
		
		get_node("beans_scroll/golden_beans/golden_bean_pack_1/golden_bean_pack_1_btn/amount").set_text(str(server.get_app_parameter("tiny.bean_pack",Config.TINY_BEAN_PACK)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_ 2/golden_bean_pack_2_btn/amount").set_text(str(server.get_app_parameter("small.bean_pack",Config.SMALL_BEAN_PACK)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_ 3/golden_bean_pack_3_btn/amount").set_text(str(server.get_app_parameter("medium.bean_pack",Config.MEDIUM_BEAN_PACK)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_ 4/golden_bean_pack_4_btn/amount").set_text(str(server.get_app_parameter("big.bean_pack",Config.BIG_BEAN_PACK)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_5/golden_bean_pack_5_btn/amount").set_text(str(server.get_app_parameter("huge.bean_pack",Config.HUGE_BEAN_PACK)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_1/golden_bean_pack_1_btn/price").set_text(str(server.get_app_parameter("tiny.bean_pack.price",Config.TINY_BEAN_PACK_PRICE)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_ 2/golden_bean_pack_2_btn/price").set_text(str(server.get_app_parameter("small.bean_pack.price",Config.SMALL_BEAN_PACK_PRICE)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_ 3/golden_bean_pack_3_btn/price").set_text(str(server.get_app_parameter("medium.bean_pack.price",Config.MEDIUM_BEAN_PACK_PRICE)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_ 4/golden_bean_pack_4_btn/price").set_text(str(server.get_app_parameter("big.bean_pack.price",Config.BIG_BEAN_PACK_PRICE)))
		get_node("beans_scroll/golden_beans/golden_bean_pack_5/golden_bean_pack_5_btn/price").set_text(str(server.get_app_parameter("huge.bean_pack.price",Config.HUGE_BEAN_PACK_PRICE)))


	#server.show_ad(server.get_app_parameter("Popup_shop_rewarded_ad" + "_" + OS.get_name(),Config.get_zone("Popup_shop_rewarded_ad" + "_" + OS.get_name())),{})
	show()


func _on_right_arrow_pressed():
	manage_arrow_btn("right")


func _on_left_arrow_pressed():
	manage_arrow_btn("left")


func _on_back_btn_pressed():
	if(!self.is_hidden()):
		self.hide()


func _on_golden_bean_pack_1_btn_pressed():
	buy_beans(server.get_app_parameter("tiny.bean_pack_sku",Config.TINY_BEAN_PACK_SKU))
	#buy_beans(Config.TINY_BEAN_PACK_SKU)
	server.log_event("shop.iap_beans_tiny_pack",{"beans":server.get_beans()})
	server.register_event("Shop Beans Pack","beans_pack","5000",{"beans":server.get_beans()})


func _on_golden_bean_pack_2_btn_pressed():
	buy_beans(server.get_app_parameter("small.bean_pack_sku",Config.SMALL_BEAN_PACK_SKU))
	#buy_beans(Config.SMALL_BEAN_PACK_SKU)
	server.log_event("shop.iap_beans_small_pack",{"beans":server.get_beans()})
	server.register_event("Shop Beans Pack","beans_pack","6500",{"beans":server.get_beans()})


func _on_golden_bean_pack_3_btn_pressed():
	buy_beans(server.get_app_parameter("medium.bean_pack_sku",Config.MEDIUM_BEAN_PACK_SKU))
	#buy_beans(Config.MEDIUM_BEAN_PACK_SKU)
	server.log_event("shop.iap_beans_medium_pack",{"beans":server.get_beans()})
	server.register_event("Shop Beans Pack","beans_pack","8000",{"beans":server.get_beans()})


func _on_golden_bean_pack_4_btn_pressed():
	buy_beans(server.get_app_parameter("big.bean_pack_sku",Config.BIG_BEAN_PACK_SKU))
	#buy_beans(Config.BIG_BEAN_PACK_SKU)
	server.log_event("shop.iap_beans_big_pack",{"beans":server.get_beans()})
	server.register_event("Shop Beans Pack","beans_pack","9500",{"beans":server.get_beans()})

func _on_golden_bean_pack_5_btn_pressed():
	buy_beans(server.get_app_parameter("huge.bean_pack_sku",Config.HUGE_BEAN_PACK_SKU))
	#buy_beans(Config.HUGE_BEAN_PACK_SKU)
	server.log_event("shop.iap_beans_huge_pack",{"beans":server.get_beans()})
	server.register_event("Shop Beans Pack","beans_pack","9500",{"beans":server.get_beans()})

func buy_beans(sku):
	server.purchase(sku,"bGoa+V7g/yqDXvKRqq+JTFn4uQZbPiQJo4pf9RzJ")
	
func consume_purchase(sku):
	if(!Config.SKU_FILTER.has(sku)):
		print("Invalid sku")
		return

	var consumable = str(Config.SKU_FILTER[sku])
	
	if(consumable.find("hat",0) != -1):
		print("Invalid sku")
		return
	else:
		server.set_beans(server.get_beans() + consumable.to_int())
		
	if(server.parse):
		server.save_cloud()
	else:
		server.save_pc()

func manage_arrow_btn(direction):
	var scroll_size = (get_node("beans_scroll/golden_beans/golden_bean_pack_1").get_size().x * 2) + 95
	var last_scroll = get_node("beans_scroll/golden_beans/golden_bean_pack_1").get_size().x + 95

	var MAX_SCROLL_SIZE = scroll_size * ((get_node("beans_scroll/golden_beans").get_child_count() / 2) - 1)
	
	if(direction == "right"):
		if(current_h_scroll < MAX_SCROLL_SIZE):
			current_h_scroll += scroll_size
		elif(current_h_scroll < (MAX_SCROLL_SIZE + last_scroll)):
			current_h_scroll += last_scroll

	elif(direction == "left"):
		var node_scroll = get_node("beans_scroll").get_h_scroll() 
		if(node_scroll > MAX_SCROLL_SIZE):
			current_h_scroll -= last_scroll
		elif(node_scroll > 0):
			if((current_h_scroll - scroll_size) >= 0):
				current_h_scroll -= scroll_size
			else:
				current_h_scroll = 0
	
	get_node("beans_scroll").set_h_scroll(current_h_scroll)
