
extends TextureFrame

var shufflebag
var server
var Config = preload("res://global/config.gd")
var Hats = preload("res://screens/shop_v2/shopv2_hats_textures.gd")
var bean = preload("res://screens/shop_v2/assets/bean_item.png")

class ShuffleBag extends Control:
	var gift_frequency = {}					
	var items = []

	func _init(gstate):
		print("creating")
		### DEPRECATED !!!
		#gift_frequency = {"100_beans":float(gstate.get_app_parameter("yg_100.beans","10")),
		#			  "200_beans":float(gstate.get_app_parameter("yg_200.beans","10")),
		#			  "300_beans":float(gstate.get_app_parameter("yg_300.beans","15")),
		#			  "400_beans":float(gstate.get_app_parameter("yg_400.beans","20")),
		#			  "500_beans":float(gstate.get_app_parameter("yg_500.beans","20")),
		#			  "600_beans":float(gstate.get_app_parameter("yg_600.beans","12")),
		#			  "750_beans":float(gstate.get_app_parameter("yg_750.beans","10")),
		#			  "3000_beans":float(gstate.get_app_parameter("yg_3000.beans","2.89")),
		#			  "10000_beans":float(gstate.get_app_parameter("yg_10000.beans","0.1")),
		#			  "hat":float(gstate.get_app_parameter("yg_hat","1")),
		#			  "1000000_beans":float(gstate.get_app_parameter("yg_1millon.beans","0.01"))}
		
		var gift_frequency = {"tier2":10,
							  "tier3":90}
		
		var dir = Directory.new()
		
		if dir.file_exists("user://shufflebag.bin"):
			dir.remove("user://shufflebag.bin")
		
		var file = File.new()
		if(file.file_exists("user://shufflebag_new.bin")):
			var err = file.open_encrypted_with_pass("user://shufflebag_new.bin",File.READ,OS.get_unique_ID())
			if(err != -1):
				if(file.get_len() > 0):
					items = file.get_var()
					#print("getting shufflebag from file : ", items)
				else:
					print("file is empty")
				file.close()
		else:
			var keys = gift_frequency.keys()
			print("setting up")
			for i in range(keys.size()):
				var amount = gift_frequency[keys[i]] * 5
				add(keys[i],amount)
				
			var err = file.open_encrypted_with_pass("user://shufflebag_new.bin",File.WRITE,OS.get_unique_ID())
			if(err != -1):
				file.store_var(items)
				print("saving Shuffle Bag for the first time")
				file.close()
		
	var currentPosition = -1
	var currentItem

	func add(item,amount):
		for i in range(amount):
			items.append(item)
		
		currentPosition = items.size() - 1
	
	func randomize_bag():
		var current
		var last_item = items.size()
		for i in range(items.size()):
			last_item -= 1
			if(last_item >= 1):
				var pos = randi() % last_item
				
				current = items[pos]
				items[pos] = items[last_item]
				items[last_item] = current
		
		#print("randomized bag : ", items)
	
	func next():
		if(currentPosition < 1):
			currentPosition = items.size() - 1
			currentItem = items[0]
			return currentItem
			
		var pos = randi() % currentPosition
		currentItem = items[pos]
		items[pos] = items[currentPosition]
		items[currentPosition] = currentItem
		items.remove(currentPosition)
		currentPosition -= 1
		
		return currentItem
		
	func removeOccurences(occurrence):
		for i in range(items.size()):
			if(items[i] == occurrence):
				items.remove(i)
				
	func update_BAG():
		var file = File.new()
		var err = file.open_encrypted_with_pass("user://shufflebag_new.bin",File.WRITE,OS.get_unique_ID())
		if(err != -1):
			file.store_var(items)
			print("Updating Shuffle BAG")
			file.close()
						
func _ready():
	server = get_node("/root/gamestate")
	shufflebag = ShuffleBag.new(server);
	shufflebag.randomize_bag()
	open_bag()
	add_user_signal("gift_popup_closed")

func open_bag():
	get_node("cont/gift_container/gift/anim").play("open")
	
	var item = shufflebag.next()
	var hats = server.get_hats()
	var keys = hats.keys()
	var items = []
	
	for k in Config.HATS_FILTER:
		if Config.HATS_FILTER[k] == item:
			items.push_back(k)
	
	var gift = items[randi()%items.size()]
	
	for i in range(keys.size()):
		if keys[i].find(gift) != -1:
			if(hats[keys[i]] == "unequip" || hats[keys[i]] == "equip"):
				var beans = 0
				if item == "tier2":
					beans = 600
				else:
					beans = 50
				
				get_node("cont/gift_container/gift/hat").set_texture(bean)
				get_node("cont/desc/Label").set_text(tr("YSHOP_GIFT_BEANS_DESC").replace("[BEANS_XX]",str(beans)))
				server.set_beans(server.get_beans() + beans)
				server.log_event("earn_virtual_currency",{"virtual_currency":"beans",
		  		  	  	  						  		  "item":"virtual_box",
		  		  	  	  						  		  "value":str(beans)})
			else:
				var hat = keys[i]
				if(hat == "mexican"):
					hat = "mariachi"
				elif(hat == "sports"):
					hat = "basketball"
					
				for texture in Hats.TEXTURES:
					if texture.get_name().find(hat) != -1:
						get_node("cont/gift_container/gift/hat").set_texture(texture)
					
				if hat == "basketball":
					hat = "headband"
				
				server.set_gift_hat(keys[i])
					
				get_node("cont/desc/Label").set_text(tr("YSHOP_GIFT_HAT_DESC").replace("[HAT_NAME]",tr(hat+"_hat")))
				server.log_event("earn_virtual_currency",{"virtual_currency":"hat",
		  		  	  	  						  		  "item":"virtual_box",
		  		  	  	  						  		  "value":hat})
	
	server.received_gift()
	var pos = get_node("cont/continue_btn/text").get_pos()
	get_node("cont/continue_btn/text").set_pos(Vector2(pos.x - 10, pos.y))
	get_node("cont/continue_btn/text").set_text(tr("RED_CONTINUE"))
	shufflebag.update_BAG()

func _on_continue_btn_pressed():
	if(get_node("cont/continue_btn/text").get_text() == tr("RED_CONTINUE")):
		emit_signal("gift_popup_closed")
		self.queue_free()
	pass # replace with function body
