extends TextureFrame

# class member variables go here, for example:
# var a = 2
# var b = "textvar"
var Config = preload("res://global/config.gd")
var android_po = preload("res://screens/shop_v2/owned_ts.scn")
var gstate = null
var came_from_menu = false

func _ready():
	# Called every time the node is added to the scene.
	# Initialization here
	gstate = get_node("/root/gamestate")
	gstate.connect("received_product_info",self,"update_pc")
	gstate.connect("purchase_owned",self,"po")
	if(!get_node("/root/globals").megasale_ok):
		self.set_process(true)
	pass

func _process(delta):
	if(get_node("/root/globals").megasale_ok):
		self.set_process(false)
		return
		
	var secsleft = int(gstate.get_seconds_left())
	
	var hr 
	if((secsleft/3600) < 10):
		hr = "0" + str(secsleft/3600)
	else:
		hr = secsleft/3600
	
	var mins
	if((secsleft/60)%60 < 10):
		mins = "0" + str((secsleft/60)%60)
	else:
		mins = (secsleft/60)%60
		
	var secs
	if((secsleft%60) < 10):
		secs = "0" + str(secsleft%60)
	else:
		secs = secsleft%60
		
	var txt = str(hr,":",mins,":",secs)
	get_node("timer/time").set_text(txt)

func update_pc():
	var pc = gstate.get_iap_info(Config.MEGASALE_SKU)
	if(pc):
		get_node("container/buy_btn/desc").set_text(pc)
	
func _on_buy_btn_pressed():
	get_node("/root/gamestate").purchase(Config.MEGASALE_SKU,"")
	if(!gstate.billing && !gstate.InAppStore):
		gstate.purchase_success("","",Config.MEGASALE_SKU)

func po():
	var powned = android_po.instance()
	
	if !powned.is_inside_tree():
		self.add_child(powned)

func _on_back_btn_pressed():
	if(!self.is_hidden()):
		self.hide()
	
	if(came_from_menu):
		came_from_menu = false
		if(!self.get_parent().is_hidden()):
			self.get_parent().hide()
	pass # replace with function body
