extends TextureFrame

# class member variables go here, for example:
# var a = 2
# var b = "textvar"
var gstate = null
var Config = preload("res://global/config.gd")
var Hats = preload("res://screens/shop_v2/shopv2_hats_textures.gd")
var android_po = preload("res://screens/shop_v2/owned_ts.scn")
var hats_index = Hats.Index.new()
var gift_preload = preload("res://screens/main_menu/yellow_red_gifts/gifts_popup.scn")
var went_right = false
var went_left = true
var current_hat_sku = null
var hat = null
var current_node = null
var original_pos = Vector2(0,0)

var SKUS = {"bowler":Config.BOWLER_HAT_SKU,
			"golden_tophat":Config.GOLDEN_HAT_SKU,
			"mariachi":Config.MEXICAN_HAT_SKU,
			"top":Config.TOP_HAT_SKU,
			"trucker":Config.TRUCKER_HAT_SKU,
			"basketball":Config.SPORTS_HAT_SKU,
			"construction":Config.CONSTRUCTION_HAT_SKU,
			"admiral":Config.ADMIRAL_HAT_SKU,
			"beret":Config.BERET_HAT_SKU,
			"beanie":Config.BEANNIE_HAT_SKU,
			"boater":Config.BOATER_HAT_SKU,
			"conical":Config.CONICAL_HAT_SKU,
			"chef":Config.COOK_HAT_SKU,
			"cowboy":Config.COWBOY_HAT_SKU,
			"crown":Config.CROWN_HAT_SKU,
			"explorer":Config.EXPLORER_HAT_SKU,
			"fedora":Config.FEDORA_HAT_SKU,
			"flat":Config.FLAT_HAT_SKU,
			"fruit":Config.FRUITS_HAT_SKU,
			"police":Config.LONDON_POLICE_HAT_SKU,
			"mortar":Config.MORTER_HAT_SKU,
			"paper":Config.PAPER_HAT_SKU,
			"party":Config.PARTY_HAT_SKU,
			"pilgrim":Config.PILGRIM_HAT_SKU,
			"propeller":Config.PROPELLER_HAT_SKU,
			"racoon":Config.RACOON_HAT_SKU,
			"umbrella":Config.UMBRELLA_HAT_SKU,
			"bucket":Config.BUCKET_HAT_SKU}

func _ready():
	gstate = get_node("/root/gamestate")
	set_process(true)
	set_fixed_process(true)
	get_node("beans_ok/container").get_node("_h_scroll").set_opacity(0)
	get_node("beans_counter_btn/x_beans").set_text(str(gstate.get_beans()))
	update_ygift_button()
	set_hats_textures()
	set_current_hat()
	get_node("hats_ok/hats_vbox/hats/anim").connect("finished",self,"enable_arrow")
	get_node("hats_ok/hats_vbox/hats/anim").connect("finished",self,"set_current_hat")
	gstate.connect("hat_consumed",self,"update_hat_btn_txt")
	gstate.connect("consume_successfull", self, "add_beans")
	gstate.connect("receivedGift",self,"update_items_from_gift")
	gstate.connect("buyed_megasale",self,"hide_megasale")
	gstate.connect("purchase_owned",self,"po")
	gstate.connect("sync_ok",self,"sync_ui")
	if(get_node("/root/globals").megasale_ok):
		hide_megasale()

func sync_ui():
	update_ygift_button()
	set_current_hat()

func hide_megasale():
	get_node("anim").play("center")
	get_node("Desc").hide()
	if(!get_node("shop_ok/ButtonsCont/megasale_page_btn").is_hidden()):
		get_node("shop_ok/ButtonsCont/megasale_page_btn").hide()
			
func _fixed_process(delta):
	if int(get_node("beans_counter_btn/x_beans").get_text()) < gstate.get_beans():
		get_node("beans_counter_btn/x_beans").set_text(str(gstate.get_beans()))

func _process(delta):
	if(get_node("hats_ok/bean_hat_anim").get_current_animation() == "equip" &&
	   get_node("hats_ok/bean_hat_anim").is_playing()):
		var texture_diff_h = 160 - current_node.get_texture().get_height()
		var x_offset = 0
		var y_offset = 0
		
		if(current_node.get_texture().get_name().find("trucker") != -1):
			x_offset += 50.6
			y_offset += 0.02
		if(current_node.get_texture().get_name().find("basketball") != -1):
			if(current_node.get_scale() > Vector2(0.52,0.52)):
				current_node.set_scale(current_node.get_scale() - Vector2(0.009,0.009))
			x_offset += 50.8
			y_offset += 1.1
			texture_diff_h += 15
		if(current_node.get_texture().get_name().find("construction") != -1):
			if(current_node.get_scale() > Vector2(0.68,0.68)):
				current_node.set_scale(current_node.get_scale() - Vector2(0.009,0.009))
			x_offset += 50.7
			texture_diff_h += 20
		if(current_node.get_texture().get_name().find("conical") != -1 ||
		     current_node.get_texture().get_name().find("umbrella")):
			texture_diff_h += 8.5
		if(current_node.get_texture().get_name().find("chef") != -1):
			texture_diff_h += 20
		if(current_node.get_texture().get_name().find("crown") != -1):
			texture_diff_h += 7
		if(current_node.get_texture().get_name().find("racoon") != -1):
			texture_diff_h += 70
			
		var desired_pos_y = int(get_node("hats_ok/hats_vbox/arrows/desc/bean").get_global_pos().y - y_offset -
							  get_node("hats_ok/hats_vbox/arrows/desc/bean").get_texture().get_height() / 2.35)		
		
		if(current_node.get_global_pos().y - texture_diff_h  >= desired_pos_y):
			current_node.set_global_pos(Vector2(current_node.get_global_pos().x + delta * x_offset,
										current_node.get_global_pos().y - delta * 100 - y_offset))
		else:
			current_node.set_global_pos(Vector2(current_node.get_global_pos().x + delta * x_offset,
										current_node.get_global_pos().y + delta * 100 + y_offset))

	if(get_node("/root/globals").megasale_ok):
		return
	
	if(gstate.get_seconds_left() == -1):
		if(!get_node("shop_ok/ButtonsCont/megasale_page_btn").is_disabled()):
			get_node("shop_ok/ButtonsCont/megasale_page_btn").set_disabled(true)
			get_node("shop_ok/ButtonsCont/megasale_page_btn").set_opacity(0.5)
			if(!get_node("shop_ok/ButtonsCont/megasale_page_btn/timer_cont").is_hidden()):
				get_node("shop_ok/ButtonsCont/megasale_page_btn/timer_cont").hide()
	else:
		if(get_node("shop_ok/ButtonsCont/megasale_page_btn").is_disabled()):
			get_node("shop_ok/ButtonsCont/megasale_page_btn").set_disabled(false)
			get_node("shop_ok/ButtonsCont/megasale_page_btn").set_opacity(1)
			if(get_node("shop_ok/ButtonsCont/megasale_page_btn/timer_cont").is_hidden()):
				get_node("shop_ok/ButtonsCont/megasale_page_btn/timer_cont").show()
		var secsleft = int(gstate.get_seconds_left())
		
		var hr 
		if((secsleft/3600) < 10):
			hr = "0" + str(secsleft/3600)
		else:
			hr = secsleft/3600
		
		var mins
		if((secsleft/60)%60 < 10):
			mins = "0" + str((secsleft/60)%60)
		else:
			mins = (secsleft/60)%60
			
		var secs
		if((secsleft%60) < 10):
			secs = "0" + str(secsleft%60)
		else:
			secs = secsleft%60
			
		var txt = str(hr,":",mins,":",secs)
		get_node("shop_ok/ButtonsCont/megasale_page_btn/timer_cont/txt").set_text(txt)
	
func add_beans(sku):
	if(sku == Config.TINY_BEAN_PACK_SKU):
		gstate.set_beans(gstate.get_beans() + int(gstate.get_app_parameter("tiny.bean_pack",Config.TINY_BEAN_PACK)))
		log_buybeans_event(Config.TINY_BEAN_PACK_SKU,float(gstate.get_app_parameter("tiny.bean_pack",Config.TINY_BEAN_PACK)))
	elif(sku == Config.SMALL_BEAN_PACK_SKU):
		gstate.set_beans(gstate.get_beans() + float(gstate.get_app_parameter("small.bean_pack",Config.SMALL_BEAN_PACK)))
		log_buybeans_event(Config.SMALL_BEAN_PACK_SKU,float(gstate.get_app_parameter("small.bean_pack",Config.SMALL_BEAN_PACK)))
	elif(sku == Config.MEDIUM_BEAN_PACK_SKU):
		gstate.set_beans(gstate.get_beans() + float(gstate.get_app_parameter("medium.bean_pack",Config.MEDIUM_BEAN_PACK)))
		log_buybeans_event(Config.MEDIUM_BEAN_PACK_SKU,float(gstate.get_app_parameter("medium.bean_pack",Config.MEDIUM_BEAN_PACK)))
	elif(sku == Config.BIG_BEAN_PACK_SKU):
		gstate.set_beans(gstate.get_beans() + float(gstate.get_app_parameter("huge.bean_pack",Config.BIG_BEAN_PACK)))
		log_buybeans_event(Config.BIG_BEAN_PACK_SKU,float(gstate.get_app_parameter("huge.bean_pack",Config.BIG_BEAN_PACK)))
	elif(sku == Config.HUGE_BEAN_PACK_SKU):
		gstate.set_beans(gstate.get_beans() + float(gstate.get_app_parameter("full.bean_pack",Config.HUGE_BEAN_PACK)))
		log_buybeans_event(Config.HUGE_BEAN_PACK_SKU,float(gstate.get_app_parameter("full.bean_pack",Config.HUGE_BEAN_PACK)))
	
	get_node("beans_counter_btn/x_beans").set_text(str(gstate.get_beans()))

func log_buybeans_event(sku,val):
	gstate.log_event("earn_virtual_currency",{"virtual_currency":"beans",
			  		  						  "item":sku,
			  		  						  "value":str(val)})

func update_items_from_gift():
	get_node("beans_counter_btn/x_beans").set_text(str(gstate.get_beans()))

func update_ygift_button():
	if(gstate.get_yellow_gift() > 0):
		if(get_node("hats_ok/ygift_yes").is_hidden()):
			get_node("hats_ok/ygift_yes").show()
		if(!get_node("hats_ok/ygift_no").is_hidden()):
			get_node("hats_ok/ygift_no").hide()
		get_node("hats_ok/ygift_yes/count").set_text(str(gstate.get_yellow_gift()))
		get_node("shop_ok/ButtonsCont/hats_page_btn/_counter/number").set_text(str(gstate.get_yellow_gift()))
		if(get_node("shop_ok/ButtonsCont/hats_page_btn/_counter").is_hidden()):
			get_node("shop_ok/ButtonsCont/hats_page_btn/_counter").show()
	else:
		if(!get_node("hats_ok/ygift_yes").is_hidden()):
			get_node("hats_ok/ygift_yes").hide()
		if(get_node("hats_ok/ygift_no").is_hidden()):
			get_node("hats_ok/ygift_no").show()
		if(!get_node("shop_ok/ButtonsCont/hats_page_btn/_counter").is_hidden()):
			get_node("shop_ok/ButtonsCont/hats_page_btn/_counter").hide()

func _on_beans_page_btn_pressed():
	if(gstate.get_iap_info(Config.TINY_BEAN_PACK_SKU)):
		get_node("beans_ok/container/HBox/spoon_beans_btn/btn/pc").set_text(gstate.get_iap_info(Config.TINY_BEAN_PACK_SKU))
	if(gstate.get_iap_info(Config.SMALL_BEAN_PACK_SKU)):
		get_node("beans_ok/container/HBox/can_beans_btn/btn/pc").set_text(gstate.get_iap_info(Config.SMALL_BEAN_PACK_SKU))
	if(gstate.get_iap_info(Config.MEDIUM_BEAN_PACK_SKU)):
		get_node("beans_ok/container/HBox/bag_beans_btn/btn/pc").set_text(gstate.get_iap_info(Config.MEDIUM_BEAN_PACK_SKU))
	if(gstate.get_iap_info(Config.BIG_BEAN_PACK_SKU)):
		get_node("beans_ok/container/HBox/case_beans_btn/btn/pc").set_text(gstate.get_iap_info(Config.BIG_BEAN_PACK_SKU))
	if(gstate.get_iap_info(Config.HUGE_BEAN_PACK_SKU)):
		get_node("beans_ok/container/HBox/full_beans_btn/btn/pc").set_text(gstate.get_iap_info(Config.HUGE_BEAN_PACK_SKU))
		
	get_node("title").set_text("BEANS")
	get_node("shop_ok").hide()
	get_node("Desc").hide()
	if(get_node("beans_ok").is_hidden()):
		get_node("beans_ok").show()

func _on_hats_page_btn_pressed():
	get_node("title").set_text("HATS")
	get_node("shop_ok").hide()
	get_node("Desc").hide()
	if(get_node("hats_ok").is_hidden()):
		get_node("hats_ok").show()

func _on_megasale_page_btn_pressed():
	if(get_node("megasale").is_hidden()):
		get_node("megasale").show()
		get_node("megasale").update_pc()
	pass # replace with function body

func _on_beans_counter_btn_pressed():
	if(!get_node("hats_ok").is_hidden()):
		get_node("hats_ok").hide()
	_on_beans_page_btn_pressed()


func _on_back_btn_pressed():
	get_node("title").set_text("SHOP")
	if(!get_node("shop_ok").is_hidden()):
		self.hide()
		if self.get_parent().get_name() == "world_map":
			self.get_parent().get_node("bg/levels/mexico").set_z(0)
		
		if(self.get_parent().get_name() != "world_map" &&
		   self.get_parent().get_name() != "levelselect" ):
			self.get_parent().update_ygifts_count()
		return
	elif(!get_node("beans_ok").is_hidden()):
		get_node("beans_ok").hide()
	elif(!get_node("hats_ok").is_hidden()):
		get_node("hats_ok").hide()
		
	get_node("shop_ok").show()
	
	if(!get_node("/root/globals").megasale_ok):
		get_node("Desc").show()

func _on_ygift_btn_pressed():
	if(gstate.get_yellow_gift() > 0):
		gstate.set_yellow_gift(gstate.get_yellow_gift() - 1)
	
	update_ygift_button()
	var gift_popup = gift_preload.instance()
	var root = get_tree().get_root()
	var current_scene = root.get_child( root.get_child_count() -1 )
	if(!gift_popup.is_inside_tree()):
		current_scene.add_child(gift_popup)

func _on_buy_yg_btn_pressed():
	buy_yellow_gift(int(gstate.get_app_parameter("yellow_gifts",Config.YELLOW_GIFTS)))
	
func buy_yellow_gift(price):
	if(gstate.get_beans()>=price):
		emit_signal("buyed")
		gstate.set_yellow_gift(gstate.get_yellow_gift() + 1)
		gstate.set_beans(gstate.get_beans() - price)
		get_node("beans_counter_btn/x_beans").set_text(str(gstate.get_beans()))
		get_node("hats_ok/ygift_yes/count").set_text(str(gstate.get_yellow_gift()))
		update_ygift_button()
		gstate.log_event("spend_virtual_currency",{"virtual_currency":"beans",
						  						   "item":"virtual_box",
						  						   "value":str(price)})
	else:
		if(get_node("hats_ok/not_enough_container").is_hidden()):
			get_node("hats_ok/not_enough_container").show()

func set_hats_textures():
	var idx = get_node("hats_ok/hats_vbox/hats").get_child_count() - 1
	if(Hats.TEXTURES.size() < idx):
		print("INVALID TEXTURES ARRAY ....")
		return
	
	for i in range(idx):
		get_node("hats_ok/hats_vbox/hats/hat"+str(i)).set_texture(Hats.TEXTURES[i])
	
	#hats_index.set_idx("right")

func update_hat_textures(direction):
	if get_node("hats_ok/hats_vbox/hats").is_draw_behind_parent_enabled():
		get_node("hats_ok/hats_vbox/hats").set_draw_behind_parent(false)
	
	var idx = get_node("hats_ok/hats_vbox/hats").get_child_count() - 1
	var next = null
	
	if(direction == "left"):
		for i in range(idx):
			if(i+1 < idx):
				next = get_node("hats_ok/hats_vbox/hats/hat"+str(i+1)).get_texture()
			else:
				var h5_t = get_node("hats_ok/hats_vbox/hats/hat5").get_texture()
				hats_index.set_idx(h5_t,"right")
				next = Hats.TEXTURES[hats_index.get_idx()]
			get_node("hats_ok/hats_vbox/hats/hat"+str(i)).set_texture(next)
	elif(direction == "right"):
		for i in range(idx-1, -1, -1):
			if(i > 0):
				next = get_node("hats_ok/hats_vbox/hats/hat"+str(i-1)).get_texture()
			else:
				var h0_t = get_node("hats_ok/hats_vbox/hats/hat0").get_texture()
				hats_index.set_idx(h0_t,"left")
				next = Hats.TEXTURES[hats_index.get_idx()]
			get_node("hats_ok/hats_vbox/hats/hat"+str(i)).set_texture(next)

func enable_arrow():
	if(get_node("hats_ok/hats_vbox/arrows/right_btn").is_disabled()):
		get_node("hats_ok/hats_vbox/arrows/right_btn").set_disabled(false)
	if(get_node("hats_ok/hats_vbox/arrows/left_btn").is_disabled()):
		get_node("hats_ok/hats_vbox/arrows/left_btn").set_disabled(false)

func set_current_hat():
	var keys = SKUS.keys()
	if(went_left):
		current_node = get_node("hats_ok/hats_vbox/hats/hat3")
	else:
		current_node = get_node("hats_ok/hats_vbox/hats/hat2")
	
	for i in range(keys.size()):
		if(current_node.get_texture().get_name().find(keys[i]) != -1):
			current_hat_sku = SKUS[keys[i]]
	
	hat = current_hat_sku.substr(0,current_hat_sku.find("_hat",0))
	if(hat == "mariachi"):
		hat = "mexican"
	elif(hat == "headband"):
		hat = "sports"
	elif(hat == "gold"):
		hat = "golden"
	
	var pc = gstate.get_hat_price(hat, current_hat_sku)
	
	get_node("hats_ok/hats_vbox/arrows/desc/hat_name").set_text(tr(current_hat_sku))
	get_node("hats_ok/hats_vbox/arrows/desc/hat_DESC").set_text(tr(current_hat_sku+"_desc"))
	if(pc):
		get_node("hats_ok/hats_vbox/arrows/desc/hat_equip_btn/txt").set_text(pc)
	else:
		get_node("hats_ok/hats_vbox/arrows/desc/hat_equip_btn/txt").set_text(tr(gstate.get_hat_val(hat)))
		if gstate.get_hat_val(hat) == "unequip":
			get_node("hats_ok/bean_hat_anim").play("equip")
	
func _on_left_btn_pressed():
	if !get_node("hats_ok/hats_vbox/arrows/desc/bean").is_hidden():
		get_node("hats_ok/bean_hat_anim").play("hide")
		
	get_node("hats_ok/hats_vbox/hats/anim").play_backwards("move")
	get_node("hats_ok/hats_vbox/arrows/left_btn").set_disabled(true)
	if(!went_left):
		update_hat_textures("right")
	else:
		went_left = false
		went_right = true

func _on_right_btn_pressed():
	if !get_node("hats_ok/hats_vbox/arrows/desc/bean").is_hidden():
		get_node("hats_ok/bean_hat_anim").play("hide")
		
	get_node("hats_ok/hats_vbox/hats/anim").play("move")
	get_node("hats_ok/hats_vbox/arrows/right_btn").set_disabled(true)
	if(!went_right):
		update_hat_textures("left")
	else:
		went_right = false
		went_left = true
		
func update_hat_btn_txt():
	var val = gstate.get_hat_val(hat)
	get_node("hats_ok/hats_vbox/arrows/desc/hat_equip_btn/txt").set_text(tr(val))
	
func _on_hat_equip_btn_pressed():
	if(gstate.get_hat_price(hat,current_hat_sku)):
		gstate.purchase(current_hat_sku,"")
		if(!gstate.billing && !gstate.InAppStore):
			gstate.purchase_success("","",current_hat_sku)
	else:
		var node = get_node("hats_ok/hats_vbox/arrows/desc/hat_equip_btn/txt")
		if(node.get_text() == tr("equip")):
			gstate.set_hat(hat,"equip")
			original_pos = current_node.get_global_pos()
			if(hat == "conical" || hat == "umbrella"):
				get_node("hats_ok/hats_vbox/hats").set_draw_behind_parent(true)
			get_node("hats_ok/bean_hat_anim").play("equip")
		elif(node.get_text() == tr("unequip")):
			get_node("hats_ok/bean_hat_anim").play("unequip")
			if(hat == "conical" || hat == "umbrella"):
				get_node("hats_ok/hats_vbox/hats").set_draw_behind_parent(false)
			if(original_pos != Vector2(0,0)):
				current_node.set_global_pos(original_pos)
			if(current_node.get_scale() < Vector2(0.85,0.85)):
				current_node.set_scale(Vector2(0.85,0.85))
			gstate.set_hat(hat,"unequip")
			
		var val = gstate.get_hat_val(hat)
		node.set_text(tr(val))

func _on_btn_pressed():
	if(get_node("beans_ok/container/HBox/spoon_beans_btn/btn").is_pressed()):
		gstate.purchase(Config.TINY_BEAN_PACK_SKU,"")
	elif(get_node("beans_ok/container/HBox/can_beans_btn/btn").is_pressed()):
		gstate.purchase(Config.SMALL_BEAN_PACK_SKU,"")
	elif(get_node("beans_ok/container/HBox/bag_beans_btn/btn").is_pressed()):
		gstate.purchase(Config.MEDIUM_BEAN_PACK_SKU,"")
	elif(get_node("beans_ok/container/HBox/case_beans_btn/btn").is_pressed()):
		gstate.purchase(Config.BIG_BEAN_PACK_SKU,"")
	elif(get_node("beans_ok/container/HBox/full_beans_btn/btn").is_pressed()):
		gstate.purchase(Config.HUGE_BEAN_PACK_SKU,"")
		
func po():
	if !get_node("megasale").is_hidden():
		return
	
	var powned = android_po.instance()
	self.add_child(powned)
