
extends Control

# member variables here, example:
# var a=2
# var b="textvar"

var Config = preload("res://global/config.gd")

var gstate=null

#var unlock_bean_cost=2000
 
var unlocked=1
var enabled=4
var current=0

var country_names=[tr("CS_TITLE_UK"),tr("CS_TITLE_INDIA"),tr("CS_TITLE_JAPAN"),tr("CS_TITLE_AUS"),tr("CS_TITLE_MEX"),tr("CS_TITLE_US")]
var gift_preload = preload("res://screens/main_menu/yellow_red_gifts/red_gift_popup.scn")
var endless_bg = load("res://screens/world_map2/wm_bg_endless.png")
var story_bg = load("res://screens/world_map2/world map_6-8_1280x720.png")



func _claim_red_gift():
	if (gstate.has_red_gift()):
		var gift_popup = gift_preload.instance()
		var root = get_tree().get_root()
		var current_scene = root.get_child( root.get_child_count() -1 )
		if(!gift_popup.is_inside_tree()):
			current_scene.add_child(gift_popup)
			gstate.claim_red_gift()
			if(gstate.parse):
				gstate.save_cloud()
			else:
				gstate.save_pc()	
			


func _enable_new_country():
	gstate.clear_plane()
	
	
	if(gstate.parse):
		gstate.save_cloud()
	else:
		gstate.save_pc()	
		
func _update_texts():

	if (get_node("/root/globals").endless_mode):
		get_node("bg").set_texture(endless_bg)
		get_node("bg/mode_bg/story").set_text(tr("CS_ENDLESS"))
	else:
		get_node("bg").set_texture(story_bg)
		get_node("bg/mode_bg/story").set_text(tr("CS_STORY"))
		
		
	var idx=0
	for c in get_node("bg/levels").get_children():
		var pl = c.get_node("country_select/pin/progress/label")
		c.get_node("country_select/pin/progress").set_frame([0,1][int(get_node("/root/globals").endless_mode)])
		
		if (idx<=unlocked):
			if (get_node("/root/globals").endless_mode):
				pl.set_text(str(gstate.get_endless_highscore(idx)))
				c.get_node("country_select/pin/progress").show()
			else:
				var txt=str(gstate.get_world_stars(idx))
				pl.set_text(txt)
				c.get_node("country_select/pin/progress").hide()
		
		if (get_node("/root/globals").endless_mode):
			c.get_node("country_select/pin/teddy").hide()
		else:
			c.get_node("country_select/pin/teddy").show()
		
		idx+=1
		
func show_mexico():
	if(get_node("bg/levels/mexico").is_hidden()):
		get_node("bg/levels/mexico").show()

func _world_selected(idx):
	var levels = ["uk","india","japan","australia","mexico","usa"]
	if(get_node("bg/levels/" + levels[idx] + "/country_select/pin/play/scale/label").get_text() == tr("MM_UALL")):
		if(levels[idx] == "mexico"):
			if(!get_node("bg/levels/" + levels[idx]).is_hidden()):
				get_node("bg/levels/" + levels[idx]).hide()
		
		get_node("/root/unlock_popup").show_popup()
		return
	
	get_node("/root/globals").world_index=idx
	
	var level_str=get_node("/root/globals").get_checkpoint_str()
	get_node("/root/globals").distance_run=0
	if (get_node("/root/globals").endless_mode):
		get_node("/root/globals").level_index=-1 # minus one is endless... yeah

		get_node("/root/globals").change_scene("res://locations/level.scn")
		get_node("/root/globals").level_index=-1 # minus one is endless... yeah
		

	else:
		if (gstate.get_level_completed(idx)==0):
			get_node("/root/globals").level_index=0 # minus one is endless... yeah
			get_node("/root/globals").change_scene("res://locations/level.scn")
		else:
			get_node("/root/globals").change_scene("res://screens/level_map/level_select.scn")
		


func _process(delta):
	"""
	if (waiting_plane!=-1):
		if (gstate.get_seconds_left() <=0 ):
			#gstate.clear_plane()
			get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
			waiting_plane=-1
			set_process(false)
		else:
			var secsleft = int(gstate.get_seconds_left())
			var txt = str(secsleft/3600,":",(secsleft/60)%60,":",secsleft%60)
			get_node("bg/planetrips/timeleft/time").set_text(txt)
	"""	

func _ready():

	gstate=get_node("/root/gamestate")
	
	get_node("bg/mode").set_pressed( get_node("/root/globals").endless_mode )
	
	enabled = int(gstate.get_app_parameter("worlds_enabled",6))
	
	if(gstate.p_info.data["game_complete"] && gstate.is_in_plane()):
		gstate.clear_plane()
	
	var idx=0
	var selected=-1
	
	get_node("/root/unlock_popup").connect("closed_popup",self,"show_mexico")
	
	var all_unlocked=true
	var teddy_ach = [			  "teddy_england",
						  "teddy_india",
						  "teddy_japan",
						  "teddy_australia",
						  "teddy_mexico",
						  "teddy_usa"
						]
	
	for c in get_node("bg/levels").get_children():
		c.get_node("country_select").hide()
		if (c.has_node("coming_soon")):
			var cs = c.get_node("coming_soon")
			if (idx >= enabled):
				cs.show()
			else:
				cs.hide()
			
		if (gstate.is_world_unlocked(idx)):
			unlocked = min(enabled,max(unlocked,idx+1))
			
		if (idx>=unlocked):
			#c.set_opacity(0.3) diff PAY-WALL
			
			c.get_node("country_select/pin/play/scale/label").set_text(tr("MM_UALL"))
			
			var path = c.get_node("country_select/pin").get_texture().get_path().replace(".png","_unlock.png")
			var texture = load(path)
			c.get_node("country_select/pin").set_texture(texture)
			
			path = c.get_node("country_select/pin/play").get_normal_texture().get_path().replace("play_btn.png","unlock_all_world_btn.png")
			texture = load(path)
			c.get_node("country_select/pin/play").set_normal_texture(texture)
			
			path = c.get_node("country_select/pin/play").get_pressed_texture().get_path().replace("play_btn_out.png","unlock_all_world_btn_out.png")
			texture = load(path)
			c.get_node("country_select/pin/play").set_pressed_texture(texture)
			
			c.get_node("button").connect("pressed",self,"_on_button_pressed",[idx]) 
			
			c.get_node("country_select/pin/play/scale").set_scale(Vector2(0.8,0.8))
			c.get_node("country_select/pin/play/scale/label").set_pos(Vector2(-21,-21))
			
			#########
			##c.get_node("button").hide() PAY WALL DIFF !!
			all_unlocked=false
		else:
			c.get_node("button").connect("pressed",self,"_on_button_pressed",[idx])
		
#		elif (gstate.get_level_unlocked(idx)==0):			
#			pass
		c.get_node("country_select/pin/play").connect("pressed",self,"_world_selected",[idx])	
		if (get_node("/root/gamestate").get_achievement(teddy_ach[idx])):
			c.get_node("country_select/pin/teddy").set_frame(1)
		else:
			c.get_node("country_select/pin/teddy").set_frame(0)

		idx+=1
		
#		var world = get_node("/root/globals/").world_index
	if (unlocked==enabled and enabled!=gstate.get_max_worlds()):
		get_node("all_completed/anim").play("show")
		
	current=unlocked-1
	get_node("bg/levels").get_child(current).get_node("anim").play("select")
	get_node("bg/levels").get_child(current).get_node("anim").queue("idle")
	# Initalization here
	get_node("bg/flagbase/flaga").set_frame(current)
	get_node("bg/flagbase/flagb").set_frame(current)
	
	get_node("bg/flagbase/flaga/label").set_text(country_names[current])
	get_node("bg/flagbase/flagb/label").set_text(country_names[current])
	
	if (all_unlocked):
		gstate.set_achievement_unlocked("random_travel")

	var waiting_plane = gstate.get_plane()
	print("WAITING PLANE: ",waiting_plane)	
	#if (unlocked<enabled and gstate.is_world_completed(unlocked-1) and not gstate.is_world_unlocked(unlocked)):
		#unlock_bean_cost = gstate.get_flight_timer_cost(waiting_plane)
	if (waiting_plane!=-1):
		get_node("bg/planetrips/anim").play(str(waiting_plane))
		
		## DIFF PAY WALL
		#get_node("bg/planetrips/timeleft/stars").set_text( str(gstate.get_world_stars(waiting_plane-1)," / ",gstate.get_world_passing_stars(waiting_plane-1)) )
		#get_node("bg/planetrips/timeleft/time").set_text(str(unlock_bean_cost))

		set_process(true)
	#else:
	_claim_red_gift()
	
	if (unlocked==1):
		get_node("bg/prev").hide()
		get_node("bg/next").hide()
	_update_texts()
	
	#_claim_red_gift()
	
	if (gstate.get_beans()>Config.ACHIEVEMENT_BAG_OF_BEANS):
		get_node("/root/gamestate").set_achievement_unlocked("golden_bean_bags")			
	
	var bean_notify = gstate.get_app_parameter("beans_over_x",Config.BEANS_OVER_X)
	
	if (gstate.get_beans() > bean_notify):
		gstate.subscribe("Currency Balance")	
	_update_arrows()

	if (gstate.p_info.data["game_complete"] and gstate.p_info.data["what_next"]):
		get_node("endgame").show()
		gstate.p_info.data["what_next"]=false
		
		if(gstate.parse):
			gstate.save_cloud()
		else:
			gstate.save_pc()	

func show_flag_padlock(current,prev,next):
	if(next):
		if(!gstate.is_world_unlocked(current)):
			if((current-1)>=0):
				if(!gstate.is_world_unlocked(current-1)):
					prev=true
			
			if(get_node("bg/flagbase/flaga/padlock").is_hidden()):
				get_node("bg/flagbase/flaga/padlock").show()
		else:
			if(!get_node("bg/flagbase/flaga/padlock").is_hidden()):
				get_node("bg/flagbase/flaga/padlock").hide()

	if(prev):
		if(!gstate.is_world_unlocked(current)):
			if(get_node("bg/flagbase/flagb/padlock").is_hidden()):
				get_node("bg/flagbase/flagb/padlock").show()
		else:
			if(!get_node("bg/flagbase/flagb/padlock").is_hidden()):
				get_node("bg/flagbase/flagb/padlock").hide()

func _on_prev_pressed():
	get_node("bg/levels").get_child(current).get_node("anim").play("hide")
	get_node("bg/flagbase/flaga").set_frame(current)
	get_node("bg/flagbase/flaga/label").set_text(country_names[current])	
	current=current-1
	
	if(current==gstate.get_plane()):
		current=gstate.get_plane()-1
	
	if (current<0):
		#current=unlocked-1
		current=int(gstate.get_app_parameter("worlds_enabled",6)) - 1
		
	show_flag_padlock(current,true,false)
	get_node("bg/levels").get_child(current).get_node("anim").play("select")
	get_node("bg/flagbase/flagb").set_frame(current)
	get_node("bg/flagbase/anim").play("retreat")
	get_node("bg/levels").get_child(current).get_node("anim").queue("idle")
	get_node("bg/flagbase/flagb/label").set_text(country_names[current])
	_update_arrows()
	
	
	pass # replace with function body

func _update_arrows():
	if (current==0):
		get_node("bg/prev").hide()
	else:
		get_node("bg/prev").show()
		
	#if (current+1==unlocked):	
	if (current+1>(int(gstate.get_app_parameter("worlds_enabled",6)) - 1)):		
		get_node("bg/next").hide()
	else:
		get_node("bg/next").show()

func _on_button_pressed(idx):
	if(gstate.is_in_plane() && gstate.get_plane() == idx):
		return
	
	get_node("bg/levels").get_child(current).get_node("anim").play("hide")
	get_node("bg/flagbase/flagb").set_frame(current)
	get_node("bg/flagbase/flagb/label").set_text(country_names[current])
	current=idx
	show_flag_padlock(current,true,true)
	get_node("bg/levels").get_child(current).get_node("anim").play("select")
	get_node("bg/flagbase/flaga").set_frame(current)
	get_node("bg/flagbase/anim").play("advance")
	get_node("bg/levels").get_child(current).get_node("anim").queue("idle")
	get_node("bg/flagbase/flaga/label").set_text(country_names[current])
	
	_update_arrows()
	
		

func _on_next_pressed():
	get_node("bg/levels").get_child(current).get_node("anim").play("hide")
	get_node("bg/flagbase/flagb").set_frame(current)
	get_node("bg/flagbase/flagb/label").set_text(country_names[current])
	
	current=current+1
	
	if(current == gstate.get_plane()):
		current=gstate.get_plane()+1
	
	#if (current==unlocked):
	if (current>(int(gstate.get_app_parameter("worlds_enabled",6)) - 1)):
		current=0
		
	show_flag_padlock(current,false,true)
	get_node("bg/levels").get_child(current).get_node("anim").play("select")
	get_node("bg/flagbase/flaga").set_frame(current)
	get_node("bg/flagbase/anim").play("advance")
	get_node("bg/levels").get_child(current).get_node("anim").queue("idle")
	get_node("bg/flagbase/flaga/label").set_text(country_names[current])
	_update_arrows()


func _on_mode_toggled( pressed ):
	if(!gstate.isLoggedin && gstate.parse):
		gstate.login_dialog(false)
	
	
	get_node("/root/globals").endless_mode=pressed
	_update_texts()
	pass # replace with function body


func _on_TextureButton_pressed():
	get_node("/root/globals").change_scene("res://screens/main_menu/main_menu.scn")
	pass # replace with function body


func _on_timeleft_pressed():

	if(gstate.get_plane() - 1 >= 0):
		get_node("/root/globals").world_index=gstate.get_plane() - 1
		
	get_node("/root/globals").change_scene("res://locations/airport/planeflying.scn")
	


	"""
	if (gstate.get_beans() < unlock_bean_cost):
		get_node("no_beans").show()
	else:
		if (gstate.get_seconds_left() >0 ):
			gstate.reset_plane()
			_enable_new_country()
			get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
			waiting_plane=-1
			set_process(false)
			gstate.set_beans( gstate.get_beans() - unlock_bean_cost )
	"""	
	pass # replace with function body


func _on_Button_pressed():
	for j in range(6):
		var levelcount=gstate.get_max_level(j)+1
		gstate.set_world_unlocked(j,true)
		for i in range(levelcount):
			
			gstate.set_level_unlocked(j,i,true)
			gstate.set_level_completed(j,i)
			
	get_node("/root/globals").change_scene("res://screens/world_map2/world_map.scn")
	pass # replace with function body


func _on_flag_button_pressed():
	_world_selected(current)
	pass # replace with function body


func _on_unhide_pressed():
	get_node("hidethis").show()
	pass # replace with function body


func _on_close_pressed():
	get_node("endgame").hide()
	pass # replace with function body


func _on_shop_btn_pressed():
	if(get_node("shop").is_hidden()):
		get_node("shop").show()
		get_node("bg/levels/mexico").set_z(-1)
	pass # replace with function body


func _on_leaderboard_btn_pressed():
	if(get_node("leaderboard").is_hidden()):
		get_node("leaderboard").show()
	get_node("leaderboard").set_frame_and_get_leaderboard(0)
	pass # replace with function body


func _on_achievements_btn_pressed():
	if(get_node("achievements").is_hidden()):
		get_node("achievements").show()
	pass # replace with function body
