
extends Node2D

# member variables here, example:
# var a=2
# var b="textvar"

var Config = preload("res://global/config.gd")


var FAR_DISTANCE=Config.WICKET_FAR_DISTANCE
var NEAR_DISTANCE=Config.WICKET_NEAR_DISTANCE
var KILL_DISTANCE=Config.WICKET_KILL_DISTANCE
var WALK_SPEED=Config.WICKET_WALK_SPEED
var APPROACH_SCALE=Config.WICKET_APPROACH_SCALE
var UNAPPROACH_SPEED=Config.WICKET_UNAPPROACH_SPEED
var COOLDOWN_TIME=Config.WICKET_COOLDOWN_TIME
var DISTANCE_DIVIDER=Config.WICKET_DISTANCE_DIVIDER
var CAT_INTERVAL=Config.WICKET_THROW_CAT_INTERVAL

var force_go_back_fast=false

var time_to_cat=0

var cooldown=0
var gaveup=false
var distance=FAR_DISTANCE
var hitting=false
var victim=null
	
var bean = null
var mob = null
var wicket_visible=false

var cat = preload("res://wicket/cat.scn")
var waiting_kill=false

var unable_to_catch=false

func hit_done():
	hitting=false
	pass


func calmdown():
	cooldown=COOLDOWN_TIME

func smack():
	if (waiting_kill):
		if (not bean.wicket_hit(false)):
			get_node("anim").play("run")
			cooldown=COOLDOWN_TIME
			hitting=false
			waiting_kill=false
			return	
	elif (victim):
		mob.smack_victim(victim.get_name())
		victim=null
		cooldown=COOLDOWN_TIME



func _process(delta):

	if (gaveup):
		return

	if (delta>0.5):
		delta=0.5

	var speed = (bean.target_speed-bean.speed/bean.speed_mult)*APPROACH_SCALE

	if (force_go_back_fast or speed==0 or cooldown>0):		
		speed=-UNAPPROACH_SPEED
		if (force_go_back_fast):
			speed*=12.0

		if (cooldown>0):
			cooldown-=delta
	
	var advance = speed*delta
	
	if (distance>KILL_DISTANCE):
		distance=KILL_DISTANCE
	if (distance<FAR_DISTANCE):
		distance=FAR_DISTANCE
		force_go_back_fast=false
		#begin doom	

	if (not waiting_kill):
		distance+=advance
					
	if (not hitting and cooldown<=0.0):
	
		if (not unable_to_catch and distance>=KILL_DISTANCE):
			#smack bean
			if (not waiting_kill):
				if (abs(get_global_pos().y-bean.get_global_pos().y)>200):
					if (not bean.wicket_hit(true)):
						get_node("anim").play("jump")
						get_node("anim").queue("run")
						cooldown=COOLDOWN_TIME
						return
					get_node("anim").play("jump2")
					get_node("anim").queue("angry3")
				else:				
					get_node("anim").play("hit")
					get_node("anim").queue("angry2")
				hitting=true
				get_node("wicket_hit").start()
				waiting_kill=true

		elif (advance>0):
			victim = mob.get_victim_to_smack(-distance+KILL_DISTANCE,20)
			if (victim):
				#smack victim
				get_node("anim").play("hit")
				get_node("anim").queue("run")
				hitting=true


	var pos = get_pos()
	pos.x = bean.get_pos().x
	pos.x += distance
	set_pos(pos)
#	if (not wicket_visible):	
#		var hud = get_tree().get_nodes_in_group("hud")
#		if (hud.size()):
#			hud[0].set_wicket_distance( floor((distance/DISTANCE_DIVIDER)*10)/10.0)
	
	time_to_cat-=delta
	if (false and time_to_cat<0):
		time_to_cat=CAT_INTERVAL
		var c= cat.instance()
		c.set_pos(get_pos())
		c.wicket=self
		get_parent().add_child(c)
		
	
	var hud = get_tree().get_nodes_in_group("hud")[0]
	if (get_node("on_screen_visible").is_on_screen()):
		hud.wicket_on_screen()	
	if (get_node("on_floor_visible").is_on_screen()):
		hud.wicket_on_floor()	
	hud.set_wicket_distance( distance )
			

func _bean_continued():
	print("wicket continue")
	
	if get_node("/root/globals").global_powerups["bowler"]:
		var percent = float(get_node("/root/gamestate").get_app_parameter("powerup_bowler", Config.POWERUP_BOWLER)) / 100 + 1
		distance=FAR_DISTANCE * percent
	else:
		distance=FAR_DISTANCE
		
	get_node("anim").play("run")


func _ready():
	add_to_group("wicket")
	# Initalization here
	var gstate = get_node("/root/gamestate")
	bean = get_node("../bean")
	bean.connect("continued",self,"_bean_continued")
	mob = get_node("../mob")
	get_node("anim").play("run")
	
	var level_prefix=""
	if (get_node("/root/globals").world_index!=-1):
		level_prefix+="_"+str(get_node("/root/globals").world_index+1)
	
	APPROACH_SCALE = int(gstate.get_app_parameter("wickett_approach_scale"+level_prefix,APPROACH_SCALE))
	FAR_DISTANCE = int(gstate.get_app_parameter("wickett_max_distance"+level_prefix,FAR_DISTANCE))
	
	if get_node("/root/globals").global_powerups["bowler"]:
		var percent = float(gstate.get_app_parameter("powerup_bowler", Config.POWERUP_BOWLER)) / 100 + 1
		FAR_DISTANCE *= percent
	
	
	set_process(true)
	
	pass


func giveup():
	if (gaveup):
		return
	gaveup=true
	get_node("anim").play("angry")
	get_node("sound_fx").play("Angry_Wicket")


func _on_VisibilityNotifier2D_enter_screen():
	print("enter" )
	var hud = get_tree().get_nodes_in_group("hud")
	if (hud.size()):
		hud[0].set_wicket_visible(true)
	wicket_visible=true
	pass # replace with function body


func _on_VisibilityNotifier2D_exit_screen():

	pass # replace with function body


func _on_VisibilityNotifier2D_2_enter_screen():
	pass # replace with function body


func _on_VisibilityNotifier2D_2_exit_screen():
	print("exit" )
	var hud = get_tree().get_nodes_in_group("hud")
	if (hud.size()):
		hud[0].set_wicket_visible(false)
	wicket_visible=false
	pass # replace with function body

func go_back_fast():
	force_go_back_fast=true

func make_unable_to_catch():
	unable_to_catch=true

func _on_wicket_hit_timeout():
	
	if (not waiting_kill):
		return
	#bean.gameover()
	get_parent().game_over()
	waiting_kill=false
	hitting=false
	pass # replace with function body
